<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldAtributosproducto extends FormField
{
	/**
	 * The articulo field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'atributosproducto';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="form-control '.(string) $this->element['class'].'"' : ' class="form-control"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		e_include('ext_shop/class/productoAtributo');
		
		if ($_GET['extension'] != 'ext_shop' || $_GET['vista'] != 'editar' || empty($_GET['id']) || !class_exists('ProductoAtributo')){
			return false;
		}
		
		$class_item = 'ProductoAtributo';
		$output = '';
		
		$output .= $this->getTablaCampos($valor, $attr, $class_item);
		
		return $output;
	}
	
	function getTablaCampos($valor, $attr, $clase_item){
		if (empty($clase_item))
			return '';
			
		$item = new $clase_item();
		
		$rand = rand();
		
		$cm_txt = '';
		if (!empty($_GET['custom_menu']))
			$cm_txt = '&custom_menu='.$_GET['custom_menu'];
		
		$html = '';
		
		if (!empty($item)){
			$atributos = $item->Listar("", "titulo", "ASC");
			
			$html .= '<div id="content_atr_pr" class="relative">';
			
			if (is_array($atributos) && sizeof($atributos) > 0){
				
				$html .= '<table class="table table-striped" id="atributos_list_'.$this->id.'">';
				$html .= '<thead><tr>';
				$html .= '<th></th>';
				$html .= '</tr></thead>';
				
				$html .= '<tbody>';
				
				foreach ($atributos as $atributo){
					$html .= '<tr>';
					$html .= '<td class="nowrap has-context">
					'.$atributo->renderSelect($valor[$atributo->id], '', true, $this->name).'</td>';
                    $html .= '</tr>';                    
				}
				
				$html .= '</tbody></table>';
			} else {
				$html .= '<p align="center">'.__('No hay campos extra en este item').'</p>';
			}
					
			$html .= '</div>';
			
			
		}
		
		return $html;
	}
	
	
}
