<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldDatosenvio extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'datosenvio';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="btn '.(string) $this->element['class'].'"' : ' class="btn btn-default"';
		
		$is_modal = $this->element['modal'] == 'false' ? false : true;
		
		$output = '';
		
		if ($is_modal){
			$valor_field = $valor['envio_nombre'];
			
			if (!empty($valor['envio_apellidos']))
				$valor_field .= ' '.$valor['envio_apellidos'];
			
			$output .= '<div class="input-group"><input type="text" readonly class="form-control" value="'.$valor_field.'" />';
			
			$output .= '<span class="input-group-btn"><a href="javascript:;"'.$attr.' data-toggle="modal" data-target="#mdl_'.$this->id.'" title="'.__('Datos de envío').'"><i class="fa fa-edit"></i></a></span></div>';
		}
		$output .= $this->getTablaDatos($valor, $is_modal);
		return $output;
	}
	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getTablaDatos($valor=null, $is_modal=true){
		e_include('ext_forms/class/formulario');
		
		$cfg_shop = $GLOBALS['opciones']['ext_shop'];
		
		if (empty($cfg_shop['clientes']['formulario_envio']) || empty($cfg_shop['clientes']['formulario_envio']))
			return false;
			
		$formulario_envio = new Formulario();
		$formulario_envio->setid($cfg_shop['clientes']['formulario_envio']);
		if ($formulario_envio = $formulario_envio->BuscarId()){
		} else {
			return false;
		}
		
		$campos_envio = $formulario_envio->getCampos();
		
		if (is_array($campos_envio) && sizeof($campos_envio) > 0){
			foreach ($campos_envio as $kcf1=>$cf1){
				$campos_envio[$kcf1]->nombre_original = $cf1->nombre;
				$campos_envio[$kcf1]->nombre = $this->name.'['.$cf1->nombre.']';
			}
		}
		
		if ($is_modal){
		
        $html = '<div class="modal fade" id="mdl_'.$this->id.'">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">'.__('Cerrar').'</span></button>
        <h4 class="modal-title">'.__('Datos de facturación').'</h4>
      </div>
      <div class="modal-body">
	  	<div class="row">';
		foreach ($campos_envio as $c_f){
			$alias_var = Helpers::parseaTexto($c_f->nombre_original, false, '_');
			
			$html .= '<div class="col-md-6 form-group"> '.$c_f->renderCampo($valor[$alias_var], '<label class="control-label" for="##ID##">##LABEL##</label>', '##INPUT##').' </div>';
		}
		
        $html .= '</div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">'.__('Cerrar').'</button>
      </div>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->';
		} else {
			$html = '<div class="row" id="div_'.$this->id.'">';
			
			foreach ($campos_envio as $c_f){
				$alias_var = Helpers::parseaTexto($c_f->nombre_original, false, '_');
				
				$html .= '<div class="col-md-6 form-group"> '.$c_f->renderCampo($valor[$alias_var], '<label class="control-label" for="##ID##">##LABEL##</label>', '##INPUT##').' </div>';
			}
			
			$html .= '</div>';
		}
		return $html;
	}
}
