<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldDatosfacturacion extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'datosfacturacion';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="btn '.(string) $this->element['class'].'"' : ' class="btn btn-default"';
		
		$is_modal = $this->element['modal'] == 'false' ? false : true;
		
		$select_customer = $this->element['select_customer'] == 'false' ? false : true;
				
		$output = '';
		
		if ($is_modal){
			$valor_field = $valor['nombre'];
			
			if (!empty($valor['apellidos']))
				$valor_field .= ' '.$valor['apellidos'];
				
			if (!empty($valor['nif']))
				$valor_field .= ' (NIF: '.$valor['nif'].')';
			
			$output .= '<div class="input-group"><input id="'.$this->id.'_valor_field" type="text" readonly class="form-control" value="'.$valor_field.'" />';
			
			$output .= '<span class="input-group-btn"><a href="javascript:;"'.$attr.' data-toggle="modal" data-target="#mdl_'.$this->id.'" title="'.__('Datos de facturación').'"><i class="fa fa-edit"></i></a></span></div>';
		}
		$output .= $this->getTablaDatos($valor, $is_modal, $select_customer);
		return $output;
	}
	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getTablaDatos($valor=null, $is_modal=true, $select_customer=false){
		e_include('ext_forms/class/formulario','ext_shop/class/cliente');
		
		$cfg_shop = $GLOBALS['opciones']['ext_shop'];
		
		if (empty($cfg_shop['clientes']['formulario_facturacion']) || empty($cfg_shop['clientes']['formulario_facturacion']))
			return false;
			
		$formulario_facturacion = new Formulario();
		$formulario_facturacion->setid($cfg_shop['clientes']['formulario_facturacion']);
		if ($formulario_facturacion = $formulario_facturacion->BuscarId()){
		} else {
			return false;
		}
		
		$campos_facturacion = $formulario_facturacion->getCampos();
		
		if (is_array($campos_facturacion) && sizeof($campos_facturacion) > 0){
			foreach ($campos_facturacion as $kcf1=>$cf1){
				$campos_facturacion[$kcf1]->nombre_original = $cf1->nombre;
				$campos_facturacion[$kcf1]->nombre = $this->name.'['.$cf1->nombre.']';
			}
		}
		
		if ($is_modal){
		
        $html = '<div class="modal fade" id="mdl_'.$this->id.'">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">'.__('Cerrar').'</span></button>
        <h4 class="modal-title">'.__('Datos de facturación').'</h4>
      </div>
      <div class="modal-body">
	  	<div class="row">';
		
		if ($select_customer == true){
			$clientes = new ClienteShop();
			$clientes = $clientes->Listar();
			
			$html .= '<div class="col-md-12 form-group"><label>'.__('Cliente').'</label>';
			
			$html .= '<select class="select2" name="'.$this->name.'[cliente_id]" id="'.$this->id.'_cliente_id">';
			
			$html .= '<option value="">'.__('Ningún cliente seleccionado').'</option>';
			
			if (is_array($clientes) && sizeof($clientes) > 0){
				foreach ($clientes as $cl){
					$selected = '';
					if ($valor['cliente_id'] == $cl->id)
						$selected = ' selected="selected"';
					
					$valor_field = $cl->facturacion->nombre;
			
					if (!empty($cl->facturacion->apellidos))
						$valor_field .= ' '.$cl->facturacion->apellidos;
						
					if (!empty($cl->facturacion->nif))
						$valor_field .= ' (NIF: '.$cl->facturacion->nif.')';
						
					$html .= '<option'.$selected.' value="'.$cl->id.'">'.$valor_field.'</option>';
				}
			}
			$html .= '</select>';
			$html .= '</div>';
			
			$GLOBALS['AppDoc']->AddScriptDeclaration('
			$(document).ready(function(){
				$("select#'.$this->id.'_cliente_id").on("change", function(){
					var id_cust = $(this).val();
					
					if (id_cust != undefined && id_cust != ""){
						$.post(Mideas.config.base_url + "api/shop/cliente/cargarDatos.json", { id: id_cust }, function (data){
							if (data.response == "ok"){
								var valor_field = data.data.facturacion.nombre;
								
								if (data.data.facturacion.apellidos != undefined && data.data.facturacion.apellidos != ""){
									valor_field = valor_field + " " + data.data.facturacion.apellidos;
								}
								
								if (data.data.facturacion.nif != undefined && data.data.facturacion.nif != ""){
									valor_field = valor_field + " (NIF: " + data.data.facturacion.nif + ")";
								}
								
								$("#'.$this->id.'_valor_field").val(valor_field);
								
								$("[data-campo-'.$this->id.']").each(function(idx, ele){
									var campo_alias = $(ele).data("campo-'.$this->id.'");
									var valor_campo = data.data.facturacion[campo_alias];
									
									if (valor_campo != undefined && valor_campo != null){
										$(ele).find("input, select").val(valor_campo);
									}
								});
								Utilidades.Notificar("'.__('Datos de cliente cargados').'");
							} else {
								bootbox.alert(data.response_text);
							}
						});
					}
				});
			});');
		}
		foreach ($campos_facturacion as $c_f){
			$alias_var = Helpers::parseaTexto($c_f->nombre_original, false, '_');
			
			$html .= '<div class="col-md-6 form-group" data-campo-'.$this->id.'="'.$alias_var.'"> '.$c_f->renderCampo($valor[$alias_var], '<label class="control-label" for="##ID##">##LABEL##</label>', '##INPUT##').' </div>';
		}
		
        $html .= '</div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">'.__('Cerrar').'</button>
      </div>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->';
		} else {
			$html = '<div class="row" id="div_'.$this->id.'">';
			
			foreach ($campos_facturacion as $c_f){
				$alias_var = Helpers::parseaTexto($c_f->nombre_original, false, '_');
				
				$html .= '<div class="col-md-6 form-group"> '.$c_f->renderCampo($valor[$alias_var], '<label class="control-label" for="##ID##">##LABEL##</label>', '##INPUT##').' </div>';
			}
			
			$html .= '</div>';
		}
		return $html;
	}
}
