<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldListaatributosproducto extends FormField
{
	/**
	 * The articulo field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'listaatributosproducto';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="form-control '.(string) $this->element['class'].'"' : ' class="form-control"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		if ($_GET['extension'] != 'ext_shop' || $_GET['vista'] != 'editar' || empty($_GET['id']) || !class_exists('Producto')){
			return false;
		}
		
		$pr = new Producto();
		$pr->setid($_GET['id']);
		
		if ($pr = $pr->BuscarId()){
		} else {
			return false;
		}
		
		$output = '';
		
		$output .= $this->getTablaCampos($valor, $attr, $pr);
		
		return $output;
	}
	
	function getTablaCampos($valor, $attr, $item){
		if (empty($item))
			return '';
			
		$rand = rand();
		
		$cm_txt = '';
		if (!empty($_GET['custom_menu']))
			$cm_txt = '&custom_menu='.$_GET['custom_menu'];
		
		$html = '';
		
		if (!empty($item)){
			$atributos_producto = $item->getAtributos();
			
			$html .= '<div class="clearfix pull-right"><a class="btn btn-small btn-primary iframe-config nuevo-atributo-'.strtolower(get_class($item)).'" href="?extension='.$_GET["extension"].'&amp;vista=nuevo_atributo_producto&id_item='.$item->id.$cm_txt.'&popup=1" ><i class="fa fa-plus fa fa-white"> </i> '.__('Añadir atributo').'</a></div>
			<div id="content_atr" class="relative">';
			
			if (is_array($atributos_producto) && sizeof($atributos_producto) > 0){
			
				
				$html .= '<table class="table table-striped" id="atributos_list_'.$this->id.'">';
				$html .= '<thead><tr>';
				$html .= '<th></th>';
				$html .= '</tr></thead>';
				
				$html .= '<tbody>';
				
				foreach ($atributos_producto as $atributo){
					$html .= '<tr id="listItem_'.$atributo->id.'">';
					$html .= '<td class="nowrap has-context">
					<div class="pull-right">
                      <div class="btn-group" style="margin-left: 6px; "> <a href="#" data-toggle="dropdown" class="dropdown-toggle btn btn-xs btn-default" title="'.__('Opciones avanzadas de campo extra').'"> <i class="fa fa-cog"></i> </a>
                        <ul class="dropdown-menu pull-right">
                          <li class=""><a class="iframe-config" href="?extension='.$_GET["extension"].'&amp;vista=editar_atributo_producto&amp;id='.$atributo->id.$cm_txt.'&popup=1">'.__('Editar').'</a></li>
                          <li class="divider"></li>
                          <li class=""><a href="javascript:;" class="borrar_item" data-title="'.$this->fieldname.'" data-id="'.$atributo->id.'" data-script-url="'.CONF_URL_APP_ADMIN.'?extension='.$_GET["extension"].'&vista=editar_atributo_producto'.$cm_txt.'&id='.$atributo->id.'" data-refresh-url="'.CONF_URL_APP_ADMIN.'?extension='.$_GET["extension"].'&vista='.$_GET["vista"].$cm_txt.'&id='.$_GET['id'].' #content_atr" data-contenedor-campos="#content_atr" data-token="'.Helpers::getFormToken().'">'.__('Borrar atributo').'</a></li>
                        </ul>
                      </div>
                    </div>
					<div class="clearfix"></div>
					
					</td>';
                    $html .= '</tr>';                    
				}
				
				$html .= '</tbody></table>';
				
				$last_url = Helpers::getSesion()->get('lastURL', null, 'admin');
								
				$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
				$(window).load(function(){
	var fixHelperModified = function(e, tr) {
    var $originals = tr.children();
    var $helper = tr.clone();
    $helper.children().each(function(index)
    {
      $(this).width($originals.eq(index).width())
    });
    return $helper;
};
$("table#atributos_list_'.$this->id.' tbody").sortable({
    helper: fixHelperModified,
	update : function () { 
		  var order = $(this).sortable("serialize");
		  $.post("'.$last_url.'", order, function(data){
			  if ($.trim(data) != "ok"){
			 	Notificar($.trim(data));
			  }
			  return false;
		  });		  
		} 
}).disableSelection();
});//]]>');
			} else {
				$html .= '<p align="center">'.__('No hay atributos de este producto').'</p>';
			}
			$html .= '</div>';
		}
		
		return $html;
	}
}
