<?php
c_include('forms/formField');
e_include('ext_shop/class/producto','ext_shop/class/facturaShop','ext_shop/class/facturaLineaShop','ext_shop/class/impuestoTarifa');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldListalineasfactura extends FormField
{
	/**
	 * The producto field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'listalineasfactura';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		if ($_GET['extension'] != 'ext_shop' && ($_GET['vista'] != 'editar_factura' || $_GET['vista'] != 'nueva_factura'))
			return false;
			
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$output = '';
		
		$output .= $this->getTablaLineas($valor, $attr);
		
		return $output;
	}
	
	function getTablaLineas($valor, $attr){
		$factura = new FacturaShop();
		if (!empty($_GET['id'])){			
			$factura->setid($_GET['id']);
			$factura = $factura->BuscarId();
		}
		
		$tarifas_impuestos = new ImpuestoTarifa(true);
		
		$tarifas_parseadas = $tarifas_impuestos->tarifas;
		
		$html_impuestos_select = '';
		
		if (is_array($tarifas_parseadas) && sizeof($tarifas_parseadas) > 0){
			Helpers::objectSort( $tarifas_parseadas, 'tarifa', 'DESC' );
			
			foreach ($tarifas_parseadas as $tar){
				$html_impuestos_select .= '<option value="'.$tar->tarifa.'">'.SistemaIdioma::Imprimir($tar->nombre).' ('.$tar->tarifa.'%)</option>';
			}
		}
		
		$html = '';
		
		if (!empty($factura)){
			if (!empty($_GET['id'])){
				$lineas_factura = $factura->loadLineas();
				$lineas_factura = $factura->lineas;
			}
			
			$html .= '<table class="table table-striped" id="tabla_linea_facturas">';
			$html .= '<thead><tr>';
			$html .= '<th>'.__('Borrar').'</th>';
			$html .= '<th>'.__('Descripción').'</th>';
			$html .= '<th>'.__('Cantidad').'</th>';
			$html .= '<th>'.__('Precio / ud.').'</th>';
			$html .= '<th>'.__('Impuesto').'</th>';
			$html .= '<th>'.__('Total').'</th>';
			$html .= '</tr></thead>';
			
			$html .= '<tbody>';
			if (!empty($lineas_factura)){
				foreach ($lineas_factura as $linea){
					$html .= '<tr class="linea_factura" id="linea_factura_'.$linea->id.'">
				<td width="5%" align="center"><a href="#" data-id="#linea_factura_'.$linea->id.'" class="confirm-delete-linea btn btn-default btn-sm"><i class="fa fa-trash-o"></i></a></td>
				<td width="35%"><input type="text" class="form-control" name="'.$this->name.'[lineas]['.$linea->id.'][descripcion]" value="'.$linea->nombre_producto.'" /><input type="hidden" name="'.$this->name.'[lineas]['.$linea->id.'][producto_id]" value="'.$linea->producto_id.'" /><input type="hidden" name="'.$this->name.'[lineas]['.$linea->id.'][id]" value="'.$linea->id.'" /></td>
				<td width="5%"><input type="text" class="form-control cant_linea" name="'.$this->name.'[lineas]['.$linea->id.'][cantidad]" value="'.$linea->cantidad.'" /></td>
				<td width="15%"><div class="input-group"><input type="text" class="form-control precio_ud_linea" name="'.$this->name.'[lineas]['.$linea->id.'][precio_ud]" value="'.($linea->linea_total / $linea->cantidad).'" /><span class="input-group-addon">&euro;</span></div></td>
				<td width="15%"><select class="select2 impuesto_linea" name="'.$this->name.'[lineas]['.$linea->id.'][impuesto]">';
				if (is_array($tarifas_parseadas) && sizeof($tarifas_parseadas) > 0){
					Helpers::objectSort( $tarifas_parseadas, 'tarifa', 'DESC' );
					
					$perc_imp = number_format(($linea->linea_impuesto / $linea->linea_total) * 100, 0, ".", "");
					$perc_imp = number_format($perc_imp, 2, ".", "");
					
					foreach ($tarifas_parseadas as $tar){
						$sel_txt = '';
						if ($tar->tarifa == $perc_imp)
							$sel_txt = ' selected="selected"';
							
						$html .= '<option'.$sel_txt.' value="'.$tar->tarifa.'">'.SistemaIdioma::Imprimir($tar->nombre).' ('.$tar->tarifa.'%)</option>';
					}
			
				}
				$html .= '</select></td>
				<td width="15%"><div class="input-group"><input readonly type="text" class="form-control total_linea" name="'.$this->name.'[lineas]['.$linea->id.'][total]" value="'.($linea->linea_total + $linea->linea_impuesto).'" /><span class="input-group-addon">&euro;</span></div></td>
				</tr>';                  
				}
				
				
			} else {
				$html .= '<tr class="linea_factura" id="linea_factura_0">
				<td width="5%" align="center"><a href="#" data-id="#linea_factura_0" class="confirm-delete-linea btn btn-default btn-sm"><i class="fa fa-trash-o"></i></a></td>
				<td width="35%"><input type="text" class="form-control" name="'.$this->name.'[lineas][0][descripcion]" /><input type="hidden" name="'.$this->name.'[lineas][0][producto_id]" /><input type="hidden" name="'.$this->name.'[lineas][0][id]" /></td>
				<td width="5%"><input type="text" class="form-control cant_linea" name="'.$this->name.'[lineas][0][cantidad]" /></td>
				<td width="15%"><div class="input-group"><input type="text" class="form-control precio_ud_linea" name="'.$this->name.'[lineas][0][precio_ud]" /><span class="input-group-addon">&euro;</span></div></td>
				<td width="15%"><select class="select2 impuesto_linea" name="'.$this->name.'[lineas][0][impuesto]">'.$html_impuestos_select.'</select></td>
				<td width="15%"><div class="input-group"><input readonly type="text" class="form-control total_linea" name="'.$this->name.'[lineas][0][total]" /><span class="input-group-addon">&euro;</span></div></td>
				</tr>';
			}
				
				$GLOBALS['AppDoc']->AddScriptDeclaration('
				$(window).load(function(){
					var fixHelperModified = function(e, tr) {
						var $originals = tr.children();
						var $helper = tr.clone();
						$helper.children().each(function(index)
						{
						  $(this).width($originals.eq(index).width())
						});
						return $helper;
					};
				
					$("table#tabla_linea_facturas tbody").sortable({
						helper: fixHelperModified,
						update : function () { 
							  Utilidades.Notificar("'.__('Guarda la factura para confirmar el nuevo orden de las líneas.').'");		  
							} 
					}).disableSelection();
				});
				
				$(document).ready(function(){
					calcular_totales_lineas();
					
					$(".cant_linea").live("input", function(){
						var tr_linea = $(this).parent().parent();
						
						var cantidad_linea = parseInt($(this).val());
						var precio_ud_linea = parseFloat(tr_linea.find("input.precio_ud_linea").val());
						var impuesto_linea = parseFloat(tr_linea.find("select.impuesto_linea").val());
						var total_linea_obj = tr_linea.find("input.total_linea");
						
						var total_linea = cantidad_linea * (precio_ud_linea + (precio_ud_linea * (impuesto_linea / 100) ) );
						
						if (!isNaN(total_linea)){
							total_linea_obj.val(total_linea.toFixed(2));
						} else {
							total_linea_obj.val(0.00);
						}
						
						calcular_totales_lineas();
					});
					
					$(".precio_ud_linea").live("input", function(){
						var tr_linea = $(this).parent().parent().parent();
						
						var precio_ud_linea = parseFloat(tr_linea.find("input.precio_ud_linea").val());
						var cantidad_linea = parseInt(tr_linea.find("input.cant_linea").val());
						var impuesto_linea = parseFloat(tr_linea.find("select.impuesto_linea").val());
						var total_linea_obj = tr_linea.find("input.total_linea");
						var total_linea = cantidad_linea * (precio_ud_linea + (precio_ud_linea * (impuesto_linea / 100) ) );
						
						if (!isNaN(total_linea)){
							total_linea_obj.val(total_linea.toFixed(2));
						} else {
							total_linea_obj.val(0.00);
						}
						
						calcular_totales_lineas();
						
					});
					
					$(".impuesto_linea").live("change", function(){
						var tr_linea = $(this).parent().parent();
						
						var precio_ud_linea = parseFloat(tr_linea.find("input.precio_ud_linea").val());
						var cantidad_linea = parseInt(tr_linea.find("input.cant_linea").val());
						var impuesto_linea = parseFloat(tr_linea.find("select.impuesto_linea").val());
						var total_linea_obj = tr_linea.find("input.total_linea");
						var total_linea = cantidad_linea * (precio_ud_linea + (precio_ud_linea * (impuesto_linea / 100) ) );
						
						if (!isNaN(total_linea)){
							total_linea_obj.val(total_linea.toFixed(2));
						} else {
							total_linea_obj.val(0.00);
						}
						
						calcular_totales_lineas();
						
					});
					
					$(".add-linea-factura").click(function(){
						var time_now = new Date().getTime();
						
						$("#tabla_linea_facturas tbody").append(\'<tr class="linea_factura" id="linea_factura_\'+time_now+\'"><td width="5%" align="center"><a href="#" data-id="#linea_factura_\'+time_now+\'" class="confirm-delete-linea btn btn-default btn-sm"><i class="fa fa-trash-o"></i></a></td><td width="35%"><input type="text" class="form-control" name="'.$this->name.'[lineas][\'+time_now+\'][descripcion]" /><input type="hidden" name="'.$this->name.'[lineas][\'+time_now+\'][producto_id]" /><input type="hidden" name="'.$this->name.'[\'+time_now+\'][id]" /></td><td width="5%"><input type="text" class="form-control cant_linea" name="'.$this->name.'[lineas][\'+time_now+\'][cantidad]" /></td><td width="15%"><div class="input-group"><input type="text" class="form-control precio_ud_linea" name="'.$this->name.'[lineas][\'+time_now+\'][precio_ud]" /><span class="input-group-addon">&euro;</span></div></td><td width="15%"><select class="select2 impuesto_linea" name="'.$this->name.'[lineas][\'+time_now+\'][impuesto]">'.$html_impuestos_select.'</select></td><td width="15%"><div class="input-group"><input readonly type="text" class="form-control total_linea" name="'.$this->name.'[lineas][\'+time_now+\'][total]" /><span class="input-group-addon">&euro;</span></div></td></tr>\');
						
						$("select.impuesto_linea").select2();
					});
					
					$(".percent_descuento_lineas_factura, .percent_retencion_lineas_factura, .percent_recargo_lineas_factura").live("input", function(){
						calcular_totales_lineas();
					});
				});
				
				function calcular_totales_lineas(){
					var subtotal_lineas = $(".subtotal_lineas_factura");
					var subtotal_impuesto_lineas = $(".subtotal_impuesto_lineas_factura");
					var total_lineas = $(".total_lineas_factura");
					
					var precent_descuento = $(".percent_descuento_lineas_factura");
					var subtotal_descuento_lineas = $(".subtotal_descuento_lineas_factura");
					
					var precent_recargo = $(".percent_recargo_lineas_factura");
					var subtotal_recargo_lineas = $(".subtotal_recargo_lineas_factura");
					
					var precent_retencion = $(".percent_retencion_lineas_factura");
					var subtotal_retencion_lineas = $(".subtotal_retencion_lineas_factura");
					
					var s = 0;
					var i = 0;
					var t = 0;
					var d = 0;
					var r = 0;
					var rr = 0;
					
					if ($(".linea_factura").length > 0){
						$(".linea_factura").each(function(idx, ele){
							var lin = $(ele);
							
							s += lin.find(".cant_linea").val() * lin.find(".precio_ud_linea").val();
							
							i += ( lin.find("select.impuesto_linea").val() / 100 ) * lin.find(".precio_ud_linea").val() * lin.find(".cant_linea").val();
							
							t += parseFloat(lin.find(".total_linea").val());
						});
						
						d = s * ( precent_descuento.val() / 100 );
						
						if (d > 0){
							var s = 0;
							var i = 0;
							var t = 0;
							var pd = ( precent_descuento.val() / 100 );
							$(".linea_factura").each(function(idx, ele){
								var lin = $(ele);
								
								var stl = lin.find(".precio_ud_linea").val() - lin.find(".precio_ud_linea").val() * pd;
								
								s += stl * lin.find(".cant_linea").val();
								
								i += ( lin.find("select.impuesto_linea").val() / 100 ) * stl * lin.find(".cant_linea").val();
								
								t += parseFloat(stl * lin.find(".cant_linea").val() + ( lin.find("select.impuesto_linea").val() / 100 ) * stl * lin.find(".cant_linea").val());
							});
						}
						
						r = s * ( precent_retencion.val() / 100 );
						
						rr = s * ( precent_recargo.val() / 100 );
						
						t = t - r + rr;
						
						subtotal_descuento_lineas.val(-d.toFixed(2));
						subtotal_retencion_lineas.val(-r.toFixed(2));
						subtotal_recargo_lineas.val(rr.toFixed(2));
						subtotal_lineas.val(s.toFixed(2));
						subtotal_impuesto_lineas.val(i.toFixed(2));
						total_lineas.val(t.toFixed(2));
					} else {
						subtotal_descuento_lineas.val(0);
						subtotal_retencion_lineas.val(0);
						subtotal_recargo_lineas.val(0);
						subtotal_lineas.val(0);
						subtotal_impuesto_lineas.val(0);
						total_lineas.val(0);
					}
				}');
			
			$html .= '</tbody></table>';
			
			$html .= '<div class="clearfix pull-left"><a class="btn btn-sm btn-primary add-linea-factura" href="javascript:;" ><i class="fa fa-plus icon-white"> </i> '.__('Añadir línea').'</a></div>';
			$html .= '
			<table class="table">
			<thead>
				<tr>
					<th>'.__('Subtotal').'</th>
					<th width="15%">'.__('Retención').'</th>
					<th width="15%">'.__('Impuestos').'</th>
					<th width="15%">'.__('Recargo').'</th>
					<th width="15%">'.__('Descuento').'</th>
					<th width="20%">'.__('Total').'</th>
				</tr>
			</thead>
			<tbody>
			<tr id="totales_lineas_factura">
				<td><div class="input-group"><input type="text" readonly class="form-control subtotal_lineas_factura" name="'.$this->name.'[base_imponible]"><span class="input-group-addon">€</span></div></td>
				
				
				<td><div class="row">
				<div class="col-sm-12">
				<div class="input-group"><input type="text" class="form-control percent_retencion_lineas_factura" name="'.$this->name.'[percent_retencion]" value="'. $factura->percent_retencion .'"><span class="input-group-addon">%</span></div>
				</div>
				<div class="col-sm-12">
				<div class="input-group"><input type="text" readonly class="form-control subtotal_retencion_lineas_factura" name="'.$this->name.'[total_retencion]" value="'. -$factura->total_retencion .'"><span class="input-group-addon">€</span></div>
				</div>
				</div></td>
				<td><div class="input-group"><input type="text" readonly class="form-control subtotal_impuesto_lineas_factura" name="'.$this->name.'[total_impuesto]"><span class="input-group-addon">€</span></div></td>
				<td>
				<div class="row">
				<div class="col-sm-12">
				<div class="input-group"><input type="text" class="form-control percent_recargo_lineas_factura" name="'.$this->name.'[percent_recargo]" value="'. $factura->percent_recargo .'"><span class="input-group-addon">%</span></div>
				</div>
				<div class="col-sm-12">
				<div class="input-group"><input type="text" readonly class="form-control subtotal_recargo_lineas_factura" name="'.$this->name.'[total_recargo]" value="'. number_format($factura->total_recargo, 2, '.', '') .'"><span class="input-group-addon">€</span></div>
				</div>
				</div>
				</td>
				<td>
				<div class="row">
				<div class="col-sm-12">
				<div class="input-group"><input type="text" class="form-control percent_descuento_lineas_factura" name="'.$this->name.'[percent_descuento]" value="'. $factura->percent_descuento .'"><span class="input-group-addon">%</span></div>
				</div>
				<div class="col-sm-12">
				<div class="input-group"><input type="text" readonly class="form-control subtotal_descuento_lineas_factura" name="'.$this->name.'[total_descuento]" value="'. -$factura->total_descuento .'"><span class="input-group-addon">€</span></div>
				</div>
				</div>
				</td>
				<td><div class="input-group"><input type="text" readonly class="form-control total_lineas_factura input-lg" name="'.$this->name.'[total]"><span class="input-group-addon">€</span></div></td>
				</tr>
				</tbody>
				</table>';
								
				$html .= '<div id="modal-delete-linea" class="modal fade">
				<div class="modal-dialog">
				<div class="modal-content">
              <div class="modal-header">
                <button onclick="$(\'#modal-delete-linea\').modal(\'hide\');return false;" class="close">&times;</button>
                <h3>'.__('Borrar Línea de Factura').'</h3>
              </div>
              <div class="modal-body">
                <p>'.__('Va a eliminar permanentemente una línea de la factura. Este proceso es irreversible.').'</p>
                <p>'.__('¿Quiere continuar con la eliminación de la línea?').'</p>
              </div>
              <div class="modal-footer"> <a href="javascript:;" class="btn btn-danger" id="del-linea-btn">'.__('Sí').'</a> <a href="javascript:$(\'#modal-delete-linea\').modal(\'hide\')" class="btn secondary">'.__("No").'</a> </div>
            </div>
			</div>
			</div>';
				
				$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
$(window).load(function(){
$("#del-linea-btn").live("click", function() {
	var this_el = $(this);
	
	var id = $("#modal-delete-linea").data("id");
			
	$(id).remove();
	
	calcular_totales_lineas();
	
	$("#modal-delete-linea").modal("hide");
});
$(".confirm-delete-linea").live("click", function(e) {
    e.preventDefault();
    
    var id = $(this).data("id");
    $("#modal-delete-linea").data("id", id).modal("show");
});
});//]]>');
			
			
		}
		
		return $html;
	}
	
	
}
