<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldOpcionesenvio extends FormField
{
	/**
	 * The articulo field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'opcionesenvio';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="form-control '.(string) $this->element['class'].'"' : ' class="form-control"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$output = '';
		
		if ($_GET['extension'] == 'ext_shop' && $_GET['vista'] == 'nuevo_envio')
			return '<div class="alert alert-info">'.__('Guarda primero el método de envío para poder cambiar sus opciones.').'</div>';
		
		if ($_GET['extension'] != 'ext_shop' || $_GET['vista'] != 'editar_envio' || empty($_GET['id']))
			return $output;
		
		$output .= $this->getTablaCampos($valor, $attr);
		
		return $output;
	}
	
	function getTablaCampos($valor, $attr){
		e_include('ext_shop/class/envioShop');
		
		$item_seleccionado = new EnvioShop();
		$item_seleccionado->setid($_GET['id']);
		
		$rand = rand();
		
		$cm_txt = '';
		if (!empty($_GET['custom_menu']))
			$cm_txt = '&custom_menu='.$_GET['custom_menu'];
		
		$html = '';
		
		if ($item_seleccionado = $item_seleccionado->BuscarId()){
			$metodo_envio = $item_seleccionado->getMetodoEnvio();
			
			$html .= $metodo_envio->generate_settings_html($this->name, $valor);
		}
		
		return $html;
	}
}
