<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldOpcionesproductoatributo extends FormField
{
	/**
	 * The articulo field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'opcionesproductoatributo';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="form-control '.(string) $this->element['class'].'"' : ' class="form-control"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		global $producto_atributo;
		
		if (empty($producto_atributo))
			return false;
		
		$output = '';
		
		$output .= $this->getTablaCampos($valor, $attr, $producto_atributo);
		
		return $output;
	}
	
	function getTablaCampos($valor, $attr, $clase_item){
		if (empty($clase_item) || !is_object($clase_item))
			return false;
		
		$rand = rand();
		
		$cm_txt = '';
		if (!empty($_GET['custom_menu']))
			$cm_txt = '&custom_menu='.$_GET['custom_menu'];
		
		$html = '';
		
		if (!empty($clase_item)){
			$valores_atr = $clase_item->getValores();
			
			$html .= '<div class="pull-right"><a class="btn btn-small btn-primary iframe-config nuevo-valor-atributo-'.strtolower(get_class($clase_item)).'" href="?extension='.$_GET["extension"].'&amp;vista=nuevo_atributo_valor&atributo_id='.$clase_item->id.$cm_txt.'&popup=1" ><i class="fa fa-plus fa fa-white"> </i> '.__('Añadir valor').'</a></div>
			<div class="clearfix"></div>
			<div id="content_ce" class="relative">';
			
			if (is_array($valores_atr) && sizeof($valores_atr) > 0){
				
				$has_text = $clase_item->hasTextura();
				
				$html .= '<table class="table table-striped" id="atributos_valor_list_'.$this->id.'">';
				$html .= '<thead><tr>';
				$html .= '<th width="1%">'.__("ID").'</th>';
				$html .= '<th>'.__("Valor").'</th>';
				if ($has_text){
					$html .= '<th>'.__("Textura / color").'</th>';
				}
				$html .= '<th style="text-align: right;">'.__("Opciones").'</th>';
				$html .= '</tr></thead>';
				
				$html .= '<tbody>';
				
				foreach ($valores_atr as $valor_atr){
					$html .= '<tr id="listItem_'.$valor_atr->id.'">';
					
					$html .= '<td class="nowrap">'.$valor_atr->id.'</td>';
					
					$html .= '<td class="nowrap">'.SistemaIdioma::Imprimir($valor_atr->valor).'</td>';
					
					if ($has_text){
						$html .= '<td class="nowrap">'.$valor_atr->printTextura().'</td>';
					}
					$html .= '<td class="nowrap has-context">
					<div class="pull-right">
                      <div class="btn-group" style="margin-left: 6px; "> <a href="#" data-toggle="dropdown" class="dropdown-toggle btn btn-xs btn-default" title="'.__('Opciones avanzadas del valor').'"> <i class="fa fa-cog"></i> </a>
                        <ul class="dropdown-menu pull-right">
                          <li class=""><a class="iframe-config" href="?extension='.$_GET["extension"].'&amp;vista=editar_atributo_valor&amp;id='.$valor_atr->id.$cm_txt.'&popup=1">'.__('Editar').'</a></li>
                          <li class="divider"></li>
                          <li class=""><a href="javascript:;" class="borrar_item" data-title="'.SistemaIdioma::Imprimir($this->valor).'" data-id="'.$valor_atr->id.'" data-script-url="'.CONF_URL_APP_ADMIN.'?extension='.$_GET["extension"].'&vista=editar_atributo_valor'.$cm_txt.'&id='.$valor_atr->id.'" data-refresh-url="'.CONF_URL_APP_ADMIN.'?extension='.$_GET["extension"].'&vista='.$_GET["vista"].$cm_txt.'&id='.$_GET['id'].' #content_ce" data-contenedor-items="#content_ce" data-token="'.Helpers::getFormToken().'">'.__('Borrar valor').'</a></li>
                        </ul>
                      </div>
                    </div>
					<div class="clearfix"></div>
					
					</td>';
                    $html .= '</tr>';                    
				}
				
				$html .= '</tbody></table>';
				
				$last_url = Helpers::getSesion()->get('lastURL', null, 'admin');
								
				$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
				$(window).load(function(){
	var fixHelperModified = function(e, tr) {
    var $originals = tr.children();
    var $helper = tr.clone();
    $helper.children().each(function(index)
    {
      $(this).width($originals.eq(index).width())
    });
    return $helper;
};
$("table#atributos_valor_list_'.$this->id.' tbody").sortable({
    helper: fixHelperModified,
	update : function () { 
		  var order = $(this).sortable("serialize");
		  $.post("'.$last_url.'", order, function(data){
			  if ($.trim(data) != "ok"){
			 	Utilidades.Notificar($.trim(data));
			  }
			  return false;
		  });		  
		} 
}).disableSelection();
});//]]>');
			} else {
				$html .= '<p align="center">'.__('No hay valores en este atributo').'</p>';
			}
			$html .= '</div>';
		}
		
		return $html;
	}
}
