<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldTipoproductoatributolist extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'tipoproductoatributolist';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		$rand = rand();
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->multiple ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		// Get the field options.
		$options = (array) $this->getOptions($valor);
		
		$output = '';
		
		$output .= '<select'.$attr.' name="'.$this->name.'" id="'.$this->id.'_'.$rand.'">';
		
		foreach ($options as $option){
			$output .= $option;
		}
		
		$output .= '</select>';
		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);
		return $output;
	}
	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null)
	{
		$options = array();
		
		e_include('ext_shop/class/productoAtributoTipo');
		
		$tipos_list = new ProductoAtributoTipo();		
		
		$tipos_list = $tipos_list->getTipos();
		
		$este_campo = $this;
		
		$blank_selected = '';
		if ($valor == 0 || $valor == '')
			$blank_selected = ' selected="selected"';
		
		if ($tipos_list == false || empty($tipos_list)){
			$options[] = '<option'.$blank_selected.' value="">'.__('No hay tipos de atributos').'</option>';
		} else {
			foreach ($tipos_list as $id_tipo=>$tipo_atributo){
				$output = '';
				
				$output .= '<option value="'.$id_tipo.'"';
				if ($valor != null){
					if ($este_campo->element['multiple'] == 'true' && is_array($valor)){
						if (in_array($id_tipo, $valor)){
							$output .= ' selected="selected"';
						}
					} else {
						if ($valor == $id_tipo){
							$output .= ' selected="selected"';
						}
					}
				}
				
				$output .='>'.$tipo_atributo . '</option>';
				
				$options[] = $output;
				
			}
	
			reset($options);
		}
		
		return $options;
	}
}
