<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldTransportistaslist extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'transportistaslist';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		$rand = rand();
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multiple'] ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$multiple = $this->element['multiple'] ? true : false;
		
		$mult_attr = '';
		if ($multiple && substr($this->name, strlen($this->name) - 2) != '[]')
			$mult_attr = '[]';
		// Get the field options.
		$options = (array) $this->getOptions($valor, $multiple);
		
		$output = '';
		
		$output .= '<select'.$attr.' name="'.$this->name.$mult_attr.'" id="'.$this->id.'_'.$rand.'">';
		
		foreach ($options as $option){
			$output .= $option;
		}
		
		$output .= '</select>';
		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);
		return $output;
	}
	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $multiple=false)
	{
		$options = array();
		
		$path_transportistas = CONF_REALPATH_APP . 'extensions/ext_shop/class/transportistas/';
		
		$files_transportistas = Helpers::dir_list($path_transportistas, '', '.class.php', false, false);
				
		$este_campo = $this;
		
		$blank_selected = '';
		if ($valor == 0 || $valor == '')
			$blank_selected = ' selected="selected"';
		
		if ($files_transportistas == false || empty($files_transportistas)){
			if ($multiple == false){
				$options[] = '<option'.$blank_selected.' value="">'.__('No hay transportistas').'</option>';
			}
		} else {
			if ($multiple == false){
				$options[] = '<option'.$blank_selected.' value="">'.__('Sin transportista').'</option>';
			}
			
			foreach ($files_transportistas as $trans_files){
				
				foreach ($trans_files as $tran){
					
					$filename_arr = explode('.', $tran);
					$filename = $filename_arr[0];
					
					$class_trans = ucfirst($filename) . 'TransportistaShop';
					
					if (!class_exists($class_trans))
						include($path_transportistas . $tran);
						
					if (class_exists($class_trans)){
					
						$trans_obj = new $class_trans();
						
						$id_trans = $trans_obj->getId();
						$nombre_tans = $trans_obj->getNombre();
					
						$output = '';
						
						$output .= '<option value="'.$id_trans.'"';
						if ($valor != null){
							if ($este_campo->element['multiple'] == 'true' && is_array($valor)){
								if (in_array($id_trans, $valor)){
									$output .= ' selected="selected"';
								}
							} else {
								if ($valor == $id_trans){
									$output .= ' selected="selected"';
								}
							}
						}
						
						$output .= '>' . $nombre_tans . '</option>';
						
						$options[] = $output;
					}
				}
				
			}
	
			reset($options);
		}
		
		return $options;
	}
	
	function init_extra_form_fields() {
        parent::init_extra_form_fields();
        $extra_form_fields = array(
            'text' => array(
                'nombre' => __('Campo: Lista de zonas de envío'),
                'campos' => array(
                    'multiple' => array(
                        'type' => 'list',
                        'label' => __('Selección múltiple'),
                        'description' => __('Permite seleccionar varias zonas de la lista'),
                        'default' => 'false',
                        'params' => array('button-group' => 'true', 'class_div' => 'col-xs-4'),
                        'options' => array('true' => __('Sí'), 'false' => __('No'))
                    )
                )
            )
        );
        $this->extra_form_fields = array_merge($this->extra_form_fields, $extra_form_fields);
    }
}
