<?php
c_include('forms/formField');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldZonasenvioslist extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'zonasenvioslist';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		$rand = rand();
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multiple'] ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$multiple = $this->element['multiple'] ? true : false;
		
		$mult_attr = '';
		if ($multiple && substr($this->name, strlen($this->name) - 2) != '[]')
			$mult_attr = '[]';
		// Get the field options.
		$options = (array) $this->getOptions($valor, $multiple);
		
		$output = '';
		
		$output .= '<select'.$attr.' name="'.$this->name.$mult_attr.'" id="'.$this->id.'_'.$rand.'">';
		
		foreach ($options as $option){
			$output .= $option;
		}
		
		$output .= '</select>';
		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);
		return $output;
	}
	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $multiple=false)
	{
		$options = array();
		
		e_include('ext_shop/class/zonaEnvios');
		
		$zonas_list = new ZonaEnviosShop();
		$zonas_list = $zonas_list->Listar('estado=1','titulo','ASC');
				
		$este_campo = $this;
		
		$blank_selected = '';
		if ($valor == 0 || $valor == '')
			$blank_selected = ' selected="selected"';
		
		if ($zonas_list == false || empty($zonas_list)){
			if ($multiple == false){
				$options[] = '<option'.$blank_selected.' value="">'.__('No hay zonas de envío').'</option>';
			}
		} else {
			if ($multiple == false){
				$options[] = '<option'.$blank_selected.' value="">'.__('Sin zona de envío').'</option>';
			}
			
			foreach ($zonas_list as $zona){
				$output = '';
				
				$output .= '<option value="'.$zona->id.'"';
				if ($valor != null){
					if ($este_campo->element['multiple'] == 'true' && is_array($valor)){
						if (in_array($zona->id, $valor)){
							$output .= ' selected="selected"';
						}
					} else {
						if ($valor == $zona->id){
							$output .= ' selected="selected"';
						}
					}
				}
				
				$output .='>'.SistemaIdioma::Imprimir($zona->titulo) . '</option>';
				
				$options[] = $output;
				
			}
	
			reset($options);
		}
		
		return $options;
	}
	
	function init_extra_form_fields() {
        parent::init_extra_form_fields();
        $extra_form_fields = array(
            'text' => array(
                'nombre' => __('Campo: Lista de zonas de envío'),
                'campos' => array(
                    'multiple' => array(
                        'type' => 'list',
                        'label' => __('Selección múltiple'),
                        'description' => __('Permite seleccionar varias zonas de la lista'),
                        'default' => 'false',
                        'params' => array('button-group' => 'true', 'class_div' => 'col-xs-4'),
                        'options' => array('true' => __('Sí'), 'false' => __('No'))
                    )
                )
            )
        );
        $this->extra_form_fields = array_merge($this->extra_form_fields, $extra_form_fields);
    }
}
