<?php
$options = array(
    "titulo" => __('Facturas'),
    "nivel_acceso" => ""
);
$txt_cm  = '';
if (isset($GLOBALS['custom_menu'])) {
    $txt_cm = '&custom_menu=' . $GLOBALS['custom_menu']->id;
    if (!empty($GLOBALS['custom_menu']->params)) {
        parse_str(trim($GLOBALS['custom_menu']->params), $parametros_custom);
        foreach ($parametros_custom as $kparam => $param) {
            if (array_key_exists($kparam, $options))
                $options[$kparam] = utf8_decode($param);
        }
    }
    $options['titulo'] = SistemaIdioma::Imprimir($GLOBALS['custom_menu']->titulo);
}
c_include('usuario', 'helpers/templateHelper');
e_include('ext_shop/class/facturaShop', 'ext_shop/class/cliente');
$clientes = new ClienteShop();
$clientes = $clientes->Listar("", "datos_facturacion", "ASC");
if (!class_exists('ListadoAdminModel')) {
    echo "Error 500: No se ha encontrado la clase de la extensión.";
    return false;
}
if (!empty($_POST)) {
    if ($_POST['accion'] == 'exportar_facturas') {
        include CONF_REALPATH_APP . "extensions/ext_shop/admin/tools/exportar_facturas.php";
    }
}
$ejercicio_actual       = date('Y');
$ejercicio_seleccionado = $ejercicio_actual;
if ($_GET['todo'] == '1') {
    $ejercicio_seleccionado = false;
} elseif (!empty($_GET['ejercicio'])) {
    $ejercicio_seleccionado = (int) $_GET['ejercicio'];
}
$cat_id    = 0;
$class_obj = new FacturaShop();
$opts      = array(
    "keyword_where_exp" => "(datos_facturacion LIKE '%##KEYWORD##%')"
);
if ($ejercicio_seleccionado) {
    $opts["sql_extra"] .= "ejercicio = '" . $ejercicio_seleccionado . "'";
}
$ejercicios_disponibles_sql = $class_obj->getSQLGrouped('ejercicio');
$ejercicios_disponibles     = array();
foreach ($ejercicios_disponibles_sql as $ejer) {
    $ejercicios_disponibles[$ejer['campo']] = $ejer['num_items'];
}
if (!array_key_exists($ejercicio_actual, $ejercicios_disponibles)) {
    $ejercicios_disponibles[$ejercicio_actual] = 0;
}
krsort($ejercicios_disponibles);
$opts['vista_config'] = array(
    "url_nuevo" => "?extension=##EXT##&vista=nuevo_factura",
    "url_editar" => "?extension=##EXT##&vista=##VISTA##&id=##id##",
    "url_opciones" => "?extension=configuracion&load=##EXT##&popup=1",
    "vista_url_editar" => "editar_factura",
    "tipo_vista" => "tabla",
    "clase_tabla" => "table-striped"
);
$items                = new ListadoAdminModel($cat_id, $class_obj, $opts);
$ejercicios_array     = array();
foreach ($ejercicios_disponibles as $ejercicio => $num_facturas) {
    $model_ejercicio = array(
        'titulo' => $ejercicio,
        'href' => Helpers::currentUrl(array(
            'ejercicio' => $ejercicio,
			'page' => '1'
        ))
    );
    if ($ejercicio == $ejercicio_seleccionado) {
        $model_ejercicio['attr'] = ' class="active"';
    }
    $ejercicios_array[] = $model_ejercicio;
}
$items->vista_config['listado_extra_toolbar'] = array(
    array(
        "titulo" => $ejercicio_seleccionado,
        "icono" => "fa fa-calendar",
        "descripcion" => __('Ejercicio seleccionado'),
        "clase_css" => "btn btn-sm btn-default navbar-btn",
        "dropdown" => true,
        "children" => $ejercicios_array
    ),
    array(
        "titulo" => __('Herramientas'),
        "icono" => "fa fa-cogs",
        "descripcion" => __('Herramientas de facturas'),
        "clase_css" => "btn btn-sm btn-default navbar-btn",
        "dropdown" => true,
        "children" => array(
            array(
                "titulo" => __('Generar facturas periódicas'),
                "icono" => "fa fa-refresh",
                "descripcion" => __('Generar todas las facturas periódicas pendientes'),
                "attr" => ' data-toggle="modal"',
                "href" => "#modal-generar-facturas-periodicas"
            ),
            array(
                "titulo" => __('Exportar facturas'),
                "icono" => "fa fa-external-link",
                "descripcion" => __('Exportar todas las facturas a un archivo CSV'),
                "attr" => ' data-toggle="modal"',
                "href" => "#modal-exportar-facturas"
            ),
            array(
                "titulo" => __('Informes'),
                "icono" => "fa fa-list",
                "descripcion" => __('Generar informes de facturas para presentación de impuestos, control de ingresos, etc.'),
                "attr" => ' data-toggle="modal"',
                "href" => "#modal-informes-facturas"
            )
        )
    )
);
$items->vista_config['listado_extra_html']    = '<div id="modal-exportar-facturas" class="modal fade">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button onclick="$(\'#modal-exportar-facturas\').modal(\'hide\');return false;" class="close">&times;</button>
        <h4 class="modal-title">' . __('Exportar facturas') . '</h4>
      </div>
      <div class="modal-body">
        <p>' . __('Se van a exportar todas las facturas a un archivo CSV.') . '</p>
        <p>' . __('¿Quiere continuar con la exportación de las facturas?') . '</p>
      </div>
      <div class="modal-footer">
        <form method="post" action="" target="_blank">
          <input type="hidden" name="accion" value="exportar_facturas" />
          <button type="submit" id="btn-modal-exportar-facturas" class="btn btn-danger">' . __('Sí') . '</button>
          <a href="javascript:$(\'#modal-exportar-facturas\').modal(\'hide\')" class="btn btn-default">' . __('No') . '</a>
        </form>
      </div>
    </div>
  </div>
</div>
<div id="modal-generar-facturas-periodicas" class="modal fade">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button onclick="$(\'#modal-generar-facturas-periodicas\').modal(\'hide\');return false;" class="close">&times;</button>
        <h4 class="modal-title">' . __('Generar facturas periódicas') . '</h4>
      </div>
      <div class="modal-body">
        <p>' . __('Se van a generar todas las facturas periódicas pendientes.') . '</p>
        <p>' . __('¿Quiere continuar con la generación de las facturas?') . '</p>
      </div>
      <div class="modal-footer">
        <form method="post" action="" target="_blank" id="frm-generar-facturas-periodicas">
          <input type="hidden" name="accion" value="generar_facturas_periodicas" />
          <a id="btn-modal-exportar-facturas" class="btn btn-danger" data-accion-item="form" data-form-id="form#frm-generar-facturas-periodicas" data-script-url="' . CONF_URL_APP . 'api/shop/factura/generarFacturasPeriodicas.json" data-token="' . Helpers::getFormToken() . '" data-titulo="' . __('Vas a generar todas las facturas periódicas pendientes. ¿Quieres continuar con la generación de las facturas?') . '" data-respuesta-ok="' . __('Las facturas se han generado con éxito') . '" data-refresh-url="' . Helpers::currentURL() . '" data-refresh="#page-wrapper" data-es-modal="1">' . __('Sí') . '</button>
          <a href="javascript:$(\'#modal-generar-facturas-periodicas\').modal(\'hide\')" class="btn btn-default">' . __('No') . '</a>
		  <input type="hidden" name="accion" value="facturas_periodicas" />
		  <input type="hidden" name="token" value="' . Helpers::getFormToken() . '" />
        </form>
      </div>
    </div>
  </div>
</div>
<div id="modal-informes-facturas" class="modal fade">
  <div class="modal-lg modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button onclick="$(\'#modal-informes-facturas\').modal(\'hide\');return false;" class="close">&times;</button>
        <h4 class="modal-title">' . __('Informes de Facturas') . '</h4>
      </div>
      <div class="modal-body">
	  	
		<h5>' . __('Filtros del informe') . '</h5>
		
		<form id="frm-informes-facturas" method="post" action="" class="row">
		
		<div class="form-group col-sm-3">			
			<div class="input-group"><span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text" name="fecha_inicio" id="fecha_inicio_filtros_informes_facturas" value="" placeholder="' . __('Fecha de inicio') . '" class="form-control datepicker"></div>
			
		</div>
		
		<div class="form-group col-sm-3">			
			<div class="input-group"><span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text" name="fecha_fin" id="fecha_fin_filtros_informes_facturas" value="" placeholder="' . __('Fecha final') . '" class="form-control datepicker"></div>
			
		</div>
		
		<div class="form-group col-sm-2">			
			<select name="cliente" id="cliente_filtros_informes_facturas" class="select2">
			<option value="">' . __('Cliente') . '</option>
			';
foreach ($clientes as $cl) {
    $items->vista_config['listado_extra_html'] .= '<option value="' . $cl->id . '">' . $cl->facturacion->nombre . ' ' . $cl->facturacion->apellidos . ' (' . __('NIF:') . ' ' . $cl->facturacion->nif . ')</option>';
}
$items->vista_config['listado_extra_html'] .= '</select>
			
		</div>
		
		
		
		
		
		
		<div class="form-group col-sm-2">			
			<select name="estado" id="estado_filtros_informes_facturas" class="select2">
			<option value="">' . __('Todas') . '</option>
			<option value="pendiente">' . __('Pendiente') . '</option>
			<option value="pagada">' . __('Pagada') . '</option>
			';
$items->vista_config['listado_extra_html'] .= '</select>
			
		</div>
		
		
		
		
		<div class="form-group col-sm-2">
			<a href="javascript:;" data-accion-item="form" data-form-id="form#frm-informes-facturas" data-script-url="' . CONF_URL_APP . 'api/shop/factura/generarInforme.json" data-token="' . Helpers::getFormToken() . '" data-titulo="' . __('Vas a generar un informe de facturas con los filtros seleccionados. ¿Quieres continuar con la generación del informe?') . '" data-respuesta-ok="' . __('El informe se ha generado con éxito') . '" data-refresh-url="' . CONF_URL_APP . 'api/shop/factura/mostrarInforme.json" data-refresh="#resultado-informes-facturas" class="btn btn-primary btn-block">' . __('Generar') . '</a>
			<input type="hidden" name="accion" value="informe_facturas" />
			<input type="hidden" name="token" value="' . Helpers::getFormToken() . '" />
		</div>
		
		</form>
		<div class="clearfix"></div>
		
		<div id="resultado-informes-facturas" style="max-height: 300px;overflow-y: auto; overflow-x: hidden;">
		
		</div>
		
      </div>
      <div class="modal-footer">
          <a href="javascript:$(\'#modal-informes-facturas\').modal(\'hide\')" class="btn btn-default">' . __('Cerrar') . '</a>
      </div>
    </div>
  </div>
</div>';
$items->vista_config['listado_extra_opts']  = array(
    array(
        "titulo" => __('Descargar en PDF'),
        "icono" => "fa fa-download",
        "descripcion" => __('Descargar factura en PDF'),
        "clase_css" => "",
        "attr" => ' target="_blank"',
        "href" => "?extension=ext_shop&vista=editar_factura&id=##id##&download=pdf"
    ),
    array(
        "titulo" => __('Enviar por email'),
        "icono" => "fa fa-envelope",
        "descripcion" => __('Enviar factura por email'),
        "clase_css" => "iframe-config",
        "attr" => ' target="_blank"',
        "href" => "?extension=ext_shop&vista=editar_factura&id=##id##&download=email"
    ),
    array(
        "titulo" => __('Imprimir'),
        "icono" => "fa fa-print",
        "descripcion" => __('Imprimir factura'),
        "clase_css" => "",
        "attr" => ' target="_blank"',
        "href" => "?extension=ext_shop&vista=editar_factura&id=##id##&download=html"
    )
);
$items->columnas_config['estado_factura']   = array(
    "allow_ordering" => false,
    "width" => "5%",
    "class" => "nowrap",
    "class_td" => "small"
);
$items->columnas_config['factura_html']     = array(
    "allow_ordering" => false,
    "show_opts_box" => true,
    "width" => "25%",
    "class" => "nowrap",
    "class_td" => "small"
);
$items->columnas_config['forma_pago']       = array(
    "allow_ordering" => true,
    "class" => "nowrap",
    "class_td" => "small"
);
$items->columnas_config['total_factura']    = array(
    "allow_ordering" => false,
    "width" => "5%",
    "class" => "nowrap",
    "class_td" => "small"
);
$items->columnas_config['opciones_factura'] = array(
    "allow_ordering" => false,
    "width" => "10%",
    "class" => "nowrap right",
    "class_td" => "small right"
);
$items->columnas_config['titulo']           = array(
    "allow_ordering" => true,
    "show_opts_box" => false,
    "class" => "nowrap",
    "class_td" => "small"
);
$items->parsea_config_vista();
$items->columnas_listado = array(
    "estado_factura" => __('Estado'),
    "factura_html" => __('Factura'),
    "titulo" => __('Asunto'),
    "fecha" => __('Fecha'),
    "forma_pago" => __('Forma de pago'),
    "total_factura" => __('Total'),
    "opciones_factura" => __('Opciones'),
    "id" => __('ID')
);
$columnas_tabla          = $items->getColumnasListado();
?>