<?php /*
template: Bootstrap 3 Avanzado
*/?>
<?php defined('CONF_URL_APP') or die; ?>
<!doctype html>
<html lang="<?php echo SistemaIdioma::getIdiomaSesion();?>">
<head>
<meta charset="UTF-8">
<title><?php echo sprintf(__('Factura # %s'), $factura->codigo.'/'.$factura->ejercicio);?></title>
<style>
@import url('http://maxcdn.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css');
</style>
</head>
<body style="zoom: 0.8;">
<div class="container">
  <div class="row">
    <div class="col-xs-6">
      <h1> <img src="<?php echo CONF_URL_APP.$datos_empresa["logotipo"];?>"> </h1>
    </div>
    <div class="col-xs-6 text-right">
      <h1><?php echo __('FACTURA');?></h1>
      <h1><small><?php echo sprintf(__('Factura # %s'), $factura->codigo.'/'.$factura->ejercicio);?><br>
        <?php echo sprintf(__('Fecha: %s'), strftime("%d/%m/%Y", strtotime($factura->fecha)));?></small></h1>
    </div>
  </div>
  <div class="row">
    <div class="col-xs-6 col-sm-5">
      <div class="panel panel-default">
        <div class="panel-heading">
          <h4><small><?php echo __('De');?>:</small> <b><?php echo $datos_empresa["razon_social"];?></b></h4>
        </div>
        <div class="panel-body">
          <p> <?php echo htmlentities($datos_empresa["nif_cif"]).'<br />
					'.htmlentities($datos_empresa['direccion']).'<br />
					'.htmlentities($datos_empresa['codigo_postal']).' '.htmlentities($datos_empresa['localidad']).'<br />
					'.htmlentities($datos_empresa['provincia']).' ('.htmlentities($datos_empresa['pais']).')<br />
					<a href="mailto:'.$datos_empresa["email"].'">'.$datos_empresa["email"].'</a>';?> </p>
        </div>
      </div>
    </div>
    <div class="col-xs-6 col-sm-5 col-sm-offset-2 text-right">
      <div class="panel panel-default">
        <div class="panel-heading">
          <h4><small><?php echo __('Para');?>:</small> <b><?php echo $datos_facturacion['nombre'].' '.$datos_facturacion['apellidos'];?></b></h4>
        </div>
        <div class="panel-body">
          <p> <?php echo htmlentities($datos_facturacion['nif']).'<br />
					'.htmlentities($datos_facturacion['direccion']).'<br />
					'.htmlentities($datos_facturacion['codigo_postal']).' '.htmlentities($datos_facturacion['localidad']).'<br />
					'.htmlentities($datos_facturacion['provincia_label']).' ('.htmlentities($datos_facturacion['pais_label']).')<br />
					<a href="mailto:'.$cliente->email.'">'.$cliente->email.'</a>';?> </p>
        </div>
      </div>
    </div>
  </div>
  <!-- / end client details section -->
  
  <table class="table table-bordered">
    <thead>
      <tr>
        <th><h4><?php echo __('Descripción');?></h4></th>
        <th><h4><?php echo __('Cantidad');?></h4></th>
        <th><h4><?php echo __('Precio ud.');?></h4></th>
        <th><h4><?php echo __('Impuesto');?></h4></th>
        <th><h4><?php echo __('Subtotal');?></h4></th>
      </tr>
    </thead>
    <tbody>
      <?php 
		$gastos_de_envio = false;
		$importe_gastos_envio = 0;
		$impuestos = array();
		$subtotal = 0;
		$total = 0;
		foreach ($factura->lineas as $linea){
			$perc_impuesto = number_format(($linea->linea_impuesto / $linea->linea_total) * 100, 0);
			$perc_impuesto = number_format($perc_impuesto, 2, '.', '');
			
			if (($linea->nombre_producto == 'Gastos de envío' || $linea->nombre_producto == 'Shipping') && $perc_impuesto == '0'){
				$perc_impuesto = "21.00";
				
				$linea->linea_impuesto = round(($linea->linea_total / 1.21) * 0.21, 2);
				$linea->linea_total = $linea->linea_total - $linea->linea_impuesto;
			}
			
			$subtotal += $linea->linea_total;
			$total += $linea->linea_total + $linea->linea_impuesto;
			
			if (!isset($impuestos[$perc_impuesto])){
				$impuestos[$perc_impuesto] = array('porcentaje'=>$perc_impuesto, 'total_impuesto'=>$linea->linea_impuesto, 'base_imponible'=>$linea->linea_total);
			} else {
				$impuestos[$perc_impuesto]['total_impuesto'] += $linea->linea_impuesto;
				$impuestos[$perc_impuesto]['base_imponible'] += $linea->linea_total;
			}
			
			?>
      <tr>
        <td><?php echo $linea->nombre_producto;?></td>
        <td class="text-right"><?php echo $linea->cantidad;?></td>
        <td class="text-right"><?php echo Helpers::Importe($linea->linea_total / $linea->cantidad);?> &euro;</td>
        <td class="text-right"><?php echo $perc_impuesto;?> %</td>
        <td class="text-right"><?php echo Helpers::Importe($linea->linea_total + $linea->linea_impuesto);?> &euro;</td>
      </tr>
      <?php } ?>
    </tbody>
  </table>
  <div class="row text-right">
    <div class="col-xs-4 col-xs-offset-6">
      <p> <strong>
        <?php if (is_array($impuestos) && sizeof($impuestos) > 0){?>
        <?php foreach ($impuestos as $imp){?>
        <?php echo sprintf(__('Base imponible (%s%%)'), $imp['porcentaje']);?> : <br>
        <?php } ?>
        <?php } else {?>
        <?php echo __('Base imponible');?> : <br>
        <?php } ?>
        <?php if ($factura->total_retencion <> 0){?>
        <?php echo sprintf(__('Retención (%s%%)'), number_format($factura->percent_retencion, 2, '.', ''));?> : <br>
        <?php } ?>
        <?php if (is_array($impuestos) && sizeof($impuestos) > 0){?>
        <?php foreach ($impuestos as $imp){?>
        <?php echo sprintf(__('Cuota IVA (%s%%)'), $imp['porcentaje']);?> : <br>
        <?php } ?>
        <?php } else {?>
        <?php echo __('Impuestos');?> : <br>
        <?php } ?>
        <?php if ($factura->total_recargo <> 0){
			$perc_recargo = number_format($factura->percent_recargo, 2, '.', '');
			?>
        <?php echo sprintf(__('Recargo de equivalencia (%s%%)'), $perc_recargo);?> : <br>
        <?php } ?>
        <?php if ($factura->total_descuento <> 0){
			$perc_descuento = number_format($factura->percent_descuento, 2, '.', '');?>
        <?php echo sprintf(__('Descuento (%s%%)'), $perc_descuento);?> : <br>
        <?php } ?>
        <br>
        <big><?php echo __('Total');?> :</big> <br>
        </strong> </p>
    </div>
    <div class="col-xs-2"> <strong>
      <?php if (is_array($impuestos) && sizeof($impuestos) > 0){?>
      <?php foreach ($impuestos as $imp){?>
      <?php echo Helpers::Importe($imp['base_imponible']);?> &euro; <br>
      <?php } ?>
      <?php } else {?>
      <?php if ($gastos_de_envio == true){?>
      <?php echo Helpers::Importe($factura->base_imponible - $importe_gastos_envio);?> &euro; <br>
      <?php } else { ?>
      <?php echo Helpers::Importe($factura->base_imponible);?> &euro; <br>
      <?php } ?>
      <?php } ?>
      <?php if ($factura->total_retencion <> 0){?>
      <?php echo Helpers::Importe($factura->total_retencion);?> &euro; <br>
      <?php } ?>
      <?php if (is_array($impuestos) && sizeof($impuestos) > 0){?>
      <?php foreach ($impuestos as $imp){?>
      <?php echo Helpers::Importe($imp['total_impuesto']);?> &euro; <br>
      <?php } ?>
      <?php } else {?>
      <?php echo Helpers::Importe($factura->total_impuesto);?> &euro; <br>
      <?php } ?>
      <?php if ($factura->total_recargo <> 0){?>
      <?php echo Helpers::Importe($factura->total_recargo);?> &euro; <br>
      <?php } ?>
      <?php if ($factura->total_descuento <> 0){?>
      <?php echo Helpers::Importe($factura->total_descuento);?> &euro; <br>
      <?php } ?>
      <br>
      <big><?php echo Helpers::Importe($total + $factura->total_descuento + $factura->total_recargo + $factura->total_retencion);?> &euro;</big> <br>
      </strong> </div>
  </div>
  <div class="row">
    <div class="col-xs-6">
      <div class="panel panel-info">
        <div class="panel-heading">
          <h4><?php echo __("Método de Pago");?></h4>
        </div>
        <div class="panel-body">
          <?php if (!empty($factura->vencimiento) && $factura->vencimiento != '0000-00-00 00:00:00'){?>
          <dl class="dl-horizontal">
            <dt><?php echo __('Vencimiento');?></dt>
            <dd><?php echo strftime('%d-%m-%Y', strtotime($factura->vencimiento));?></dd>
          </dl>
          <?php } ?>
          <dl class="dl-horizontal" style="margin-bottom:0;">
            <dt><?php echo __('Forma de pago');?></dt>
            <dd><?php echo $metodo_pago->titulo[SistemaIdioma::getIdiomaSesion()];?> </dd>
            <?php if ($factura->forma_pago == 'transferencia'){?>
            <?php if (!empty($metodo_pago->settings['banco_cuenta'])){?>
            <dt><?php echo __('Banco');?></dt>
            <dd><?php echo $metodo_pago->settings['banco_cuenta'];?></dd>
            <?php } ?>
            <?php if (!empty($metodo_pago->settings['nombre_cuenta'])){?>
            <dt><?php echo __('Titular');?></dt>
            <dd><?php echo $metodo_pago->settings['nombre_cuenta'];?></dd>
            <?php } ?>
            <?php $num_cuenta = trim($metodo_pago->settings['codigo_entidad_cuenta'] . " " . $metodo_pago->settings['codigo_oficina_cuenta'] . " " . $metodo_pago->settings['digito_control_cuenta'] . " " . $metodo_pago->settings['numero_cuenta']);
		  
		  if (!empty($num_cuenta)){?>
            <dt><?php echo __('Cuenta');?></dt>
            <dd><?php echo $num_cuenta;?></dd>
            <?php } ?>
            <?php } ?>
          </dl>
        </div>
      </div>
    </div>
    <div class="col-xs-6">
      <div class="span6">
        <div class="panel panel-info">
          <div class="panel-heading">
            <h4><?php echo __('Observaciones');?></h4>
          </div>
          <div class="panel-body">
            <?php if (!empty($factura->comentarios)){?>
            <?php echo nl2br($factura->comentarios);?>
            <?php } ?>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
</body>
</html>