<?php /*
template: Bootstrap 3
*/?>
<?php defined('CONF_URL_APP') or die; ?>
<!doctype html>
<html lang="en">
<head>
<meta charset="UTF-8">
<title><?php echo sprintf(__('Factura # %s'), $factura->codigo.'/'.$factura->ejercicio);?></title>
<style>
	@import url('http://maxcdn.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css');
</style>
</head>
<body>
<div class="container">
  <div class="row">
    <div class="col-xs-6">
      <h1> <img src="<?php echo CONF_URL_APP.$datos_empresa["logotipo"];?>"> </h1>
    </div>
    <div class="col-xs-6 text-right">
      <h1><?php echo __('FACTURA');?></h1>
      <h1><small><?php echo sprintf(__('Factura # %s'), $factura->codigo.'/'.$factura->ejercicio);?><br><?php echo sprintf(__('Fecha: %s'), strftime("%d/%m/%Y", strtotime($factura->fecha)));?></small></h1>
    </div>
  </div>
  <div class="row">
    <div class="col-xs-5">
      <div class="panel panel-default">
        <div class="panel-heading">
          <h4><?php echo __('De');?>: <a href="javascript:;"><?php echo $datos_empresa["razon_social"];?></a></h4>
        </div>
        <div class="panel-body">
          <p> <?php echo htmlentities($datos_empresa["nif_cif"]).'<br />
					'.htmlentities($datos_empresa['direccion']).'<br />
					'.htmlentities($datos_empresa['codigo_postal']).' '.htmlentities($datos_empresa['localidad']).'<br />
					'.htmlentities($datos_empresa['provincia']).' ('.htmlentities($datos_empresa['pais']).')<br />
					'.$datos_empresa["email"];?>
          </p>
        </div>
      </div>
    </div>
    <div class="col-xs-5 col-xs-offset-2 text-right">
      <div class="panel panel-default">
        <div class="panel-heading">
          <h4><?php echo __('Para');?> : <a href="javascript:;"><?php if (!empty($datos_facturacion['apellidos'])){?><?php echo $datos_facturacion['apellidos'];?>, <?php } ?><?php echo $datos_facturacion['nombre'];?></a></h4>
        </div>
        <div class="panel-body">
          <p> <?php echo htmlentities($datos_facturacion['nif']).'<br />
					'.htmlentities($datos_facturacion['direccion']).'<br />
					'.htmlentities($datos_facturacion['codigo_postal']).' '.htmlentities($datos_facturacion['localidad']).'<br />
					'.htmlentities($datos_facturacion['provincia_label']).' ('.htmlentities($datos_facturacion['pais_label']).')<br />
					'.$cliente->email;?>
          </p>
        </div>
      </div>
    </div>
  </div>
  <!-- / end client details section -->
  
  <table class="table table-bordered">
    <thead>
      <tr>
        <th><h4><?php echo __('Descripción');?></h4></th>
        <th><h4><?php echo __('Cantidad');?></h4></th>
        <th><h4><?php echo __('Precio ud.');?></h4></th>
        <th><h4><?php echo __('Impuesto');?></h4></th>
        <th><h4><?php echo __('Subtotal');?></h4></th>
      </tr>
    </thead>
    <tbody>
    	<?php foreach ($factura->lineas as $linea){
			?>
      <tr>
        <td<?php if ($linea->nombre_producto == 'Gastos de envío' || $linea->nombre_producto == 'Shipping'){?> colspan="4"<?php } ?>><?php echo $linea->nombre_producto;?></td>
        <?php if ($linea->nombre_producto != 'Gastos de envío' && $linea->nombre_producto != 'Shipping'){?>
        <td class="text-right"><?php echo $linea->cantidad;?></td>
        <td class="text-right"><?php echo Helpers::Importe($linea->linea_total / $linea->cantidad);?> &euro;</td>
        <td class="text-right"><?php echo Helpers::Importe(number_format(($linea->linea_impuesto / $linea->linea_total) * 100, 0));?> %</td>
        <?php } ?>
        <td class="text-right"><?php echo Helpers::Importe($linea->linea_total + $linea->linea_impuesto);?> &euro;</td>
      </tr>
      <?php } ?>
    </tbody>
  </table>
  <div class="row text-right">
    <div class="col-xs-2 col-xs-offset-8">
      <p> <strong> <?php echo __('Subtotal');?> : <br>
      <?php if ($factura->total_retencion <> 0){?>
      <?php echo __('Retención');?> : <br>
      <?php } ?>
        <?php echo __('Impuestos');?> : <br>
        <?php echo __('Descuento');?> : <br>
        <?php echo __('Total');?> : <br>
        </strong> </p>
    </div>
    <div class="col-xs-2"> <strong> <?php echo Helpers::Importe($factura->base_imponible);?> &euro; <br>
    	<?php if ($factura->total_retencion <> 0){?>
    	<?php echo Helpers::Importe($factura->total_retencion);?> &euro; <br>
        <?php } ?>
      <?php echo Helpers::Importe($factura->total_impuesto);?> &euro; <br>
      <?php echo Helpers::Importe($factura->total_descuento);?> &euro; <br>
      <?php echo Helpers::Importe($factura->total);?> &euro; <br>
      </strong> </div>
  </div>
  <div class="row">
    <div class="col-xs-5">
      <div class="panel panel-info">
        <div class="panel-heading">
          <h4><?php echo __("Método de Pago");?></h4>
        </div>
        <div class="panel-body">
          <p><strong><?php echo $metodo_pago->titulo[SistemaIdioma::getIdiomaSesion()];?> <small>(<?php echo $factura->estado;?>)</small></strong></p>
          <p><?php echo nl2br($instrucciones_pp);?></p>
        </div>
      </div>
    </div>
    <div class="col-xs-7">
      <div class="span7">
        <div class="panel panel-info">
          <div class="panel-heading">
            <h4><?php echo __('Datos de Contacto');?></h4>
          </div>
          <div class="panel-body">
            <p> <?php echo __('Email');?> : <?php echo $datos_empresa['email'];?> <?php if (!empty($datos_empresa['telefono_1'])){?><br>
              <br>
              <?php echo __('Teléfono');?> : <?php echo $datos_empresa['telefono_1'];?><?php } ?> <?php if (!empty($datos_empresa['telefono_2'])){?><br>
              <br>
              <?php echo __('Móvil');?> : <?php echo $datos_empresa['telefono_2'];?> <?php } ?></p>
            <?php /*?><h4>Payment should be mabe by Bank Transfer</h4><?php */?>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
</body>
</html>