<?php
defined('CONF_URL_APP') or die;
class ClienteShop extends EntidadModel
{
	protected $dbt_const = "DBT_SHOP_CLIENTES";
	protected $dbt = "shop_clientes";
	
	protected $ext_folder = "ext_shop";
	
	protected $all_vars = array("id","id_usuario","email","datos_facturacion","datos_envio","direccion_envio_igual_facturacion","envio_calculado","estado","fecha");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("id_usuario","email","datos_facturacion","datos_envio","direccion_envio_igual_facturacion","envio_calculado","estado");
	
	protected $campos_multilang = array();
	protected $campos_array = array("datos_facturacion","datos_envio");
	
	public function __construct() {
		parent::__construct();
	}
	
	function BuscarIdUsuario()
    {
        if ($this->id_usuario) {
            $link = new DB();
            $i    = 0;
            $sql  = "
					SELECT 
						*
						
					FROM
						" . DBT_SHOP_CLIENTES . "
						
					WHERE
						id_usuario = " . $this->id_usuario;
            $res  = $link->Query($sql);
            $x    = $link->FetchArray($res);
            $aux  = new ClienteShop();
			$a = $this->get_classvars();
            foreach ($a as $clave) {
                $aux->$clave = $this->filtroSalida($x[$clave]);
            }
			$aux->getInfo();
            $link->Desconectar();
            if (!isset($aux->id)) {
                return false;
            } else {
                return $aux;
            }
        } else {
            return false;
        }
    }
    
	function getUsuarioMideas(){
		if (empty($this->id_usuario))
			return false;
			
		c_include('usuario');
		$usuario_mideas = new Usuario();
		$usuario_mideas->setid($this->id_usuario);
		if ($usuario_mideas = $usuario_mideas->BuscarId()){
			return $usuario_mideas;
		} else {
			return false;
		}
	}
	private function parsea_datos(){
		if (empty($this->id) || empty($this->datos_facturacion) || empty($this->datos_envio))
			return false;
			
		$datos_facturacion = Helpers::toArray(json_decode($this->datos_facturacion));
		$datos_envio = Helpers::toArray(json_decode($this->datos_envio));
		
		if (!empty($datos_facturacion) && is_array($datos_facturacion)){
			foreach ($datos_facturacion as $key=>$val){
				$this->facturacion->$key = $val;
			}
		}
		
		if (!empty($datos_envio) && is_array($datos_envio)){
			foreach ($datos_envio as $key1=>$val1){
				$this->envio->$key1 = $val1;
			}
		}
		
		c_include('loc/localidad','loc/provincia','loc/pais');
		
		if (!empty($this->facturacion->localidad)){
			if (is_numeric($this->facturacion->localidad)){
				$this->facturacion->localidad_label = Localidad::BuscarObjPorId($this->facturacion->localidad);
				if ($this->facturacion->localidad_label instanceof Localidad)
					$this->facturacion->localidad_label = $this->facturacion->localidad_label->getlocalidad();
				else
					$this->facturacion->localidad_label = __("Sin localidad");
			} else {
				$this->facturacion->localidad_label = $this->facturacion->localidad;
			}
		}
		
		if (!empty($this->facturacion->provincia)){	
			if (is_numeric($this->facturacion->provincia)){
				$this->facturacion->provincia_label = Provincia::BuscarObjPorId($this->facturacion->provincia);
				if ($this->facturacion->provincia_label instanceof Provincia)
					$this->facturacion->provincia_label = $this->facturacion->provincia_label->getprovincia();
				else
					$this->facturacion->provincia_label = __("Sin provincia");
					
			} else {
				$this->facturacion->provincia_label = $this->facturacion->provincia;
			}
			
		}
		
		if (!empty($this->facturacion->pais)){	
			$this->facturacion->pais_label = Pais::BuscarPorISO2($this->facturacion->pais);
			if ($this->facturacion->pais_label instanceof Pais)
				$this->facturacion->pais_label = $this->facturacion->pais_label->getpais();
			else
				$this->facturacion->pais_label = __("Sin país");
			
		}
		
	}
	function setsesion(){
		if (is_object($this->datos_facturacion)){
			$datos_facturacion = get_object_vars($this->datos_facturacion);
		} elseif (is_string($this->datos_facturacion)){
			$datos_facturacion = Helpers::toArray(json_decode($this->datos_facturacion));
		}
		
		$sess_usr = array();
		
		if (is_array($datos_facturacion) && sizeof($datos_facturacion) > 0){
			foreach ($datos_facturacion as $kdf=>$df){
				$sess_usr[$kdf] = $df;
			}
		}
		
		$sess_usr["envio_igual_facturacion"] = $this->direccion_envio_igual_facturacion;
		
		if ($this->direccion_envio_igual_facturacion == '0'){
			if (is_object($this->datos_envio)){
				$datos_envio = get_object_vars($this->datos_envio);
			} elseif (is_string($this->datos_envio)){
				$datos_envio = Helpers::toArray(json_decode($this->datos_envio));
			}
			
			if (is_array($datos_envio) && sizeof($datos_envio) > 0){
				foreach ($datos_envio as $kde=>$de){
					$sess_usr[$kde] = $de;
				}
			}
		}
		
		Helpers::getSesion()->set('shop.usuario', $sess_usr);
	}
    public function getInfo(){
		$this->parsea_datos();
	}
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }
    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
}
?>