<?php
e_include('ext_shop/class/reglaPrecioCondicion');
class CestaPesoTotalReglaPrecioCondicion extends ReglaPrecioCondicion
{
	protected $grupo = 'cesta';
	protected $id = 'pesoTotal';
	protected $nombre = 'Peso total de la cesta';
	
	
	public function __construct($operacion, $valor){
		if ($this->checkOperacion($operacion) && $this->checkValor($valor)){
			$this->resultado = $this->checkCondicion($operacion,$valor);
		}
	}
	
	private function checkCondicion($op,$val){
		$peso_carrito = $this->getPesoTotalFromSesion();
		
		if (!empty($peso_carrito) && $this->evaluaOperacion((float) $peso_carrito, (float) $val, $op)){
			return true;
		} else {
			return false;
		}
	}
	
	private function getPesoTotalFromSesion(){
		return Helpers::getSesion()->get('shop.contenido_carrito_peso');
	}
}