<?php
e_include('ext_shop/class/reglaPrecioCondicion');
class CestaTotalReglaPrecioCondicion extends ReglaPrecioCondicion
{
	protected $grupo = 'cesta';
	protected $id = 'total';
	protected $nombre = 'Importe total de la cesta';
	
	
	public function __construct($operacion, $valor){
		if ($this->checkOperacion($operacion) && $this->checkValor($valor)){
			$this->resultado = $this->checkCondicion($operacion,$valor);
		}
	}
	
	private function checkCondicion($op,$val){
		$subtotal_carrito = $this->getTotalFromSesion();
		if (!empty($subtotal_carrito) && $this->evaluaOperacion((float) $subtotal_carrito, (float) $val, $op)){
			return true;
		} else {
			return false;
		}
	}
	
	private function getTotalFromSesion(){
		return Helpers::getSesion()->get('shop.subtotal');
	}
}