<?php
e_include('ext_shop/class/reglaPrecioCondicion');
class ClienteCuponDescuentoReglaPrecioCondicion extends ReglaPrecioCondicion
{
	protected $grupo = 'cliente';
	protected $id = 'cuponDescuento';
	protected $nombre = 'Cupón de descuento';
	
	
	public function __construct($operacion, $valor){
		if ($this->checkOperacion($operacion) && $this->checkValor($valor)){
			$this->resultado = $this->checkCondicion($operacion,$valor);
		}
	}
	
	private function checkCondicion($op,$val){
		$cupones_aplicados_sesion = Helpers::getSesion()->get('shop.cupones_aplicados');
		
		if (!is_array($cupones_aplicados_sesion) || sizeof($cupones_aplicados_sesion) == 0)
			return false;
			
		foreach ($cupones_aplicados_sesion as $codigo_cupon=>$cupon){
			if ($this->evaluaOperacion($codigo_cupon, $val, $op)){
				return true;
			}
		}
		
		return false;
	}
}