<?php
/**
 * PayPal Standard Payment Gateway
 *
 * Provides a PayPal Standard Payment Gateway.
 *
 * @class 		PagoPaypal
 * @extends		MetodoPago
 * @version		1.0.0
 * @package		Shop/Classes/Payment
 * @author 		Mideas
 */
 defined('CONF_URL_APP') or die;
 
class ConectoresExtensionesArticulos extends ShopConector {
	public function __construct() {
		$this->id = 'articulos';
		$this->titulo = __('Artículos');
		$this->extension = 'ext_articulos';
		$this->acciones = array(	
									'nuevo_articulo_desde_categoria',
									'permisos_categoria'
								);
	}
	
	function admin_fields_nuevo_articulo_desde_categoria(){
		$fields = array();
		
		$fields = array(	
							'opciones_permisos_categoria' => array(
													'titulo' => __( 'Opciones de la acción: Nuevo artículo desde categoría' ),
													'type' => 'titulo',
													'descripcion' => '',
												),
							'categoria' => array(
													'titulo' => 'categoria',
													'type' => 'categoriaslist',
													'label' => __('Categoría'),
													'descripcion' => __('Categoría de artículos'),
													'attributes'	=>	array('multicheck' => 'false')
												)
					);
						
		$output = $this->generate_settings_html ( $fields );
		
		return $output;
	}
	
	function admin_fields_permisos_categoria(){
		$fields = array();
		
		$fields = array(	
							'opciones_permisos_categoria' => array(
													'titulo' => __( 'Opciones de la acción: Permisos para categoría' ),
													'type' => 'titulo',
													'descripcion' => '',
												),
							'categoria' => array(
													'titulo' => 'categoria',
													'type' => 'categoriaslist',
													'label' => __('Categoría'),
													'descripcion' => __('Categoría de artículos'),
													'attributes'	=>	array('multicheck' => 'false')
												),
							'nivel_acceso' => array(
													'titulo' => 'nivel_acceso',
													'type' => 'list',
													'label' => __('Nivel de acceso'),
													'descripcion' => __('Nuevo nivel de acceso'),
													'options'	=>	array('1' => '1', '2' => '2')
												)
					);
						
		$output = $this->generate_settings_html ( $fields );
		
		return $output;
	}
	
}