<?php    
/**
 * Clase Envio
 * 
 * Maneja los envíos
 *
 * @class 		Envio
 * @package		Shop
 * @category	Envío
 * @author		Mideas
 */  
defined('CONF_URL_APP') or die;
class Envio {
	
	var $activo			= false;
	var $metodos_envio 	= array();
	var $metodo_elegido		= null;
	var $envio_total 	= 0;
	var $envio_impuestos		= array();
	var $envio_nombre		= null;
	var $envio_tasa_manipulacion		= null;
	var $tipos_envio;
	var $tipo_envio			= null;
	var $paquetes			= array();
    /**
     * init function.
     * 
     * Init the envio - load methods and reorder based on settings.
     *
     * @access public
     */
    function init() {
		
		$config_shop = $GLOBALS['opciones']['ext_shop'];
		
		$this->activo = ( $config_shop['envios']['activar_envios'] == '0' ) ? false : true;
		
		$usr_sess = Helpers::getSesion()->get('shop.usuario');
		
		if ($usr_sess['envio_igual_facturacion'] == '0'){
			$pais_usr = $usr_sess['envio_pais'];
			$prov_usr = $usr_sess['envio_provincia'];
			$codigo_postal_usr = $usr_sess['envio_codigo_postal'];
		} else {
			$pais_usr = $usr_sess['pais'];
			$prov_usr = $usr_sess['provincia'];
			$codigo_postal_usr = $usr_sess['codigo_postal'];
		}
		
		if (empty($prov_usr))
			$prov_usr = 0;
		
		$localizacion_usr = $pais_usr.'.'.$prov_usr;
		
		//do_action('woocommerce_envio_init');
		
		$pais_metodo = array();
		if (!empty($pais_usr)){
			$pais_metodo[] = $localizacion_usr;
			$pais_metodo[] = $pais_usr.'.0';
		} else {
			
			global $paises_defecto_shop;
			
			if (is_array($paises_defecto_shop)){
				$pais_metodo = $paises_defecto_shop;
			} else {
				$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
				$pais_metodo = $paises_defecto_shop;
			}
		}
		
		if (!empty($codigo_postal_usr)){
			$where_lm = "codigo_postal='' OR codigo_postal = '".$codigo_postal_usr."'";
		} else {
			$where_lm = "codigo_postal=''";
		}
		
		$load_methods = new EnvioShop();
		$load_methods = $load_methods->Listar($where_lm,'coste','ASC');
		
		$load_methods_tmp = array();
		
		foreach ($load_methods as $lm){
			if ($lm->zona != "0"){
				e_include("ext_shop/class/zonaEnvios");
				$zona = new ZonaEnviosShop();
				$zona->setid($lm->zona);
				if ($zona = $zona->BuscarId()){
					$paises_lm = json_decode($zona->paises);
				} else {
					$paises_lm = json_decode($lm->paises);
				}
			} else {
				$paises_lm = json_decode($lm->paises);
			}
			
			foreach ($paises_lm as $plm){
				if (in_array($plm, $pais_metodo)){
					$load_methods_tmp[] = $lm;
					continue;
				}
			}
		}
		
		$load_methods = $load_methods_tmp;
				
		/*$load_methods = array('TarifaPlana');
		e_include('ext_shop/class/envio/tarifaPlana');
		
		// Get order option
		$ordering 	= array(1=>1);*/
		$order_end 	= 999;
		
		// Load gateways in order
		foreach ( $load_methods as $method ) {
			e_include('ext_shop/class/envio/'.$method->metodo_envio);
			
			$metodoClass = $method->metodo_envio;
			
			if (!class_exists($metodoClass)){
				include(CONF_REALPATH_APP.'extensions/ext_shop/class/envio/'.$metodoClass.'.class.php');
			}
			
			$load_method = new $metodoClass();
			$load_method->db_object = $method;
			$load_method->init();
			
			if ( isset( $ordering[$load_method->id] ) && is_numeric( $ordering[$load_method->id] ) ) {
				// Add in position
				$this->metodos_envio[$ordering[$load_method->id]] = $load_method;
			} else {
				// Add to end of the array
				$this->metodos_envio[$order_end] = $load_method;
				$order_end++;
			}
		}
				
	}
	/**
	 * get_tipos_envio function.
	 * 
	 * Load envio tipos taxonomy terms.
	 *
	 * @access public
	 * @return array
	 */
	function get_tipos_envio() {
		if ( ! is_array( $this->tipos_envio ) ) :
			
			$tipos = array();
			
			$this->tipos_envio = ($tipos) ? $tipos : array();
				
		endif;
		
		return (array) $this->tipos_envio;
	}	
	
	/**
	 * calcular_envio function.
	 *
	 * Calculate envio for (multiple) paquetes of cart items. 
	 * 
	 * @access public
	 * @param array $paquetes multi-dimentional array of cart items to calc envio for
	 */
	function calcular_envio( $paquetes = array() ) {
		if ( ! $this->activo ) return;
		if ( empty( $paquetes ) ) return;
		
		$this->envio_total 	= 0;
		$this->envio_impuestos 	= array();
		$this->envio_nombre 	= null;
		$this->envio_tipo 	= null;
		$this->envio_tasa_manipulacion 	= null;
		$this->paquetes 		= array();
		$_coste_mas_barato = $_metodo_mas_barato = $metodo_elegido = '';
		
		$_metodo_env_elegido = Helpers::getSesion()->get('shop._metodo_envio_elegido');
		
		if ( !empty( $_metodo_env_elegido ) ) 
			$metodo_elegido = Helpers::getSesion()->get('shop._metodo_envio_elegido');
				
		// Calculate costes for passed paquetes
		$paquete_keys 		= array_keys( $paquetes );
		$paquete_keys_size 	= sizeof( $paquete_keys );
		
		for ( $i=0; $i < $paquete_keys_size; $i++ ) 
			$this->paquetes[$paquete_keys[$i]] = $this->calcular_envio_por_paquete( $paquetes[$paquete_keys[$i]] );
			
		// Get available methods (in this case methods for all paquetes)
		$_metodos_disponibles = $this->get_metodos_envio_disponibles();
		
		if ( sizeof( $_metodos_disponibles ) > 0 ) {
			
			// If not set, set a default
			//if ( empty( $metodo_elegido ) || ! isset( $_metodos_disponibles[$metodo_elegido] ) ) {
				
				//$metodo_elegido = get_option('woocommerce_metodo_envio_defecto');
				
				//if ( empty( $metodo_elegido ) || ! isset( $_metodos_disponibles[$metodo_elegido] ) ) {
				
					// Default to cheapest
					foreach ( $_metodos_disponibles as $method_id => $method ) {
						if ( $method->coste < $_coste_mas_barato || ! is_numeric( $_coste_mas_barato ) ) {
							$_coste_mas_barato 	= $method->coste;
							$_metodo_mas_barato 	= $method_id;
						}
					}
					
					$metodo_elegido = $_metodo_mas_barato;
				//}
			
			//}
			
			if ( $metodo_elegido ) {
				Helpers::getSesion()->set('shop._metodo_envio_elegido', $metodo_elegido);
				$this->envio_total 	= $_metodos_disponibles[$metodo_elegido]->coste;
				$this->envio_impuestos 	= $_metodos_disponibles[$metodo_elegido]->impuestos;
				$this->envio_nombre 	= $_metodos_disponibles[$metodo_elegido]->nombre;
				$this->envio_tasa_manipulacion 	= $_metodos_disponibles[$metodo_elegido]->tasa_manipulacion;
				$this->envio_tipo 	= $_metodos_disponibles[$metodo_elegido]->tipo;
				
			}
		}
	}
	/**
	 * calcular_envio_por_paquete function.
	 *
	 * Calculates each envio methods coste. Rates are cached based on the paquete to speed up calculations.
	 * 
	 * @access public
	 * @param array $paquete cart items
	 */
	function calcular_envio_por_paquete( $paquete = array() ) {
		if ( ! $this->activo ) return false;
		if ( ! $paquete ) return false;
		
		// Calculate envio method tarifas
		$paquete['tarifas'] = array();
		
		foreach ( $this->metodos_envio as $metodo_envio ) {
			
			if ( $metodo_envio->is_available( $paquete ) ) {
				
				// Reset Rates
				$metodo_envio->tarifas = array();
				
				// Calculate Shipping for paquete
				$metodo_envio->calcular_envio( $paquete );
				
				// Place tarifas in paquete array
				if ( ! empty( $metodo_envio->tarifas ) && is_array( $metodo_envio->tarifas ) )
					foreach ( $metodo_envio->tarifas as $tarifa ) 
						$paquete['tarifas'][$tarifa->id] = $tarifa;
			}
			
		}
		
		return $paquete;
	}
	
	/**
	 * get_metodos_envio_disponibles function.
	 *
	 * Gets all available envio methods which have tarifas. 
	 *
	 * @todo Currently we support 1 envio method per order so this function merges tarifas - in the future we should offer
	 * 1 tarifa per paquete and list them accordinly for user selection
	 * 
	 * @access public
	 * @return array
	 */
	function get_metodos_envio_disponibles() {
		if ( ! $this->activo ) return;
		if ( empty( $this->paquetes ) ) return;
		
		// Loop paquetes and merge tarifas to get a total for each envio method
		$metodos_disponibles = array();
		foreach ( $this->paquetes as $paquete ) {
			
			if ( ! $paquete['tarifas'] ) continue;
			
			foreach ( $paquete['tarifas'] as $id => $tarifa ) {
				if ( isset( $metodos_disponibles[$id] ) ) {
					// Merge coste and impuestos - label and ID will be the same
					$metodos_disponibles[$id]->coste += $tarifa->coste;
					
					foreach ( array_keys( $metodos_disponibles[$id]->impuestos + $tarifa->impuestos ) as $key ) {
					    $metodos_disponibles[$id]->impuestos[$key] = ( isset( $tarifa->impuestos[$key] ) ? $tarifa->impuestos[$key] : 0 ) + ( isset( $metodos_disponibles[$id]->impuestos[$key] ) ? $metodos_disponibles[$id]->impuestos[$key] : 0 );
					}
				} else {
					$metodos_disponibles[$id] = new TarifaEnvioShop( $tarifa->id, $tarifa->nombre, $tarifa->coste, $tarifa->impuestos, $tarifa->tipo );
				}
								
			}
			
		}
				
		return $metodos_disponibles;
	}
	/**
	 * reset_envio function.
	 * 
	 * Reset the totals for envio as a whole.
	 *
	 * @access public
	 * @return void
	 */
	function reset_envio() {
		Helpers::getSesion()->clear('shop._metodo_envio_elegido');
		$this->envio_total = 0;
		$this->envio_impuestos = array();
		$this->envio_nombre = null;
		$this->envio_tipo = null;
		$this->paquetes = array();
	}
		
}