<?php
defined('CONF_URL_APP') or die;
class FacturaShop extends EntidadModel
{
    protected $dbt_const = "DBT_SHOP_FACTURAS";
    protected $dbt = "shop_facturas";
    protected $ext_folder = "ext_shop";
    protected $all_vars = array("id", "codigo", "titulo", "ejercicio", "usuario_id", "datos_facturacion", "creador_id", "pedido_id", "estado", "fecha", "vencimiento", "comentarios", "base_imponible", "total_descuento", "percent_descuento", "total_impuesto", "total_recargo", "percent_recargo", "total_retencion", "percent_retencion", "total", "forma_pago", "params");
    protected $idx_vars = array("id");
    protected $update_vars = array("codigo", "titulo", "ejercicio", "usuario_id", "datos_facturacion", "creador_id", "pedido_id", "estado", "fecha", "vencimiento", "comentarios", "base_imponible", "total_descuento", "percent_descuento", "total_impuesto", "total_recargo", "percent_recargo", "total_retencion", "percent_retencion", "total", "forma_pago", "params");
    protected $campos_multilang = array();
    protected $campos_array = array("datos_facturacion");
    public $lineas;
    public function __construct($id_factura = '', $ejercicio_factura = '')
    {
        parent::__construct();
        if (!empty($id_factura) && !empty($ejercicio_factura)) {
            $this->setid($id_factura);
            if ($this->id) {
                $link = new DB();
                $i    = 0;
                $sql  = "
						SELECT * FROM " . DBT_SHOP_FACTURAS . " WHERE id = " . $this->id . " AND ejercicio = " . $this->ejercicio;
                $res  = $link->Query($sql);
                $x    = $link->FetchArray($res);
                $a    = get_class_vars(get_class($this));
                foreach ($a as $clave => $estado) {
                    $this->$clave = $this->filtroSalida($x[$clave]);
                }
                $this->getInfo();
                $link->Desconectar();
            }
        }
    }
    function includes()
    {
        e_include('ext_shop/class/facturaLineaShop');
    }
    function calcular_siguiente_id($ejercicio)
    {
        if (empty($ejercicio))
            $ejercicio = strftime("%Y");
        $link = new DB();
        $sql  = "SELECT codigo FROM " . DBT_SHOP_FACTURAS . " WHERE ejercicio = '" . $ejercicio . "' ORDER BY codigo DESC LIMIT 0,1";
        $res  = $link->Query($sql);
        $x    = $link->FetchArray($res);
        return (int) $x['codigo'] + 1;
    }
    function getLink($url_amigable = false, $lang = null)
    {
        if (empty($lang))
            $lang = SistemaIdioma::getIdiomaSesion();
        $link = '';
        if ($GLOBALS['opciones']['metadatos']['urls_amigables_metadatos'] == 0 && $url_amigable == false) {
            $link .= "?extension=ext_shop&vista=factura&id=" . $this->id;
            $parametros = Helpers::toArray(json_decode($this->params));
            if (!empty($parametros['estilo'])) {
                $link .= '&estilo=' . $parametros['estilo'];
            } else {
                $parametros['estilo'] = '';
            }
            $link .= '&lang=' . $lang;
        } else {
            c_include('enlace');
            $enlace_bd   = new Enlace();
            $enlace_bd_c = $enlace_bd->ListarCount("tipo='ext_shop' AND vista='factura' AND id_elemento='" . $this->id . "'");
            if ($enlace_bd_c > 0) {
                $enlace_bd = $enlace_bd->Listar("tipo='ext_shop' AND vista='factura' AND id_elemento='" . $this->id . "'");
                $link      = $enlace_bd[0]->printLink(1);
                return $link;
            }
            $params_link      = array();
            $enlace_cat_sel   = new Enlace();
            $enlace_cat_sel_c = $enlace_cat_sel->ListarCount("tipo='ext_shop' AND vista='lista_facturas'");
            if ($enlace_cat_sel_c > 0) {
                $enlace_cat_sel = $enlace_cat_sel->Listar("tipo='ext_shop' AND vista='lista_facturas'");
                $enlace_cat_sel = $enlace_cat_sel[0];
                $link           = $enlace_cat_sel->printLink(1, SistemaIdioma::getIdiomaSesion()) . '/' . $this->id;
                return $link;
            }
            $link .= Helpers::ArmaURLAmigable('ext_shop', 'producto', $this->id, $this->id, $parametros['estilo'], $lang);
        }
        return $link;
    }
    function loadLineas()
    {
        if (empty($this->id))
            return false;
        if (empty($this->lineas)) {
            $lineas   = new FacturaLineaShop();
            $where    = "factura_id='" . $this->id . "' AND ejercicio='" . $this->ejercicio . "'";
            $lineas_c = $lineas->ListarCount($where);
            if ($lineas_c > 0) {
                $lineas       = $lineas->Listar($where, 'orden', 'ASC');
                $this->lineas = $lineas;
                return true;
            } else {
                return false;
            }
        } else {
            return true;
        }
    }
    function getIDPedidosFacturados()
    {
        $link = new DB();
        $i    = 0;
        $sql  = "SELECT pedido_id FROM " . DBT_SHOP_FACTURAS . " WHERE pedido_id > 0 GROUP BY pedido_id";
        $arr  = array();
        $res  = $link->Query($sql);
        while ($x = $link->FetchArray($res)) {
            if (!empty($x["pedido_id"])) {
                $arr[] = $x["pedido_id"];
            }
        }
        return $arr;
    }
    function exportarFacturas($tipo = 'browser', $archivo = 'facturas.xls', $fecha_inicio, $fecha_fin)
    {
        c_include('helpers/exportData');
        e_include('ext_shop/class/cliente', 'ext_shop/class/pedidoShop', 'ext_shop/class/producto');
        $fs                   = new self();
        $facturas_disponibles = $fs->Listar("", "id", "ASC");
        if (is_array($facturas_disponibles) && sizeof($facturas_disponibles) > 0) {
            $exporter = new ExportDataExcel($tipo, $archivo);
            $exporter->initialize(); // starts streaming data to web browser
            foreach ($facturas_disponibles as $factura) {
                $pedido_obj = '';
                if (!empty($factura->pedido_id)) {
                    $pedido_obj = new PedidoShop();
                    $pedido_obj->setid($factura->pedido_id);
                    $pedido_obj                      = $pedido_obj->BuscarId();
                    $total_envio_pedido              = $pedido_obj->datos['total']['envio_total'];
                    $total_impuesto_envio_pedido     = $pedido_obj->datos['total']['envio_impuesto_total'];
                    $total_productos_pedido          = $pedido_obj->datos['total']['subtotal_ex_impuesto'];
                    $total_impuesto_productos_pedido = $pedido_obj->datos['total']['impuesto_total'];
                }
                $cliente_factura = new Usuario();
                $cliente_factura->setid($factura->usuario_id);
                $cliente_factura = $cliente_factura->BuscarId();
                $fecha_factura   = strftime("%d/%m/%Y", strtotime($factura->fecha));
                $modelo_factura  = array(
                    $factura->codigo,
                    $fecha_factura,
                    $factura->base_imponible - $total_envio_pedido,
                    $factura->total_impuesto - $total_impuesto_envio_pedido,
                    $factura->total_descuento,
                    $factura->total - $total_envio_pedido - $total_impuesto_envio_pedido,
                    $total_envio_pedido,
                    $total_impuesto_envio_pedido,
                    $total_envio_pedido + $total_impuesto_envio_pedido,
                    $factura->total,
                    $factura->forma_pago,
                    $cliente_factura->id
                );
                $header_factura  = array(
                    "cod. factura",
                    "fecha",
                    "base imponible",
                    "total impuestos",
                    "total descuento",
                    "total productos",
                    "base imponible envío",
                    "impuestos envío",
                    "total envío",
                    "total",
                    "forma de pago",
                    "cod. cliente"
                );
                $campos_cliente  = Helpers::toArray(json_decode($this->datos_facturacion));
                if (is_array($campos_cliente) && sizeof($campos_cliente) > 0) {
                    foreach ($campos_cliente as $kcc => $cc) {
                        if ($kcc == 'provincia') {
                            c_include('loc/provincia');
                            $prov_obj = new Provincia();
                            $prov_obj->setid($cc);
                            $prov_obj             = $prov_obj->BuscarId();
                            $campos_cliente[$kcc] = $prov_obj->getprovincia();
                        } elseif ($kcc == 'localidad') {
                            c_include('loc/localidad');
                            $loc_obj = new Localidad();
                            $loc_obj->setid($cc);
                            $loc_obj              = $loc_obj->BuscarId();
                            $campos_cliente[$kcc] = $loc_obj->getlocalidad();
                        }
                        $modelo_factura[] = $campos_cliente[$kcc];
                        $header_factura[] = $kcc;
                    }
                }
                $exporter->addRow($header_factura);
                $exporter->addRow($modelo_factura);
                $factura->loadLineas();
                $lineas_factura = $factura->lineas;
                if (is_array($lineas_factura) && sizeof($lineas_factura) > 0) {
                    $exporter->addRow(array());
                    $header_linea_factura = array(
                        "cod. factura",
                        "cod. producto",
                        "cod. producto base datos",
                        "producto",
                        "cantidad",
                        "precio unidad",
                        "subtotal línea",
                        "impuestos línea",
                        "total línea"
                    );
                    $exporter->addRow($header_linea_factura);
                    foreach ($lineas_factura as $linea) {
                        $obj_producto = unserialize($linea->data);
                        if (empty($obj_producto->id)) {
                            $obj_producto = new Producto();
                            $obj_producto->setid($linea->producto_id);
                            $obj_producto = $obj_producto->BuscarId();
                        }
                        $modelo_linea_factura = array(
                            $linea->factura_id,
                            $obj_producto->sku,
                            $obj_producto->id,
                            $linea->nombre_producto,
                            $linea->cantidad,
                            number_format($linea->linea_total / $linea->cantidad, 2),
                            $linea->linea_total,
                            $linea->linea_impuesto,
                            $linea->linea_total + $linea->linea_impuesto
                        );
                        $exporter->addRow($modelo_linea_factura);
                    }
                    $exporter->addRow(array());
                    $exporter->addRow(array());
                }
            }
            $exporter->finalize(); // writes the footer, flushes remaining data to browser.
        }
        exit(); // all done
    }
    function descargar($formato = 'pdf', $force = false)
    {
        if (empty($formato))
            return false;
        $datos_empresa = $GLOBALS["opciones"]["ext_shop"]["empresa"];
        c_include('loc/localidad', 'loc/provincia', 'loc/pais');
        $datos_empresa["localidad"] = Localidad::BuscarObjPorId($datos_empresa["localidad"]);
        if ($datos_empresa["localidad"] instanceof Localidad)
            $datos_empresa["localidad"] = $datos_empresa["localidad"]->getlocalidad();
        else
            $datos_empresa["localidad"] = __("Sin localidad");
        $datos_empresa["provincia"] = Provincia::BuscarObjPorId($datos_empresa["provincia"]);
        if ($datos_empresa["provincia"] instanceof Provincia)
            $datos_empresa["provincia"] = $datos_empresa["provincia"]->getprovincia();
        else
            $datos_empresa["provincia"] = __("Sin provincia");
        $datos_empresa["pais"] = Pais::BuscarPorISO2($datos_empresa["pais"]);
        if ($datos_empresa["pais"] instanceof Pais)
            $datos_empresa["pais"] = $datos_empresa["pais"]->getpais();
        else
            $datos_empresa["pais"] = __("Sin país");
        e_include('ext_shop/class/cliente');
        $cliente = new Usuario();
        $cliente->setid($this->usuario_id);
        $cliente           = $cliente->BuscarId();
        $datos_facturacion = Helpers::toArray(json_decode($this->datos_facturacion));
        if (is_numeric($datos_facturacion["provincia"])) {
            $prov_tm = Provincia::BuscarObjPorId($datos_facturacion["provincia"]);
            if ($prov_tm instanceof Provincia) {
                $datos_facturacion["provincia_label"] = $prov_tm->getprovincia();
            } else {
                $datos_facturacion["provincia_label"] = $datos_facturacion["provincia"];
            }
        } else {
            $datos_facturacion["provincia_label"] = $datos_facturacion["provincia"];
        }
        if (is_string($datos_facturacion["pais"]) && strlen($datos_facturacion["pais"]) == 2) {
            $pais_tm = Pais::BuscarPorISO2($datos_facturacion["pais"]);
            if ($pais_tm instanceof Pais) {
                $datos_facturacion["pais_label"] = $pais_tm->getpais();
            } else {
                $datos_facturacion["pais_label"] = $datos_facturacion["pais"];
            }
        } else {
            $datos_facturacion["pais_label"] = $datos_facturacion["pais"];
        }
        if (!empty($datos_facturacion['Escalera']))
            $datos_facturacion['direccion'] .= ', ' . $datos_facturacion['Escalera'];
        if (!empty($datos_facturacion['Piso']))
            $datos_facturacion['direccion'] .= ', ' . $datos_facturacion['Piso'];
        if (!empty($datos_facturacion['Puerta']))
            $datos_facturacion['direccion'] .= ', ' . $datos_facturacion['Puerta'];
        $factura = $this;
        $factura->loadLineas();
        e_include('ext_shop/class/pago');
        $metodos_pago = new Pago();
        $metodo_pago  = '';
        if (is_array($metodos_pago->pasarelas_pago) && sizeof($metodos_pago->pasarelas_pago) > 0) {
            foreach ($metodos_pago->pasarelas_pago as $kpp => $pp) {
                if ($kpp == $factura->forma_pago) {
                    $metodo_pago = $pp;
                    continue;
                }
            }
        }
        $instrucciones_pp = $metodo_pago->settings['instrucciones'][SistemaIdioma::getIdiomaSesion()];
        $ruta_plantilla   = CONF_REALPATH_APP . $GLOBALS['opciones']['ext_shop']['venta']['plantilla_facturas'];
        if (is_file($ruta_plantilla)) {
            ob_start();
            require $ruta_plantilla;
            $html = ob_get_contents();
            ob_end_clean();
        } else {
            $html = '<!DOCTYPE html>
				<html>
				<head>
				<meta charset="utf-8">
				<title>Factura</title>
				<style type="text/css">
				<!--
				body {
				  font-family:Tahoma;
				}
				
				img {
				  border:0;
				}
				
				#page {
				  width:800px;
				  margin:0 auto;
				  padding:15px;
				
				}
				
				#logo {
				  float:left;
				  margin:0;
				}
				
				#address {
				  height:181px;
				  margin-left:250px; 
				}
				
				table {
				  width:100%;
				}
				
				td {
				padding:5px;
				}
				
				tr.odd {
				  background:#e1ffe1;
				}
				-->
				</style>
				</head>
				<body>
				<div id="page">
				  <div id="logo">
					<a href="' . CONF_URL_APP . '"><img src="' . CONF_URL_APP . $datos_empresa["logotipo"] . '"></a>
				  </div><!--end logo-->
				  
				  <div id="address">
				
					<p><strong>' . htmlentities($datos_empresa["razon_social"]) . '</strong><br />
					' . htmlentities($datos_empresa["nif_cif"]) . '<br />
					' . htmlentities($datos_empresa['direccion']) . '<br />
					' . htmlentities($datos_empresa['codigo_postal']) . ' ' . htmlentities($datos_empresa['localidad']) . '<br />
					' . htmlentities($datos_empresa['provincia']) . ' (' . htmlentities($datos_empresa['pais']) . ')<br />
					<a href="mailto:' . $datos_empresa["email"] . '">' . $datos_empresa["email"] . '</a><br />
					
					<br /><br />
					' . sprintf(__('Factura # %s'), $this->id . '/' . $this->ejercicio) . '<br />
					' . __('Fecha') . ': ' . strftime("%d/%m/%Y", $this->fecha) . '<br />
					</p>
				
				  </div><!--end address-->
				
				  <div id="content">
					<p>
					  <strong>' . __('Datos del cliente') . '</strong><br />
					  ' . __('Nombre') . ': Apellidos, Nombre<br />
					  Email: customeremail@somewhere.com<br />
					  ' . __('Forma de pago') . ': ' . htmlentities($this->forma_pago) . '    </p>
				
					<hr>
					<table>
					  <tr><td><strong>Description</strong></td><td><strong>Qty</strong></td><td><strong>Unit Price</strong></td><td><strong>Amount</strong></td></tr>
					  <tr class="odd"><td>Product 1</td><td>1</td><td>4.95</td><td>4.95</td></tr><tr class="even"><td>Product 2</td><td>1</td><td>4.95</td><td>4.95</td></tr><tr class="odd"><td>Product 3</td><td>1</td><td>4.95</td><td>4.95</td></tr>              <tr><td>&nbsp;</td><td>&nbsp;</td><td><strong>Total</strong></td><td><strong>14.85</strong></td></tr>
				
					</table>
					<hr>
					<p>
					  Thank you for your order!  This transaction will appear on your billing statement as "Your Company".<br />
					  If you have any questions, please feel free to contact us at <a href="mailto:youremail@somewhere.com">youremail@somewhere.com</a>.
					</p>
				
					<hr>
				
					<p>
					  <center><small>This communication is for the exclusive use of the addressee and may contain proprietary, confidential or privileged information. If you are not the intended recipient any use, copying, disclosure, dissemination or distribution is strictly prohibited.
					  <br /><br />
					  &copy; Your Company All Rights Reserved
					  </small></center>
					</p>
				  </div><!--end content-->
				</div><!--end page-->
				</body>
				
				</html>';
        }
        switch ($formato) {
            case 'email':
				$titulo_pdf = $this->codigo . '-' . $this->ejercicio . '_' . Helpers::parseaTexto($this->titulo);
				if ($titulo_pdf == $this->codigo . '-' . $this->ejercicio . '_'){
					$titulo_pdf = 'factura_' . $this->codigo . '_' . $this->ejercicio;
				}
				if (!is_dir(CONF_REALPATH_APP . 'uploads/pdf')){
					Helpers::ftpCrearCarpeta(CONF_REALPATH_APP . 'uploads/pdf');
				}
				if (!is_dir(CONF_REALPATH_APP . 'uploads/facturas')){
					Helpers::ftpCrearCarpeta(CONF_REALPATH_APP . 'uploads/facturas');
				}
                if (!file_exists(CONF_REALPATH_APP . 'uploads/pdf/' . $titulo_pdf . '.pdf') || $force == true) {
                    if (!file_exists(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html') || $force == true) {
                        file_put_contents(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html', $html);
                    }
                    if (Helpers::phptopdf_url(CONF_URL_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html', CONF_REALPATH_APP . 'uploads/pdf/', $titulo_pdf . '.pdf')) {
                        if ($this->enviar_mensaje('Factura #' . $this->codigo . ' del ejercicio ' . $this->ejercicio, 'Adjuntamos la factura de su pedido ', $cliente, CONF_REALPATH_APP . 'uploads/pdf/' . $titulo_pdf . '.pdf')) {
                            echo '<div style="padding: 15px;margin-bottom: 20px;border: 1px solid transparent;border-radius: 4px;color: #31708f;background-color: #d9edf7;border-color: #bce8f1;">' . __('Se ha enviado la factura correctamente') . '</div>';
                            exit;
                        } else {
                            echo '<div style="padding: 15px;margin-bottom: 20px;border: 1px solid transparent;border-radius: 4px;color: #a94442;background-color: #f2dede;border-color: #ebccd1;">' . __('Se ha producido un error al enviar la factura') . '</div>';
                            exit;
                        }
                    }
                } else {
                    if ($this->enviar_mensaje('Factura #' . $this->codigo . ' del ejercicio ' . $this->ejercicio, 'Adjuntamos la factura de su pedido ', $cliente, CONF_REALPATH_APP . 'uploads/pdf/factura_' . $this->codigo . '_' . $this->ejercicio . '.pdf')) {
                        echo '<div style="padding: 15px;margin-bottom: 20px;border: 1px solid transparent;border-radius: 4px;color: #31708f;background-color: #d9edf7;border-color: #bce8f1;">' . __('Se ha enviado la factura correctamente') . '</div>';
                        exit;
                    } else {
                        echo '<div style="padding: 15px;margin-bottom: 20px;border: 1px solid transparent;border-radius: 4px;color: #a94442;background-color: #f2dede;border-color: #ebccd1;">' . __('Se ha producido un error al enviar la factura') . '</div>';
                        exit;
                    }
                }
                break;
            case 'pdf':
				$titulo_pdf = $this->codigo . '-' . $this->ejercicio . '_' . Helpers::parseaTexto($this->titulo);
				if ($titulo_pdf == $this->codigo . '-' . $this->ejercicio . '_'){
					$titulo_pdf = 'factura_' . $this->codigo . '_' . $this->ejercicio;
				}
				if (!is_dir(CONF_REALPATH_APP . 'uploads/pdf')){
					Helpers::ftpCrearCarpeta(CONF_REALPATH_APP . 'uploads/pdf');
				}
				if (!is_dir(CONF_REALPATH_APP . 'uploads/facturas')){
					Helpers::ftpCrearCarpeta(CONF_REALPATH_APP . 'uploads/facturas');
				}
                if (!file_exists(CONF_REALPATH_APP . 'uploads/pdf/' . $titulo_pdf . '.pdf') || $force == true) {
                    if (!file_exists(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html') || $force == true) {
                        file_put_contents(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html', $html);
                    }
                    Helpers::phptopdf_url(CONF_URL_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html', CONF_REALPATH_APP . 'uploads/pdf/'. $titulo_pdf . '.pdf');
                }
                Helpers::redirect(CONF_URL_APP . 'uploads/pdf/' . $titulo_pdf . '.pdf');
                exit;
                break;
            default:
				if (!is_dir(CONF_REALPATH_APP . 'uploads/facturas')){
					Helpers::ftpCrearCarpeta(CONF_REALPATH_APP . 'uploads/facturas');
				}
                if (!file_exists(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html') || $force == true) {
                    file_put_contents(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html', $html);
                }
                include(CONF_REALPATH_APP . 'uploads/facturas/factura_' . $this->codigo . '_' . $this->ejercicio . '.html');
                exit;
                break;
        }
    }
    private function formatDatos()
    {
        return true;
    }
    /**
    
    
    * Adds a note (comment) to the order
    
    
    *
    
    
    * @access public
    
    
    * @param string $note Note to add
    
    
    * @param int $is_customer_note (default: 0) Is this a note for the customer?
    
    
    * @return id Comment ID
    
    
    */
    public function add_nota_factura($note, $is_customer_note = 0)
    {
        if (empty($this->id))
            return false;
        $tmp_obj       = new self($this->id);
        $notas_factura = json_decode($tmp_obj->params);
        if (empty($notas_factura) || !is_array($notas_factura))
            $notas_factura = array();
        $is_customer_note          = intval($is_customer_note);
        $arr                       = new stdClass();
        $arr->base_imponible_autor = 'mideas@noreply.com';
        $arr->factura_id           = $tmp_obj->id;
        $arr->autor                = __('Mideas');
        $arr->url_autor            = '';
        $arr->nota                 = $note;
        $arr->aprobado             = 1;
        $arr->usuario_id           = $is_customer_note;
        $arr->fecha                = strftime('%Y-%m-%d %H:%M:%S', time());
        if ($is_customer_note > 0) {
            $emailer            = new Emailer();
            $to_array           = array(
                $this->base_imponible => $this->datos['facturacion']['nombre']
            );
            $asunto             = sprintf(__('Nueva notificación de la factura # %s'), $this->id);
            $emailer->to        = $to_array;
            $emailer->asunto    = $asunto;
            $emailer->contenido = '<h1>' . $asunto . '</h1>';
            $emailer->contenido .= $note;
            if ($emailer->enviar()) {
            }
        }
        $notas_factura[] = $arr;
        Helpers::objectSort($notas_factura, 'fecha', 'DESC');
        $tmp_obj->setparams(json_encode($notas_factura));
        return $tmp_obj->Modificar();
    }
    function enviar_mensaje($asunto, $contenido, $cliente, $archivo)
    {
        if (empty($asunto)) {
            $asunto = sprintf(__('Factura # %s'), $this->codigo);
        }
        if (empty($contenido)) {
            $contenido = 'AQUI VA EL CONTENIDO DEL EMAIL DE LA FACTURA';
        }
        if (!is_object($cliente)) {
            return false;
        }
        $emailer  = new Emailer();
        $to_array = array(
            $cliente->email => $cliente->facturacion->nombre
        );
        $cc_array = array(
            $GLOBALS['opciones']['emailer']['email_emailer'] => $GLOBALS['opciones']['emailer']['nombre_emailer']
        );
        if (!empty($archivo)) {
            $emailer->archivos_adjuntos[$archivo] = basename($archivo);
        }
        $emailer->to        = $to_array;
        $emailer->cc        = $cc_array;
        $emailer->asunto    = $asunto;
        $emailer->contenido = '<h1>' . $asunto . '</h1>';
        $emailer->contenido .= $contenido;
        if ($emailer->enviar()) {
            return true;
        } else {
            return false;
        }
    }
    function get_estado_con_pago()
    {
        if (empty($this->id))
            return false;
        $total_recargo        = $this->datos['total_recargo']['creador_id'];
        $estado_total_recargo = $this->parse_status_paypal($this->datos['total_recargo']['estado']);
        $estado_factura       = ucfirst($this->getestado(true));
        $txt                  = sprintf(__('<b>%s</b>: pago %s a través de %s'), $estado_factura, $estado_total_recargo, $total_recargo);
        return $txt;
    }
    function get_num_productos()
    {
        if (empty($this->lineas) || !is_array($this->lineas))
            return 0;
        $cuenta_productos = 0;
        foreach ($this->lineas as $linea) {
            $cuenta_productos += (int) $linea->cantidad;
        }
        return (int) $cuenta_productos;
    }
    public function getInfo()
    {
        $this->formatDatos();
    }
    function getpedido()
    {
        if (!empty($this->pedido_id)) {
            e_include('ext_shop/class/pedidoShop');
            $ps = new PedidoShop();
            $ps->setid($this->pedido_id);
            if ($ps = $ps->BuscarId()) {
                return $ps;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    function getPeriodicasPendientes()
    {
        $params = Helpers::toArray(json_decode($this->params));
        if ($params['periodica'] != '1')
            return false;
        $fecha_factura = strtotime($this->fecha);
        switch ($params['tipo_periodicidad']) {
            case 'diaria':
                $tiempo_entre_facturas = 24 * 60 * 60;
                $dif                   = Helpers::FechaDif("d", $fecha_factura, time(), true);
                break;
            case 'semanal':
                $tiempo_entre_facturas = 7 * 24 * 60 * 60;
                $dif                   = Helpers::FechaDif("ww", $fecha_factura, time(), true);
                break;
            case 'mensual':
                //$tiempo_entre_facturas = strftime("%d", $fecha_factura);
                $tiempo_entre_facturas = "+1 month";
                $dif                   = Helpers::FechaDif("m", $fecha_factura, time(), true);
                break;
            case 'trimestral':
                $tiempo_entre_facturas = "+3 months";
                $dif                   = Helpers::FechaDif("q", $fecha_factura, time(), true);
                break;
            case 'anual':
                $tiempo_entre_facturas = 365 * 24 * 60 * 60;
                $dif                   = Helpers::FechaDif("yyyy", $fecha_factura, time(), true);
                break;
            default:
                $tiempo_entre_facturas = 24 * 60 * 60;
                $dif                   = Helpers::FechaDif("d", $fecha_factura, time(), true);
                break;
        }
        $this->loadLineas();
        $lineas_factura         = $this->lineas;
        $num_facturas_generadas = 0;
        for ($i = 0; $i < $dif; $i++) {
			if ($params['tipo_periodicidad'] == 'mensual'){
				$nueva_fecha = strtotime("+".($i + 1)." months", $fecha_factura);
			} elseif ($params['tipo_periodicidad'] == 'trimestral'){
				$nueva_fecha = strtotime("+".(($i + 1) * 3)." months", $fecha_factura);		
			} else {
            	$nueva_fecha = ($i + 1) * $tiempo_entre_facturas + $fecha_factura;
			}
            if ($nueva_fecha < time()) {
                $where_check_exists = "params LIKE '%\"modelo_id\":\"" . $this->id . "\"%' AND DATE_FORMAT(fecha, '%Y-%m-%d')='" . strftime("%Y-%m-%d", $nueva_fecha) . "'";
                $exists_factura     = $this->ListarCount($where_check_exists);
                if ($exists_factura == 1)
                    continue;
                $modelo_obj = new FacturaShop();
                $a          = $modelo_obj->get_classvars();
                foreach ($a as $clave) {
                    if (!in_array($clave, $this->get('ignore_vars'))) {
                        $modelo_obj->$clave = $this->$clave;
                    }
                }
                $modelo_obj->fecha     = strftime("%Y-%m-%d %H:%M:%S", $nueva_fecha);
                $modelo_obj->ejercicio = date('Y', $nueva_fecha);
                $modelo_obj->codigo    = $this->calcular_siguiente_id(date('Y', $nueva_fecha));
                $modelo_obj->estado    = 'pendiente';
                $modelo_obj->id        = '';
                $params_factura        = array(
                    "periodica" => 0,
                    "tipo_periodicidad" => "",
                    "modelo_id" => $this->id
                );
                $modelo_obj->params    = json_encode($params_factura);
                if ($nuevo_id = $modelo_obj->Guardar()) {
                    foreach ($lineas_factura as $linea_model) {
                        $lmodel = new FacturaLineaShop();
                        $b      = $lmodel->get_classvars();
                        foreach ($b as $claveb) {
                            if (!in_array($claveb, $lmodel->get('ignore_vars'))) {
                                $lmodel->$claveb = $linea_model->$claveb;
                            }
                        }
                        $lmodel->id         = '';
                        $lmodel->factura_id = $nuevo_id;
                        $lmodel->ejercicio  = date('Y', $nueva_fecha);
                        if ($nueva_linea_id = $lmodel->Guardar()) {
                        } else {
                            return true;
                        }
                    }
                    $num_facturas_generadas++;
                } else {
                    return false;
                }
            }
        }
        return $num_facturas_generadas;
    }
}
?>