<?php
e_include('ext_shop/class/impuestoShop');
class ImpuestoTarifa
{
	var $tarifas;	// Simple array of tarifas
	var $tarifas_parseadas;	// Parsed into array with counties/estados as keys
	
	private static $_instances = array();
	
	function __construct($admin=false){
		$this->getTarifasImpuesto($admin);
	}
	
	private static function _load(){
		if (!is_array(self::$_instances) || sizeof(self::$_instances) == 0){
			$tarifas_impuesto = new ImpuestoShop();
			$tarifas_impuesto = $tarifas_impuesto->Listar('');
			
			foreach ($tarifas_impuesto as $tarifa){
				self::$_instances[$tarifa->id] = $tarifa;
			}
		}
	}
	
	/**
	 * Get the tax tarifas as an array
	 */
	function getTarifasImpuesto($admin=false) {
		self::_load();
		
		if (!is_array($this->tarifas) && is_array(self::$_instances) && sizeof(self::$_instances) > 0) :
			$config_shop = App::getConfigValue('ext_shop');
			
			$tarifas_impuesto 		= self::$_instances;
			if ($admin != true){
				foreach ($tarifas_impuesto as $kt=>$t){
					if ($t->activo != '1')
						unset($tarifas_impuesto[$kt]);
				}
			}
			
			$tarifas_parseadas 		= array();
			$tarifas_planas			= array();
			$index 					= 0;
			
			if ( ! empty( $tarifas_impuesto ) ) 
			
			foreach( $tarifas_impuesto as $tarifa ) :
			
				// Standard Rate?
				if ( isset( $tarifa->tipo ) && !$tarifa->tipo) $tarifa->tipo = '*';
				
				if (!$tarifa->nombre) :
					$tarifa->nombre = __('Tarifa de impuesto');
					
					// Add % to label
					if ( $tarifa->tarifa > 0 || $tarifa->tarifa === 0 ) :
						$tarifa->nombre .= ' ('. rtrim(rtrim($tarifa->tarifa, '0'), '.') . '%)';
					endif;
				endif;
				
				$tarifas_planas[$index] = $tarifa;
				
				
				// Add entry for each pais/estado - each will hold all matching tarifas
				if ( isset( $tarifa->pais ) && $tarifa->pais) 
				
				foreach ($tarifa->getpais(true) as $loc) :
							if (empty($tarifa->codigo_postal))
								$tarifa->codigo_postal = '*';
							
							
							$tarifas_parseadas[$loc][$tarifa->codigo_postal][$tarifa->tipo][] = array( 
								'nombre' => $tarifa->nombre, 
								'tarifa' => $tarifa->tarifa, 
								'envio' => $tarifa->envio
								);
							
				endforeach;
				
				$index++;
				
			endforeach;
			
			
			$this->tarifas = $tarifas_planas;
			$this->tarifas_parseadas = $tarifas_parseadas;
			
		endif;
	}
	
	function get_envio_impuesto_tarifas($tipo_impuesto=''){
		if (empty($tipo_impuesto))
			$tipo_impuesto = 'estandar';
		
		$config_shop = App::getConfigValue('ext_shop');
		
		global $paises_defecto_shop;
			
		if (is_array($paises_defecto_shop)){
			$pais_defecto = $paises_defecto_shop;
		} else {
			$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
			$pais_defecto = $paises_defecto_shop;
		}
		$pais_defecto = $pais_defecto[0];
		
		$pais_decoded = explode('.', $pais_defecto);
		
		$pais_d = $pais_decoded[0];
		$prov_d = $pais_decoded[1];
		
		if ($prov_d == '0'){
			$prov_d = '';
		}
		
		$this->getTarifasImpuesto();
		
		$usr_sess = Helpers::getSesion()->get('shop.usuario');
		
		if (isset($usr_sess['pais'])) :
			$pais 	= $usr_sess['pais'];
			$estado 		= $usr_sess['provincia'];
			$codigo_postal   = $usr_sess['codigo_postal'];
		else :
			$pais 	= $pais_d;
			$estado 		= $prov_d;
			$codigo_postal   = '';
		endif;
		
		// If we are here then shipping is taxable - work it out
		if ( !is_null($tipo_impuesto) ) :
			
			$matched_tax_tarifas = array();
			
			// This will be per item shipping
			$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $tax_class );
			
			if ($tarifas) foreach ($tarifas as $key => $tarifa) :
				if (isset($tarifa['envio']) && $tarifa['envio']=='1') :
					$matched_tax_tarifas[$key] = $tarifa;
				endif;
			endforeach;
			
			if (sizeof($matched_tax_tarifas)==0) :
				// Get standard tarifa
				$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal );
				
				if ($tarifas) foreach ($tarifas as $key => $tarifa) :
					if (isset($tarifa['envio']) && $tarifa['envio']=='1') :
						$matched_tax_tarifas[$key] = $tarifa;
					endif;
				endforeach;
			endif;
			
			return $matched_tax_tarifas;
			
		else :
			
			// This will be per order shipping - loop through the order and find the highest tax class tarifa
			$found_tax_classes = array();
			$matched_tax_tarifas = array();
			$tarifas = false;
			
			// Loop cart and find the highest tax band
			if (sizeof(Helpers::getSesion()->get('shop.cesta'))>0) : foreach (Helpers::getSesion()->get('shop.cesta') as $item) :
				
				$_product = new Producto();
				$_product->setid($item['id']);
				$_product = $_product->BuscarId();
				
				$found_tax_classes[] = $_product->impuesto;
				
			endforeach; endif;
			
			$found_tax_classes = array_unique( $found_tax_classes );
			
			// If multiple classes are found, use highest
			if (sizeof($found_tax_classes)>1) :
				
				if (in_array('', $found_tax_classes)) :
					$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal );
				else :
					$tax_classes = array("estandar","reducido","cero");
					
					foreach ($tax_classes as $tax_class) :
						if (in_array( $tax_class, $found_tax_classes )) :
							$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $tax_class );
							break;
						endif;
					endforeach;
				endif;
			// If a single tax class is found, use it
			elseif (sizeof($found_tax_classes)==1) :
			
				$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $found_tax_classes[0] );
			
			endif;
			
			// If no classes are found, use standard tarifas
			if (!$tarifas) :
				$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal );	
			endif;
			
			if ($tarifas) foreach ($tarifas as $key => $tarifa) :
				if (isset($tarifa['envio']) && $tarifa['envio']=='1') :
					$matched_tax_tarifas[$key] = $tarifa;
				endif;
			endforeach;
			
			return $matched_tax_tarifas;
			
		endif;
		return array(); // return false
	}
	
	
	/**
	 * Searches for all matching pais/estado/codigo_postal tax tarifas
	 *
	 * @since 	1.4
	 * @param   string	pais
	 * @param	string	estado
	 * @param   string	codigo_postal
	 * @param	string	Tax Class
	 * @return  array
	 */
	function find_tarifas( $pais = '', $estado = '', $codigo_postal = '', $tax_class = '' ) {
		$this->getTarifasImpuesto();
		
		if (!$pais) return array();
		
		if (!$estado) $estado = '0';
		
		$tax_class = $tax_class;
		if (!$tax_class) $tax_class = 'estandar';
		$found_tarifas = array();
		
		// Look for a estado specific rule
		if (isset($this->tarifas_parseadas[ $pais.'.'.$estado ][ $codigo_postal ][ $tax_class ])) :
			
			// Look for tax class specific rule
			if (isset($this->tarifas_parseadas[ $pais.'.'.$estado ][ $codigo_postal ][ $tax_class ])) :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.'.$estado ][ $codigo_postal ][ $tax_class ];
			else :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.'.$estado ][ $codigo_postal ][ 'estandar' ];
			endif;
			
		// Default to * if not estado specific rules are found
		elseif (isset($this->tarifas_parseadas[ $pais.'.'.$estado ][ '*' ][ $tax_class ])) :
		
			// Look for tax class specific rule
			if (isset($this->tarifas_parseadas[ $pais.'.'.$estado ][ '*' ][ $tax_class ])) :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.'.$estado ][ '*' ][ $tax_class ];
			else :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.'.$estado ][ '*' ][ 'estandar' ];
			endif;
			
		elseif (isset($this->tarifas_parseadas[ $pais.'.0' ][ '*' ][ $tax_class ])) :
		
			// Look for tax class specific rule
			if (isset($this->tarifas_parseadas[ $pais.'.0' ][ '*' ][ $tax_class ])) :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.0' ][ '*' ][ $tax_class ];
			else :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.0' ][ '*' ][ 'estandar' ];
			endif;
			
		elseif (isset($this->tarifas_parseadas[ $pais.'.0' ][ $codigo_postal ][ $tax_class ])) :
		
			// Look for tax class specific rule
			if (isset($this->tarifas_parseadas[ $pais.'.0' ][ $codigo_postal ][ $tax_class ])) :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.0' ][ $codigo_postal ][ $tax_class ];
			else :
				$found_tarifas = $this->tarifas_parseadas[ $pais.'.0' ][ $codigo_postal ][ 'estandar' ];
			endif;
			
		endif;
		
		// Now we have an array of matching tarifas, lets filter this based on codigo_postal
		$matched_tax_tarifas = array();
		
		if ($found_tarifas) foreach ($found_tarifas as $key => $tarifa) :
			
			if (isset($tarifa['codigo_postal'])) :
				
				// Local tarifa
				if ($codigo_postal) :
				
					// Check if codigo_postal matches up
					if (in_array($codigo_postal, $tarifa['codigo_postal']) || sizeof($tarifa['codigo_postal'])==0) $matched_tax_tarifas[$key] = $tarifa;
					
					// Check codigo_postal ranges
					if (is_numeric($codigo_postal)) :
						foreach ($tarifa['codigo_postal'] as $tarifa_codigo_postal) :
							if (strstr($tarifa_codigo_postal, '-')) :
								$parts = array_map('trim', explode('-', $tarifa_codigo_postal));
								if (sizeof($parts)==2 && is_numeric($parts[0]) && is_numeric($parts[1])) :
									if ($codigo_postal>=$parts[0] && $codigo_postal<=$parts[1]) $matched_tax_tarifas[$key] = $tarifa;
								endif;
							endif;
						endforeach;
					endif;
					
				endif;
				
			else :
				
				// Standard tarifa
				$matched_tax_tarifas[$key] = $tarifa;
				
			endif;
			
		endforeach;
		
		//$matched_tax_tarifas = apply_filters('woocommerce_matched_tax_tarifas', $matched_tax_tarifas, $this->tarifas_parseadas, $pais, $estado, $codigo_postal, $tax_class );
		
		return $matched_tax_tarifas;
	}
	
	/**
	 * Get's an array of matching tarifas for a tax class
	 *
	 * @param   object	Tax Class
	 * @return  array
	 */
	function get_tarifas( $tax_class = '' ) {
		$this->getTarifasImpuesto();
		
		$tax_class = $tax_class;
		
		$config_shop = App::getConfigValue('ext_shop');
		
		global $paises_defecto_shop;
			
		if (is_array($paises_defecto_shop)){
			$pais_defecto = $paises_defecto_shop;
		} else {
			$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
			$pais_defecto = $paises_defecto_shop;
		}
		$pais_defecto = $pais_defecto[0];
		
		$pais_decoded = explode('.', $pais_defecto);
		
		$pais_d = $pais_decoded[0];
		$prov_d = $pais_decoded[1];
		
		if ($prov_d == '0'){
			$prov_d = '';
		}
		
		$usr_sess = Helpers::getSesion()->get('shop.usuario');
		
		if (isset($usr_sess['pais'])) :
			$pais 	= $usr_sess['pais'];
			$estado 		= $usr_sess['provincia'];
			$codigo_postal   = $usr_sess['codigo_postal'];
			
			$matched_tax_tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $tax_class );
			
			return $matched_tax_tarifas;
		else :
			return $this->get_tarifa_base_tienda( $tax_class );
		endif;
	}
	
	/**
	 * Get's an array of matching tarifas for the shop's base pais
	 *
	 * @param   string	Tax Class
	 * @return  array
	 */
	function get_tarifa_base_tienda( $tax_class = '' ) {
		$this->getTarifasImpuesto();
		
		$config_shop = App::getConfigValue('ext_shop');
		
		$pais_defecto = $config_shop['shop']['localizacion_defecto'];
		
		$pais_decoded = explode('.', $pais_defecto);
		
		$pais_d = $pais_decoded[0];
		$prov_d = $pais_decoded[1];
		
		if ($prov_d == '0'){
			$prov_d = '';
		}
		
		$pais 	= $pais_d;
		$estado 		= $prov_d;
		
		return $this->find_tarifas( $pais, $estado, '', $tax_class );
	}
	/**
	 * Gets an array of matching shipping tax tarifas for a given class
	 *
	 * @param   string	Tax Class
	 * @return  mixed		
	 */
	function getTarifasImpuesto_envio( $tax_class = null ) {
		$this->getTarifasImpuesto();
		
		$config_shop = App::getConfigValue('ext_shop');
		
		global $paises_defecto_shop;
			
		if (is_array($paises_defecto_shop)){
			$pais_defecto = $paises_defecto_shop;
		} else {
			$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
			$pais_defecto = $paises_defecto_shop;
		}
		$pais_defecto = $pais_defecto[0];
		
		$usr_sess = Helpers::getSesion()->get('shop.usuario');
		
		if (isset($usr_sess['pais'])) :
			$pais 	= $usr_sess['pais'];
			$estado 		= $usr_sess['provincia'];
			$codigo_postal   = $usr_sess['codigo_postal'];
		else :
			$pais 	= $pais_defecto;
			$estado 		= '';
			$codigo_postal   = '';
		endif;
		
		// If we are here then shipping is taxable - work it out
		if ( !is_null($tax_class) ) :
			
			$matched_tax_tarifas = array();
			
			// This will be per item shipping
			$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $tax_class );
			
			if ($tarifas) foreach ($tarifas as $key => $tarifa) :
				if (isset($tarifa['envio']) && $tarifa['envio']=='1') :
					$matched_tax_tarifas[$key] = $tarifa;
				endif;
			endforeach;
			
			if (sizeof($matched_tax_tarifas)==0) :
				// Get standard tarifa
				$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal );
				
				if ($tarifas) foreach ($tarifas as $key => $tarifa) :
					if (isset($tarifa['envio']) && $tarifa['envio']=='1') :
						$matched_tax_tarifas[$key] = $tarifa;
					endif;
				endforeach;
			endif;
			
			return $matched_tax_tarifas;
			
		else :
			
			// This will be per order shipping - loop through the order and find the highest tax class tarifa
			$found_tax_classes = array();
			$matched_tax_tarifas = array();
			$tarifas = false;
			
			global $shop;
			global $carrito_shop;
			
			if (is_object($shop)){
				$carrito = $shop->carrito;
			} elseif (is_object($carrito_shop)){
				$carrito = $carrito_shop;
			} else {
				$carrito = new Carrito();
				$carrito_shop = $carrito;
			}
			
			// Loop cart and find the highest tax band
			if (sizeof($carrito->get_carrito())>0) : foreach ($carrito->get_carrito() as $item) :
				
				$found_tax_classes[] = $item['data']->getimpuesto();
				
			endforeach; endif;
			
			$found_tax_classes = array_unique( $found_tax_classes );
			
			// If multiple classes are found, use highest
			if (sizeof($found_tax_classes)>1) :
				
				if (in_array('', $found_tax_classes)) :
					$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal );
				else :
					$tax_classes = array('estandar','reducida','cero');
					
					foreach ($tax_classes as $tax_class) :
						if (in_array( $tax_class, $found_tax_classes )) :
							$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $tax_class );
							break;
						endif;
					endforeach;
				endif;
			// If a single tax class is found, use it
			elseif (sizeof($found_tax_classes)==1) :
			
				$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal, $found_tax_classes[0] );
			
			endif;
			
			// If no classes are found, use standard tarifas
			if (!$tarifas) :
				$tarifas = $this->find_tarifas( $pais, $estado, $codigo_postal );	
			endif;
			
			if ($tarifas) foreach ($tarifas as $key => $tarifa) :
				if (isset($tarifa['envio']) && $tarifa['envio']=='yes') :
					$matched_tax_tarifas[$key] = $tarifa;
				endif;
			endforeach;
			
			return $matched_tax_tarifas;
			
		endif;
		return array(); // return false
	}
	
	/**
	 * Calculate the tax using a passed array of tarifas
	 *
	 * @param   float	precio
	 * @param   array	tarifas
	 * @param	bool	passed precio includes tax
	 * @return  array	array of tarifas/amounts
	 */
	function calc_impuesto( $precio, $tarifas, $precio_incluye_impuesto = true ) {
		
		$precio = $precio * 100;	// To avoid float rounding errors, work with integers (pence)
		
		// Taxes array
		$taxes = array();
		
		// Price inc tax
		if ($precio_incluye_impuesto) :
			
			$regular_tax_tarifas = 0;
			$compound_tax_tarifas = 0;
			
			foreach ($tarifas as $key => $tarifa) :
				$regular_tax_tarifas = $regular_tax_tarifas + $tarifa['tarifa'];
			endforeach;
			
			$regular_tax_tarifa = 1 + ($regular_tax_tarifas / 100);
			$compound_tax_tarifa = 1 + ($compound_tax_tarifas / 100);
			$tax_tarifa = $regular_tax_tarifa * $compound_tax_tarifa;
			
			$non_compound_precio = ($precio/$compound_tax_tarifa);
			// $precio = ($x * $regular_tax_tarifa) * $compound_tax_tarifa;
			
			foreach ($tarifas as $key => $tarifa) :
				
				$la_tarifa = $tarifa['tarifa'] / 100;
				
				$importe_impuesto = ( $la_tarifa / $regular_tax_tarifa ) * $non_compound_precio;
				
				// Back to pounds
				$importe_impuesto = ($importe_impuesto / 100);
				
				// Rounding
				/*if ( get_option( 'woocommerce_tax_round_at_subtotal' ) == 'no' ) :
					$importe_impuesto = round( $importe_impuesto, 2 );
				endif;*/
				
				// Add tarifa
				if (!isset($taxes[$key])) $taxes[$key] = $importe_impuesto; else $taxes[$key] += $importe_impuesto;
			endforeach;
		
		// Prices ex tax
		else :
			// Multiple taxes
			foreach ($tarifas as $key => $tarifa) :
				
				$importe_impuesto = $precio * ($tarifa['tarifa']/100);
				
				// Back to pounds
				$importe_impuesto = ($importe_impuesto / 100);
				
				$importe_impuesto1 = (float) $importe_impuesto;
		
				$ctm_exp = explode(".", str_replace(",",".", (string) $importe_impuesto1));
				
				if (is_string($ctm_exp[1]))
					$ctm_exp[1] = substr($ctm_exp[1], 0, 2);
				else
					$ctm_exp[1] = '00';
					
				$importe_impuesto1 = $ctm_exp[0] . '.' . $ctm_exp[1];
				$importe_impuesto1 = (float) $importe_impuesto1;
				
				$importe_impuesto = $importe_impuesto1;
		//exit;
				
				// Rounding
				/*if ( get_option( 'woocommerce_tax_round_at_subtotal' ) == 'no' ) :
					$importe_impuesto = round( $importe_impuesto, 2 );
				endif;*/
				
				// Add tarifa
				if (!isset($taxes[$key])) $taxes[$key] = $importe_impuesto; else $taxes[$key] += $importe_impuesto;
	
			endforeach;
			
			$pre_compound_total = array_sum($taxes);
			
		endif;
		return $taxes;
	}
	
	/**
	 * Calculate the shipping tax using a passed array of tarifas
	 *
	 * @param   int		Price
	 * @param	int		Taxation Rate
	 * @return  int		
	 */
	function calc_envio_impuesto( $precio, $tarifas ) {
		// Taxes array
		$taxes = array();
		
		// Multiple taxes
		foreach ($tarifas as $key => $tarifa) :
			$importe_impuesto = $precio * ($tarifa['tarifa']/100);
			
			// Add tarifa
			if (!isset($taxes[$key])) $taxes[$key] = $importe_impuesto; else $taxes[$key] += $importe_impuesto;
		endforeach;
		return $taxes;
	}
	
	/**
	 * Return a given rates label
	 *
	 * @param   int		key
	 * @return  string		
	 */
	function get_nombre_tarifa( $key ) {
		if (isset($this->tarifas[$key]) && $this->tarifas[$key]['nombre']) return $this->tarifas[$key]['nombre'];
		return '';
	}
	
	/**
	 * Round tax lines and return the sum
	 *
	 * @param   array
	 * @return  float		
	 */
	function get_impuesto_total( $taxes ) {
		return array_sum(array_map(array(&$this, 'round'), $taxes));
	}
	
	/** 
	 * Round to 2 DP
	 */
	function round( $in ) {
		//return round($in, 2);
		return $in;
	}
	
}