<?php
defined('CONF_URL_APP') or die;
class ext_shopInstallerScript{
	var $installer;
	
	function __construct($inst){
		if (!empty($inst))
			$this->installer = $inst;
	}
	
	function postflight($action='install', $inst){
		c_include('menu','enlace','app','extension','admin/instalador');
		$error = false;
		
		$extension_shop = new Extension();
		$extension_shop = $extension_shop->Listar("tipo='extension' AND carpeta='ext_shop'");
		
		if (is_array($extension_shop) && sizeof($extension_shop) == 1){
			$extension_shop = $extension_shop[0];
			
			$idioma = SistemaIdioma::getIdiomaSesion();;
			if (empty($idioma))
				$idioma = 'es';
			
			$dir = dirname(__FILE__);
			$forms_xml = array($dir.'/install/frm_facturacion.xml', $dir.'/install/frm_envio.xml');
			
			$importador = new Instalador();
			foreach ($forms_xml as $fxml){
				if (!$importador->instalar_archivo($fxml)){
					$error = true;
				}
			}
			
			if ($error){
				App::setMsg(__('Se ha producido un error al intentar importar un formulario.'), 'error', 'admin');
				$error = false;
			}
			
			$menu_obj = new Menu;
			
			$menu_usr = $menu_obj->Listar("tipo='usuario'");
			if (is_array($menu_usr) && sizeof($menu_usr) > 0){
				$menu_usr = $menu_usr[0];
				$id_menu_usr = $menu_usr->id;
			} else {
				$menu_usr = new Menu;
				$menu_usr->setnombre(__('Menu de usuario'));
				$menu_usr->setactivo(1);
				$menu_usr->setnivel_acceso(1);
				$menu_usr->settipo('usuario');
				
				$id_menu_usr = $menu_usr->Guardar();
			}
			
			$menu_gen = $menu_obj->Listar("tipo='general'");
			if (is_array($menu_gen) && sizeof($menu_gen) > 0){
				$menu_gen = $menu_gen[0];
				$id_menu_gen = $menu_gen->id;
			} else {
				$menu_gen = new Menu;
				$menu_gen->setnombre(__('Menu general'));
				$menu_gen->setactivo(1);
				$menu_gen->setnivel_acceso(-1);
				$menu_gen->settipo('general');
				
				$id_menu_gen = $menu_gen->Guardar();
			}
			
			$menu_hid = $menu_obj->Listar("tipo='oculto'");
			if (is_array($menu_hid) && sizeof($menu_hid) > 0){
				$menu_hid = $menu_hid[0];
				$id_menu_hid = $menu_hid->id;
			} else {
				$menu_hid = new Menu;
				$menu_hid->setnombre(__('Menu oculto'));
				$menu_hid->setactivo(1);
				$menu_hid->setnivel_acceso(-1);
				$menu_hid->settipo('oculto');
				
				$id_menu_hid = $menu_hid->Guardar();
			}
			
			$existe_enlace_tienda = Enlace::getInstanceByAtrr('ext_shop', 'categoria_productos', '1');
			
			if (!$existe_enlace_tienda){
				$enlace_tienda = new Enlace();
				$enlace_tienda->setnombre(__('Tienda'));
				$enlace_tienda->settitulo(json_encode(array($idioma=>__('Tienda'))));
				$alias_enlace_tienda = __('Tienda');
				$check_alias_tienda = Enlace::checkAlias($alias_enlace_tienda, $idioma);
				if ($check_alias_tienda == true){
					$alias_enlace_tienda = __('Tienda').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_tienda, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace principal de la tienda. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_tienda = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0","params":{"num_articulos":"12","orden_alias":"nuevo","incluir_subcategorias":"1","mostrar_solo_usuario":"0","ignorar_geolocalizacion":"0","tipos_resultados":""},"listado":{"mensaje_cargando":{"es":"Cargando m\\u00e1s productos"},"imagen_cargando":"","mostrar_titulo":"1","enlazar_titulo":"1","mostrar_contenido":"0","longitud_contenido":"","mostrar_imagen":"1","ancho_imagen":"300","alto_imagen":"300","mostrar_karma":"0","mostrar_localizacion":"0","mostrar_distancia":"0","mostrar_fecha":"0","mostrar_categorias":"1","mostrar_autor":"0","mostrar_comentarios":"0","mostrar_leermas":"1","numero_columnas":"4"},"detalle":{"mostrar_titulo":"0","mostrar_imagen":"1","ancho_imagen":"1920","alto_imagen":"1080","mostrar_karma":"0","mostrar_localizacion":"0","mostrar_distancia":"0","mostrar_fecha":"0","mostrar_categorias":"1","mostrar_autor":"0","mostrar_galeria_imagenes":"1","mostrar_campos_extra":"1"}}';
					
					$enlace_tienda->setalias(json_encode(array($idioma=>$alias_enlace_tienda)));
					$enlace_tienda->setmenu_id($id_menu_gen);
					$enlace_tienda->setextension_id($extension_shop->id);
					$enlace_tienda->setnivel_acceso("0");
					$enlace_tienda->setpadre_id("0");
					$enlace_tienda->setmeta_description("");
					$enlace_tienda->setmeta_keywords("");
					$enlace_tienda->settipo("ext_shop");
					$enlace_tienda->setvista("categoria_productos");
					$enlace_tienda->setid_elemento("1");
					$enlace_tienda->setidioma("");
					$enlace_tienda->setparams($params_enlace_tienda);
					
					if (!$enlace_tienda->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace principal de la tienda. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_cesta = Enlace::getInstanceByAtrr('ext_shop', 'cesta');
			
			if (!$existe_enlace_cesta){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Cesta de la compra'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Cesta de la compra'))));
				$alias_enlace_cesta = __('Cesta-de-la-compra');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Cesta-de-la-compra').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la cesta de la compra. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0"}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_hid);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("0");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("cesta");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la cesta de la tienda. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_pago = Enlace::getInstanceByAtrr('ext_shop', 'cesta_pago');
			
			if (!$existe_enlace_pago){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Confirmar pedido'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Confirmar pedido'))));
				$alias_enlace_cesta = __('Confirmar-pedido');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Confirmar-pedido').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de confirmación de pedido. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0","params":{"formulario_envio":"47"}}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_hid);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("0");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("cesta_pago");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de confirmación de pedido. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_pago_form = Enlace::getInstanceByAtrr('ext_shop', 'cesta_pago_form');
			
			if (!$existe_enlace_pago_form){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Finalizar pedido'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Finalizar pedido'))));
				$alias_enlace_cesta = __('Finalizar-pedido');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Finalizar-pedido').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de finalizar pedido. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0"}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_hid);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("0");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("cesta_pago_form");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de finalizar pedido. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			
			$existe_enlace_fin = Enlace::getInstanceByAtrr('ext_shop', 'cesta_fin');
			
			if (!$existe_enlace_fin){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Pedido realizado'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Pedido realizado'))));
				$alias_enlace_cesta = __('Pedido-realizado');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Pedido-realizado').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de pedido realizado. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0"}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_hid);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("0");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("cesta_fin");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de pedido realizado. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_procesar = Enlace::getInstanceByAtrr('ext_shop', 'procesar_pago');
			
			if (!$existe_enlace_procesar){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Procesar pago'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Procesar pago'))));
				$alias_enlace_cesta = __('Procesar-pago');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Procesar-pago').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de procesar pago. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0"}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_hid);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("0");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("procesar_pago");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de procesar pago. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_pedidos = Enlace::getInstanceByAtrr('ext_shop', 'lista_pedidos');
			
			if (!$existe_enlace_pedidos){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Mis pedidos'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Mis pedidos'))));
				$alias_enlace_cesta = __('Mis-pedidos');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Mis-pedidos').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página Mis pedidos. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0"}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_usr);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("1");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("lista_pedidos");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de Mis pedidos. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_direcciones = Enlace::getInstanceByAtrr('ext_shop', 'editar_cliente');
			
			if (!$existe_enlace_direcciones){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Mis direcciones'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Mis direcciones'))));
				$alias_enlace_cesta = __('Mis-direcciones');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Mis-direcciones').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página Mis direcciones. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"2columnas_right","estilo_vista":"","clase":"","clase_icono":"","cache":"0"}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_usr);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("1");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("editar_cliente");
					$enlace_cesta->setid_elemento("");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de Mis direcciones. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			$existe_enlace_fabricantes = Enlace::getInstanceByAtrr('ext_shop', 'categoria_fabricantes', '1');
			
			if (!$existe_enlace_fabricantes){
				$enlace_cesta = new Enlace();
				$enlace_cesta->setnombre(__('Fabricantes'));
				$enlace_cesta->settitulo(json_encode(array($idioma=>__('Fabricantes'))));
				$alias_enlace_cesta = __('Fabricantes');
				$check_alias_cesta = Enlace::checkAlias($alias_enlace_cesta, $idioma);
				if ($check_alias_cesta == true){
					$alias_enlace_cesta = __('Fabricantes').'-'.time();
					
					if (Enlace::checkAlias($alias_enlace_cesta, $idioma) == true){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página Fabricantes. Por favor, intente crearlo manualmente.'), 'error', 'admin');
						$error = true;
					}
				}
				if (!$error){
					$params_enlace_cesta = '{"nueva_ventana":"0","ambito":"general","estilo":"1columna","estilo_vista":"","clase":"","clase_icono":"","cache":"0","params":{"num_articulos":"12","orden_alias":"nuevo","incluir_subcategorias":"1","mostrar_solo_usuario":"0","ignorar_geolocalizacion":"0"},"listado":{"mensaje_cargando":{"es":"Cargando m\\u00e1s fabricantes"},"imagen_cargando":"","mostrar_titulo":"1","enlazar_titulo":"1","mostrar_contenido":"0","longitud_contenido":"","mostrar_imagen":"1","ancho_imagen":"300","alto_imagen":"300","mostrar_karma":"0","mostrar_localizacion":"0","mostrar_distancia":"0","mostrar_fecha":"0","mostrar_categorias":"0","mostrar_autor":"0","mostrar_comentarios":"0","mostrar_galeria":"0","numero_columnas":"4"},"detalle":{"mostrar_titulo":"0","mostrar_imagen":"1","mostrar_karma":"0","mostrar_localizacion":"1","mostrar_distancia":"0","mostrar_fecha":"0","mostrar_categorias":"1","mostrar_autor":"0","mostrar_comentarios":"0","mostrar_galeria_imagenes":"1","mostrar_campos_extra":"1"}}';
					
					$enlace_cesta->setalias(json_encode(array($idioma=>$alias_enlace_cesta)));
					$enlace_cesta->setmenu_id($id_menu_hid);
					$enlace_cesta->setextension_id($extension_shop->id);
					$enlace_cesta->setnivel_acceso("1");
					$enlace_cesta->setpadre_id("0");
					$enlace_cesta->setmeta_description("");
					$enlace_cesta->setmeta_keywords("");
					$enlace_cesta->settipo("ext_shop");
					$enlace_cesta->setvista("categoria_fabricantes");
					$enlace_cesta->setid_elemento("1");
					$enlace_cesta->setidioma("");
					$enlace_cesta->setparams($params_enlace_cesta);
					
					if (!$enlace_cesta->Guardar()){
						App::setMsg(__('Se ha producido un error al intentar crear el enlace de la página de Mis direcciones. Por favor, intente crearlo manualmente.'), 'error', 'admin');
					}
					$error = false;
				} else {
					$error = false;
				}
			}
			
			c_include('cache/utilities');
			$cache_helper = new CacheUtilities();
			
			$cache_helper->cleanlist(array('extensiones','menus'));
		
		} else {
			App::setMsg(__('No se encuentra el registro de la extensión Shop en la base de datos'), 'error', 'admin');
		}
		return true;
	}
	
	function uninstall($xml){
		c_include('menu','enlace','app');
		e_include('ext_forms/class/formulario');
		$error = false;
		
		$enlaces = new Enlace();
		$enlaces = $enlaces->Listar("tipo='ext_shop'");
		
		if (is_array($enlaces) && sizeof($enlaces) > 0){
			foreach ($enlaces as $enlace){
				if (!$enlace->Borrar()){
					$error = true;
				}
			}
		}
		if ($error){
			App::setMsg(__('Se ha producido un error al intentar borrar algún enlace de la extensión'), 'error', 'admin');
			$error = false;
		}
		$opts = $GLOBALS['opciones']['ext_shop']['clientes'];
		if (!empty($opts['formulario_facturacion'])){
			$frm = new Formulario();
			$frm->setid($opts['formulario_facturacion']);
			if ($frm = $frm->BuscarId()){
				$campos_frm = $frm->getCampos();
				$fs_frm = $frm->getFieldsets();
				
				if (!$frm->Borrar()){
					$error = true;
				}
				
				foreach ($campos_frm as $camp){
					$camp->Borrar();
				}
				
				foreach ($fs_frm as $fs){
					$fs->Borrar();
				}
			}
		}
		
		if (!empty($opts['formulario_envio'])){
			$frm = new Formulario();
			$frm->setid($opts['formulario_envio']);
			if ($frm = $frm->BuscarId()){
				$campos_frm = $frm->getCampos();
				$fs_frm = $frm->getFieldsets();
				
				if (!$frm->Borrar()){
					$error = true;
				}
				
				foreach ($campos_frm as $camp){
					$camp->Borrar();
				}
				
				foreach ($fs_frm as $fs){
					$fs->Borrar();
				}
			}
		}
		
		if ($error){
			App::setMsg(__('Se ha producido un error al intentar borrar algún formulario de la extensión'), 'error', 'admin');
			$error = false;
		}
		
		c_include('cache/utilities');
		$cache_helper = new CacheUtilities();
		
		$cache_helper->cleanlist(array('extensiones','menus'));
		
		return true;
	}
}