<?php
defined('CONF_URL_APP') or die;
	
class PedidoShop extends EntidadModel
{
	protected $dbt_const = "DBT_SHOP_PEDIDOS";
	protected $dbt = "shop_pedidos";
	
	protected $ext_folder = "ext_shop";
	
	protected $all_vars = array("id","usuario_id","titulo","estado","fecha","comentarios","email","envio_a_facturacion","datos_facturacion","datos_envio","metodo_pago","metodo_envio","total","params","reglas_aplicadas");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("usuario_id","titulo","estado","comentarios","email","envio_a_facturacion","datos_facturacion","datos_envio","metodo_pago","metodo_envio","total","params","reglas_aplicadas");
	
	protected $campos_multilang = array();
	protected $campos_array = array("datos_facturacion","datos_envio","metodo_pago","metodo_envio","total","params","reglas_aplicadas");
	
	public $lineas;
	
	public function __construct($id_pedido='') {
		parent::__construct();
		
		if (!empty($id_pedido)){
			$this->setid($id_pedido);
			if ($this->id) {
				$link = new DB();
				$i    = 0;
				$sql  = "
						SELECT 
							*
							
						FROM
							" . DBT_SHOP_PEDIDOS . "
							
						WHERE
							id = " . $this->id;
				$res  = $link->Query($sql);
				$x    = $link->FetchArray($res);
				$a    = get_class_vars(get_class($this));
				foreach ($a as $clave => $estado) {
					$this->$clave = $this->filtroSalida($x[$clave]);
				}
				$this->getInfo();
				$link->Desconectar();
			}
		}
	}
	
	function includes() {
        e_include('ext_shop/class/pedidoLineaShop','ext_shop/class/estadoPedidoShop','ext_shop/class/helper');
    }
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }
    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
	
    function getestado($for_print=false, $object=false)
    {
		if ($for_print == false){
        	return $this->estado;
		} else {
			$estado_ped = new EstadoPedidoShop($this->estado);
			
			if ($object == true){
				return $estado_ped;
			} else {
				return SistemaIdioma::Imprimir($estado_ped->nombre);
			}
		}
    }
	
	function Borrar() {
		if (!in_array($this->estado, $GLOBALS['opciones']['ext_shop']['venta']['estados_borrables'])){
			return false;
		} else {
			return parent::Borrar();
		}
	}
	
	function loadLineas(){
		if (empty($this->id))
			return false;
			
		if (empty($this->lineas)){
			$lineas = new PedidoLineaShop();
			$where = "pedido_id='".$this->id."'";
			$lineas_c = $lineas->ListarCount($where);
			if ($lineas_c > 0){
				$lineas = $lineas->Listar($where);
				$this->lineas = $lineas;
				return true;
			} else {
				return false;
			}
		} else {
			return true;
		}
	}
	
	private function formatDatos(){
		c_include('loc/localidad','loc/provincia','loc/pais','loc/locHelper');
		
		if (empty($this->id) || empty($this->datos_facturacion))
			return false;
			
		$this->datos['facturacion'] = Helpers::toArray(json_decode($this->datos_facturacion));
		
		if (is_string($this->datos['facturacion']['pais']) && strlen($this->datos['facturacion']['pais']) == 2) {
			$this->datos['facturacion']['nombre_pais'] = Pais::BuscarPorISO2($this->datos['facturacion']['pais'])->getpais();
			
			$pais = new Pais();
			if ($pais = $pais->BuscarPorISO2($this->datos['facturacion']['pais'])){
				$this->datos['facturacion']['pais_iso3'] = $pais->iso3;
			}
		} else
			$this->datos['facturacion']['nombre_pais'] = $this->datos['facturacion']['pais'];
			
		if (is_numeric((int) $this->datos['facturacion']['provincia']) && (int) $this->datos['facturacion']['provincia'] > 0)
			$this->datos['facturacion']['nombre_provincia'] = Provincia::BuscarObjPorId($this->datos['facturacion']['provincia'])->getprovincia();
		else
			$this->datos['facturacion']['nombre_provincia'] = $this->datos['facturacion']['provincia'];
			
		if (is_numeric((int) $this->datos['facturacion']['localidad']) && (int) $this->datos['facturacion']['localidad'] > 0)
			$this->datos['facturacion']['nombre_localidad'] = Localidad::BuscarObjPorId($this->datos['facturacion']['localidad'])->getlocalidad();
		else
			$this->datos['facturacion']['nombre_localidad'] = $this->datos['facturacion']['localidad'];
		
		if (!empty($this->datos_envio)){
			$this->datos['envio'] = Helpers::toArray(json_decode($this->datos_envio));
			
			if (is_string($this->datos['envio']['envio_pais']) && strlen($this->datos['envio']['envio_pais']) == 2){
				$this->datos['envio']['nombre_pais'] = Helpers::getPaises(array($this->datos['envio']['envio_pais']));
				$pais = new Pais();
				if ($pais = $pais->BuscarPorISO2($this->datos['envio']['envio_pais'])){
					$this->datos['envio']['pais_iso3'] = $pais->iso3;
				}
			} else
				$this->datos['envio']['nombre_pais'] = $this->datos['envio']['envio_pais'];
				
			if (is_numeric((int) $this->datos['facturacion']['envio_provincia']) && (int) $this->datos['envio']['envio_provincia'] > 0)
				$this->datos['envio']['nombre_provincia'] = Provincia::BuscarObjPorId($this->datos['envio']['envio_provincia'])->getprovincia();
			else
				$this->datos['envio']['nombre_provincia'] = $this->datos['envio']['envio_provincia'];
				
			if (is_numeric((int) $this->datos['envio']['envio_localidad']) && (int) $this->datos['envio']['envio_localidad'] > 0)
				$this->datos['envio']['nombre_localidad'] = Localidad::BuscarObjPorId($this->datos['envio']['envio_localidad'])->getlocalidad();
			else
				$this->datos['envio']['nombre_localidad'] = $this->datos['envio']['envio_localidad'];
			
		}
			
		if (!empty($this->metodo_pago))
			$this->datos['metodo_pago'] = Helpers::toArray(json_decode($this->metodo_pago));
			
		if (!empty($this->metodo_envio))
			$this->datos['metodo_envio'] = Helpers::toArray(json_decode($this->metodo_envio));
			
		if (!empty($this->total))
			$this->datos['total'] = Helpers::toArray(json_decode($this->total));
			
		$tmp_notas = json_decode($this->params);
		if (!empty($tmp_notas)){
			Helpers::objectSort($tmp_notas,'fecha','DESC');
			$this->datos['notas'] = $tmp_notas;
		}
		
		$this->estado_pedido_html = $this->getestado(true, true)->printLabelEstado();
			
		$this->loadLineas();
		
		return true;
	}
	
	public function pago_completo($new_estado) {
		c_include('usuario');
		e_include('ext_shop/class/producto');
		
		global $shop;
		
		if (empty($new_estado))
			$new_estado = $GLOBALS['opciones']['ext_shop']['venta']['estado_procesando'];
		
		$_pedido_esp = Helpers::getSesion()->get('shop.pedido_esperando_pago');
		if ( ! empty( $_pedido_esp ) )
			Helpers::getSesion()->clear('shop.pedido_esperando_pago');
		if ( $this->id && ( $this->estado != $GLOBALS['opciones']['ext_shop']['venta']['estado_completado'] ) ) {
			$order_needs_processing = $new_estado == $GLOBALS['opciones']['ext_shop']['venta']['estado_procesando'] ? true : false;
			if ( sizeof( $this->lineas ) > 0 ) {
				foreach( $this->lineas as $item ) {
					$order_needs_processing = $new_estado == $GLOBALS['opciones']['ext_shop']['venta']['estado_procesando'] ? true : false;
					if ( $item->product_id > 0 ) {
						$_product = unserialize($item->data);
						if ( $_product->es_virtual() && $_product->es_credito() ) {
							$usr_tmp = new Usuario();
							$usr_tmp->setid($this->usuario_id);
							$usr_tmp = $usr_tmp->BuscarId();
							$usr_tmp->cambiaCredito($item->cantidad*$_product->get_credito());
							$this->add_nota_pedido( sprintf(__( 'Se ha modificado el crédito del usuario %s en %s.' ), Usuario::getLoged()->username, $_product->get_credito()) );
							
							$order_needs_processing = false;
							//continue;
						}
					}
					break;
				}
			}
			
			if ($order_needs_processing){
				$new_order_status = $GLOBALS['opciones']['ext_shop']['venta']['estado_procesando'];
			} else {
				$new_order_status = $new_estado;
			}
			
			$this->setestado( $new_order_status );
			$this->prepararModificar();
			$this->Modificar();
			
			//$this->enviar_mensaje( $new_order_status );
			
			if (!$order_needs_processing && $new_order_status != $GLOBALS['opciones']['ext_shop']['venta']['estado_enviado']){
				$this->reducir_stock_pedido();
			}
			
			if ($order_needs_processing){
				$this->PlaceShippingOrder();
			}
		}
	}
	
	public function PlaceShippingOrder(){
		e_include('ext_shop/class/envioShop');
		
		if (!empty($this->datos['metodo_envio']['id'])){
			
			$metodo_envio = new EnvioShop();
			$metodo_envio->setid($this->datos['metodo_envio']['id']);
			
			if ($metodo_envio = $metodo_envio->BuscarId()){
				$transportista = $metodo_envio->getTransportista();
				
				if ($transportista != false){
					$transportista->place_shipping_order($this);
					
					/*if ($id_shipping_order = $transportista->place_shipping_order($this)){
						$this->add_nota_pedido( sprintf(__( 'Enviando solicitud de recogida a transportista %s con código de albarán %s' ), $transportista->getNombre(), $id_shipping_order) );
					} else {
						$this->add_nota_pedido( sprintf(__( 'Se ha producido un error al intentar solicitar el envío al transportista %s' ), $transportista->getNombre()) );
					}*/
				}
			}
		
		}
	}
	
	/**
	 * Reduce stock levels
	 *
	 * @access public
	 * @return void
	 */
	public function reducir_stock_pedido() {
		e_include('ext_shop/class/productoVariacion');
		
		$opts = $GLOBALS['opciones']['ext_shop'];
		if ( $opts['producto']['habilitar_stock'] == '1' && sizeof( $this->lineas ) > 0 ) {
			// Reduce stock levels and do any other actions with products in the cart
			foreach ( $this->lineas as $item ) {
				if ($item->product_id>0) {
					$_product_tmp = unserialize($item->data);
					$_product = new Producto();
					$_product->setid($_product_tmp->id);
					if ($_product = $_product->BuscarId()){
					} else {
						//Inconsistencia de stock!!!!!
						$_product = $_product_tmp;
					}
					if ( $_product && $_product->id > 0 && $opts['producto']['habilitar_stock'] == '1' ) {
						
						$_product_name = SistemaIdioma::Imprimir($_product->nombre);
						
						if ($item->variation_id > 0){
							$_product = new ProductoVariacion();
							$_product->setid($item->variation_id);
							if ($_product = $_product->BuscarId()){
								$_product_name = SistemaIdioma::Imprimir($_product->objeto_padre->nombre) . ' ' . $_product->getatributos(true,false,', ');
							} else {
								$this->add_nota_pedido( __( 'Se ha producido un error al reducir el stock de los productos del pedido.' ) );
								return false;
							}
						}
						
						$old_stock = $_product->stock;
						$qty = $item->cantidad;
						$new_quantity = $_product->reducir_stock( $qty );
						
						if ($new_quantity != false){
							$this->add_nota_pedido( sprintf( __( 'Stock del producto #%s reducido de %s a %s.' ), $_product_name, $old_stock, $new_quantity) );
						}
					}
				}
			}
			$this->add_nota_pedido( __( 'Stock de los productos del pedido reducido con éxito.' ) );
		}
	}
	
	/**
	 * Reduce stock levels
	 *
	 * @access public
	 * @return void
	 */
	public function restaurar_stock_pedido() {
		e_include('ext_shop/class/productoVariacion');
		
		$opts = $GLOBALS['opciones']['ext_shop'];
		if ( $opts['producto']['habilitar_stock'] == '1' && sizeof( $this->lineas ) > 0 ) {
			// Reduce stock levels and do any other actions with products in the cart
			foreach ( $this->lineas as $item ) {
				if ($item->product_id>0) {
					$_product_tmp = unserialize($item->data);
					$_product = new Producto();
					$_product->setid($_product_tmp->id);
					if ($_product = $_product->BuscarId()){
					} else {
						//Inconsistencia de stock!!!!!
						$_product = $_product_tmp;
					}
					
					if ( $_product && $_product->id > 0 && $opts['producto']['habilitar_stock'] == '1' ) {
						
						$_product_name = SistemaIdioma::Imprimir($_product->nombre);
						
						if ($item->variation_id > 0){
							$_product = new ProductoVariacion();
							$_product->setid($item->variation_id);
							if ($_product = $_product->BuscarId()){
								$_product_name = SistemaIdioma::Imprimir($_product->objeto_padre->nombre) . ' ' . $_product->getatributos(true,false,', ');
							} else {
								$this->add_nota_pedido( __( 'Se ha producido un error al restaurar el stock de los productos del pedido.' ) );
								return false;
							}
						}
						
						$old_stock = $_product->stock;
						$qty = $item->cantidad;
						$new_quantity = $_product->aumentar_stock( $qty );
						
						if ($new_quantity != false){
							$this->add_nota_pedido( sprintf( __( 'Stock del producto #%s restaurado de %s a %s.' ), $_product_name, $old_stock, $new_quantity) );
						}
					}
				}
			}
			
			$this->add_nota_pedido( __( 'Stock de los productos del pedido restaurado con éxito.' ) );
		}
	}
	
	/**
	 * Adds a note (comment) to the order
	 *
	 * @access public
	 * @param string $note Note to add
	 * @param int $is_customer_note (default: 0) Is this a note for the customer?
	 * @return id Comment ID
	 */
	public function add_nota_pedido( $note, $is_customer_note = 0, $is_change_state = 0 ) {
		if (empty($this->id))
			return false;
			
		$tmp_obj = new PedidoShop();
		$tmp_obj->setid($this->id);
		$tmp_obj = $tmp_obj->BuscarId();
		
		$notas_pedido = json_decode($tmp_obj->params);
		
		if (empty($notas_pedido) || !is_array($notas_pedido))
			$notas_pedido = array();
		$is_customer_note = intval( $is_customer_note );
		
		$arr = new stdClass();
		$arr->email_autor = 'mideas@noreply.com';
		$arr->pedido_id = $tmp_obj->id;
		$arr->autor = __('Mideas');
		$arr->url_autor = '';
		$arr->nota = $note;
		$arr->aprobado = 1;
		$arr->cliente_id = $is_customer_note;
		$arr->estado_id = $is_change_state;
		$arr->fecha = strftime('%Y-%m-%d %H:%M:%S', time());
		if ($is_customer_note > 0) {
			$emailer = new Emailer();
				
			$to_array = array($this->email=>$this->datos['facturacion']['nombre']);
			
			$asunto = sprintf(__('Nueva notificación del pedido # %s'), $this->id);
			
			$emailer->to = $to_array;
			$emailer->asunto = $asunto;
			
			$emailer->contenido = '<h1>'.$asunto.'</h1>';
			$emailer->contenido .= $note;
			
			if ($emailer->enviar()){
			}
		}
		
		$notas_pedido[] = $arr;
		
		Helpers::objectSort($notas_pedido,'fecha','DESC');
		
		$tmp_obj->setparams(json_encode($notas_pedido));
		
		return $tmp_obj->Modificar();
	}
	
	function enviar_mensaje($estado, $asunto, $mensaje, $to, $cc){
		if (empty($asunto)){
			$asunto = sprintf(__('Pedido # %s completado'), $this->id);
		}
		
		$estado_obj = new EstadoPedidoShop($estado);
		$params_estado = Helpers::toArray(json_decode($estado_obj->params));
		
		$file_email = CONF_REALPATH_APP . $params_estado['email_notificacion'];
		
		if (!empty($params_estado['email_notificacion']) && is_file($file_email)){
			
			$emailer = new Emailer();
			
			if (!is_array($to) || sizeof($to) == 0){
				$to = array($this->email=>$this->datos['facturacion']['nombre']);
			}
			
			/*if ($estado != $GLOBALS['opciones']['ext_shop']['venta']['estado_completado'] && !is_array($cc)){
				$cc = array($GLOBALS['opciones']['emailer']['email_emailer']=>$GLOBALS['opciones']['emailer']['nombre_emailer']);
			}*/
	
			$emailer->to = $to;
			$emailer->cc = $cc;
			$emailer->asunto = $asunto;
			
			$emailer->contenido = '<h1>'.$asunto.'</h1>';
			$emailer->contenido .= $mensaje;
			$emailer->contenido .= $this->email_mensaje($estado);
			
			if ($emailer->enviar()){
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	private function email_mensaje($estado){
		if (empty($this->id) || empty($estado))
			return false;
			
		if ($this->datos["metodo_pago"]["id"] == 'transferencia'){
			e_include('ext_shop/class/pago');
		
			$pasarelas = new Pago();
			$pasarelas = $pasarelas->get_available_pasarelas_pago();
			
			$transf = $pasarelas["transferencia"];
			
			$instrucciones_pago = nl2br($transf->instrucciones[SistemaIdioma::getIdiomaSesion()]);
		}
		
		$estado_obj = new EstadoPedidoShop($estado);
		$params_estado = Helpers::toArray(json_decode($estado_obj->params));
		
		$file_email = CONF_REALPATH_APP . $params_estado['email_notificacion'];
		
		if (!empty($params_estado['email_notificacion']) && is_file($file_email)){
			ob_start();
			
			include($file_email);
			
			$out = ob_get_contents();
			
			ob_end_clean();
		} else {
			$out = '';
		}
				
		return $out;
	}
	
	function enviar_email_pedido($accion) {
        if (empty($accion))
            return false;
        $config_act = $GLOBALS['opciones']['ext_shop']['notificaciones'];
        $web_name = $GLOBALS['opciones']['sitio']['nombre_sitio'][SistemaIdioma::getIdiomaSesion()];
        $email_send = $config_act['notificar_email'];
        if (empty($email_send))
            $email_send = $GLOBALS['opciones']['emailer']['email_emailer'];
		$estado_act = 0;
		
        switch ($accion) {
            case 'nuevo':
				$estado_act = $GLOBALS['opciones']['ext_shop']['venta']['estado_creado'];
				break;
            case 'en_proceso':
				$estado_act = $GLOBALS['opciones']['ext_shop']['venta']['estado_procesando'];
				break;
            case 'enviado':
				$estado_act = $GLOBALS['opciones']['ext_shop']['venta']['estado_enviado'];
				break;
            case 'completado':
				$estado_act = $GLOBALS['opciones']['ext_shop']['venta']['estado_completado'];
				break;
            case 'fallido':
				$estado_act = $GLOBALS['opciones']['ext_shop']['venta']['estado_fallido'];
				break;
            case 'cancelado':
				$estado_act = $GLOBALS['opciones']['ext_shop']['venta']['estado_cancelado'];
				break;
            default:
                return false;
                break;
        }
		
		$asunto_key = 'notificar_asunto_' . $accion;
		$txt_key = 'notificar_texto_' . $accion;
		$asunto = $config_act[$asunto_key][SistemaIdioma::getIdiomaSesion()];
		$txt = $config_act[$txt_key][SistemaIdioma::getIdiomaSesion()];
		if (empty($asunto))
			return false;
        $asunto = $this->parsearVariablesItem($asunto);
        $txt = $this->parsearVariablesItem($txt);
				
		return $this->enviar_mensaje($estado_act, $asunto, $txt, array($this->email=>$this->datos['facturacion']['nombre']), array($email_send=>$email_send));
    }
	
	function parsearVariablesItem($txt) {
        if (empty($txt))
            return '';
        global $AppTpl;
        $creador = new Usuario();
		$creador->setid($this->usuario_id);
        if ($creador = $creador->BuscarId()) {
		} else {
            $creador = new Usuario();
            $creador->nombre = $this->datos['facturacion']['nombre'];
		}
        $fecha = strftime(SistemaIdioma::formatoFecha('corta'), strtotime($this->fecha));
        $fecha_dia = strftime('%d', strtotime($this->fecha));
        $fecha_mes = strftime('%b', strtotime($this->fecha));
        $fecha_anyo = strftime('%Y', strtotime($this->fecha));
		
		$fecha_actual =  strftime(SistemaIdioma::formatoFecha('larga'), time());
        if (in_array('fecha_inicio', $this->update_vars)) {
            $fecha_inicio = strftime(SistemaIdioma::formatoFecha('corta'), strtotime($this->fecha_inicio));
            $fecha_inicio_dia = strftime('%d', strtotime($this->fecha_inicio));
            $fecha_inicio_mes = strftime('%b', strtotime($this->fecha_inicio));
            $fecha_inicio_anyo = strftime('%Y', strtotime($this->fecha_inicio));
        }
        if (!empty($this->hora_inicio)) {
            $hora_inicio = $this->hora_inicio;
        }
        if (!empty($this->hora_fin)) {
            $hora_inicio = $this->hora_fin;
        }
        if (in_array('fecha_fin', $this->update_vars)) {
            $fecha_fin = strftime(SistemaIdioma::formatoFecha('corta'), strtotime($this->fecha_fin));
            $fecha_fin_dia = strftime('%d', strtotime($this->fecha_fin));
            $fecha_fin_mes = strftime('%b', strtotime($this->fecha_fin));
            $fecha_fin_anyo = strftime('%Y', strtotime($this->fecha_fin));
        }
        $info_origen = $this->info_origen;
        $origen = '';
        $origen_url = '';
        if (is_array($info_origen)) {
            $origen = $info_origen['titulo'];
            $origen_url = $info_origen['url'];
        }
        $out = str_replace('##TITULO##', $this->titulo, $txt);
		$out = str_replace('##TOKEN##', Helpers::getFormToken(), $out);
		$out = str_replace('##CURRENTURL##', Helpers::currentUrl(), $out);
		$out = str_replace('##CREADORID##', $this->usuario_id, $out);
        $out = str_replace('##CREADOR##', $creador->getnombre_completo(), $out);
        $out = str_replace('##CREADOR_EMAIL##', $this->email, $out);
        $out = str_replace('##URL##', $this->getLink(), $out);
        $out = str_replace('##ID##', $this->id, $out);
        $out = str_replace('##ORIGEN##', $origen, $out);
        $out = str_replace('##ORIGEN_URL##', $origen_url, $out);
		$out = str_replace('##DIRECCION##', $this->datos['facturacion']['direccion'], $out);
		$out = str_replace('##CODIGO_POSTAL##', $this->datos['facturacion']['codigo_postal'], $out);
		$out = str_replace('##PAIS##', $this->datos['facturacion']['pais'], $out);
		$out = str_replace('##PROVINCIA##', $this->datos['facturacion']['provincia'], $out);
		$out = str_replace('##LOCALIDAD##', $this->datos['facturacion']['localidad'], $out);
        $out = str_replace('##LOCALIZACION##', strip_tags($this->print_datos_facturacion_html(), '<b><strong><i>'), $out);
		$out = str_replace('##TOTAL##', Helpers::Importe($this->datos['total']['total']).ShopHelper::get_shop_moneda_simbolo(), $out);
		$out = str_replace('##FECHA_ACTUAL##', $fecha_actual, $out);
        $out = str_replace('##FECHA##', $fecha, $out);
        $out = str_replace('##FECHA_DIA##', $fecha_dia, $out);
        $out = str_replace('##FECHA_MES##', $fecha_mes, $out);
        $out = str_replace('##FECHA_ANYO##', $fecha_anyo, $out);
        if (in_array('fecha_inicio', $this->update_vars)) {
            $out = str_replace('##FECHA_INICIO##', $fecha_inicio, $out);
            $out = str_replace('##FECHA_INICIO_DIA##', $fecha_inicio_dia, $out);
            $out = str_replace('##FECHA_INICIO_MES##', $fecha_inicio_mes, $out);
            $out = str_replace('##FECHA_INICIO_ANYO##', $fecha_inicio_anyo, $out);
        }
        if (in_array('fecha_fin', $this->update_vars)) {
            $out = str_replace('##FECHA_FIN##', $fecha_fin, $out);
            $out = str_replace('##FECHA_FIN_DIA##', $fecha_fin_dia, $out);
            $out = str_replace('##FECHA_FIN_MES##', $fecha_fin_mes, $out);
            $out = str_replace('##FECHA_FIN_ANYO##', $fecha_fin_anyo, $out);
        }
        if (!empty($this->hora_inicio)) {
            $out = str_replace('##HORA_INICIO##', $hora_inicio, $out);
        }
        if (!empty($this->hora_fin)) {
            $out = str_replace('##HORA_FIN##', $hora_fin, $out);
        }
        return $out;
    }
	
	function get_estado_con_pago(){
		if (empty($this->id))
			return false;
			
		$metodo_pago = $this->datos['metodo_pago']['titulo'];
		$estado_metodo_pago = $this->parse_status_paypal($this->datos['metodo_pago']['estado']);
		
		$estado_pedido = ucfirst($this->getestado(true));
		
		$txt = sprintf(__('<b>%s</b>: pago %s a través de %s'), $estado_pedido, $estado_metodo_pago, $metodo_pago);
		
		return $txt;
	}
	
	function parse_status_paypal($estado){
		if (empty($estado))
			return '';
			
		switch ($estado){
			case 'pending':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_pendiente'];
				break;
			case 'completed':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_completado'];
				break;
			case 'denied':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_fallido'];
				break;
			case 'expired':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_fallido'];
				break;
			case 'failed':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_fallido'];
				break;
			case 'voided':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_cancelado'];
				break;
			case 'refunded':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_cancelado'];
				break;
			case 'reversed':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_cancelado'];
				break;
			case 'chargeback':
				return $GLOBALS['opciones']['ext_shop']['venta']['estado_cancelado'];
				break;
			default:
				return $estado;
				break;
		}
	}
	
	function print_datos_facturacion_html(){
		if (!is_array($this->datos['facturacion']) || empty($this->datos['facturacion']))
			return false;
			
		$datos = $this->datos['facturacion'];
			
		$out = '';
		
		if (!empty($datos['Escalera']))
			$datos['direccion'] .= ', '.$datos['Escalera'];
			
		if (!empty($datos['Piso']))
			$datos['direccion'] .= ', '.$datos['Piso'];
			
		if (!empty($datos['Puerta']))
			$datos['direccion'] .= ', '.$datos['Puerta'];
		
		$out .= '<b>' . $datos['nombre'] . ' ' . $datos['apellidos'] . '</b><br>';
		if (!empty($datos['empresa'])){
			$out .= $datos['empresa'] . '<br>';
		}
		if (!empty($datos['nif'])){
			$out .= $datos['nif'] . '<br>';
		}
		$out .= $datos['direccion'] . '<br>';
		$out .= $datos['codigo_postal'] . ' ' . $datos['nombre_localidad'] . '<br>';
		$out .= $datos['nombre_provincia'] . ' ' . strtoupper($datos['nombre_pais']);
		
		return $out;
	}
	
	function print_datos_envio_html(){
		if (!is_array($this->datos['facturacion']) || empty($this->datos['facturacion']))
			return false;
			
		if ($this->envio_a_facturacion == 1){
			$datos = $this->datos['facturacion'];
			
			if (!empty($datos['Escalera']))
				$datos['direccion'] .= ', '.$datos['Escalera'];
				
			if (!empty($datos['Piso']))
				$datos['direccion'] .= ', '.$datos['Piso'];
				
			if (!empty($datos['Puerta']))
				$datos['direccion'] .= ', '.$datos['Puerta'];
			
			$out = '';
		
			$out .= '<b>' . $datos['nombre'] . ' ' . $datos['apellidos'] . '</b><br>';
			$out .= $datos['direccion'] . '<br>';
			$out .= $datos['codigo_postal'] . ' ' . $datos['nombre_localidad'] . '<br>';
			$out .= $datos['nombre_provincia'] . ' ' . strtoupper($datos['nombre_pais']);
		} else {
			$datos = $this->datos['envio'];
			
			if (!empty($datos['Escalera']))
				$datos['direccion'] .= ', '.$datos['Escalera'];
				
			if (!empty($datos['Piso']))
				$datos['direccion'] .= ', '.$datos['Piso'];
				
			if (!empty($datos['Puerta']))
				$datos['direccion'] .= ', '.$datos['Puerta'];
			
			$out = '';
		
			$out .= '<b>' . $datos['envio_nombre'] . ' ' . $datos['envio_apellidos'] . '</b><br>';
			$out .= $datos['envio_direccion'] . '<br>';
			$out .= $datos['envio_codigo_postal'] . ' ' . $datos['nombre_localidad'] . '<br>';
			$out .= $datos['nombre_provincia'] . ' ' . strtoupper($datos['nombre_pais']);
		}
		return $out;
	}
	
	function print_envio($html=false){
		if (!is_array($this->datos['facturacion']) || empty($this->datos['facturacion']))
			return false;
			
		$out='';
		
		if ($html == true){
			$out = $this->print_datos_envio_html();
		} else {
			
			if ($this->envio_a_facturacion == 1){
				$datos = $this->datos['facturacion'];
				
				$out = '';
			
				$out .= $datos['nombre'] . ' ' . $datos['apellidos'] . ', ';
				$out .= $datos['direccion'] . ', ';
				$out .= $datos['codigo_postal'] . ' ' . $datos['nombre_localidad'] . ', ';
				$out .= $datos['nombre_provincia'];
			} else {
				$datos = $this->datos['envio'];
				
				$out = '';
			
				$out .= '<b>' . $datos['envio_nombre'] . ' ' . $datos['envio_apellidos'] . ', ';
				$out .= $datos['envio_direccion'] . ', ';
				$out .= $datos['envio_codigo_postal'] . ' ' . $datos['nombre_localidad'] . ', ';
				$out .= $datos['nombre_provincia'];
			}
		
		}
		
		return $out;
		
	}
	
	function get_num_productos(){
		if (empty($this->lineas) || !is_array($this->lineas))
			return 0;
			
		$cuenta_productos = 0;
		
		foreach ($this->lineas as $linea){
			$cuenta_productos += (int) $linea->cantidad;
		}
		
		return (int) $cuenta_productos;
		
	}
	
	function esta_facturado($link_id=false){
		if (empty($this->id))
			return false;
			
		e_include("ext_shop/class/facturaShop", "ext_shop/class/facturaLineaShop", "ext_shop/class/cliente", "ext_shop/class/producto");
		
		if (!class_exists("FacturaShop")){
			return false;
		}
		
		$fs = new FacturaShop();
		$ids_pedidos_facturados = $fs->getIDPedidosFacturados();
		
		if (in_array($this->id, $ids_pedidos_facturados)){
			$fs = $fs->Listar("pedido_id='".$this->id."'");
			$fs = $fs[0];
			
			if ($link_id == true){
				return $fs->id;
			} else {
				return $fs->codigo."/".$fs->ejercicio;
			}
		}
		
		return false;
		
	}
	
	function puede_facturarse(){
		e_include("ext_shop/class/facturaShop");
		
		$fs = new FacturaShop();
		$ids_pedidos_facturados = $fs->getIDPedidosFacturados();
		
		if (in_array($this->id, $ids_pedidos_facturados)){
			return false;
		}
		
		if ($this->estado != $GLOBALS['opciones']['ext_shop']['venta']['estado_completado']){
			return false;
		}
		
		return true;
	}
	
	function facturar(){
		c_include('usuario');
		e_include("ext_shop/class/facturaShop", "ext_shop/class/facturaLineaShop", "ext_shop/class/cliente", "ext_shop/class/producto", "ext_shop/class/productoVariacion");
		
		if (!class_exists("FacturaShop")){
			throw new Exception('No existe la clase FacturaShop');
		}
		
		$fs = new FacturaShop();
		$ids_pedidos_facturados = $fs->getIDPedidosFacturados();
		
		if (in_array($this->id, $ids_pedidos_facturados)){
			throw new Exception('¡El pedido ya se ha facturado!');
		}
		
		if ($this->estado != $GLOBALS['opciones']['ext_shop']['venta']['estado_completado']){
			throw new Exception('¡El pedido no se puede facturar!');
		}
				
		$fecha_factura = strftime("%Y-%m-%d", time());
		
		$ejercicio_factura = strftime("%Y", time());
		
		$fs->setejercicio($ejercicio_factura);
		$fs->setusuario_id($this->usuario_id);
		$fs->setcreador_id(Usuario::getLogedId(true));
		$fs->setdatos_facturacion($this->datos_facturacion);
		
		$envio_total = $this->datos['total']['envio_total'];
		$envio_impuesto_total = $this->datos['total']['envio_impuesto_total'];
		
		$gastosenvio = true;
		if ($envio_total + $envio_impuesto_total - $this->datos['total']['descuento_total'] == 0){
			$gastosenvio = false;
		}
		$fs->setpedido_id($this->id);
		$fs->setestado('pagada');
		$fs->setfecha($fecha_factura);
		$fs->setcomentarios($this->comentarios);
		$fs->setbase_imponible($this->datos['total']['subtotal_ex_impuesto'] + $this->datos['total']['envio_total']);
		if ($gastosenvio == false){
			$fs->settotal_descuento(0);
		} else {
			$fs->settotal_descuento(-$this->datos['total']['descuento_total']);
		}
		$fs->settotal_impuesto($this->datos['total']['impuesto_total'] + $this->datos['total']['envio_impuesto_total']);
		$fs->settotal_recargo(0);
		$fs->settotal_retencion(0);
		if ($gastosenvio == false){
			$fs->settotal($this->datos['total']['subtotal_ex_impuesto'] + $this->datos['total']['impuesto_total']);
		} else {
			$fs->settotal($this->datos['total']['subtotal_ex_impuesto'] + $this->datos['total']['envio_total'] + $this->datos['total']['impuesto_total'] + $this->datos['total']['envio_impuesto_total'] - $this->datos['total']['descuento_total']);
		}
		$fs->setforma_pago($this->datos['metodo_pago']['id']);
		
		$next_id = $fs->calcular_siguiente_id($ejercicio_factura);
		
		if ($next_id > 0)
			$fs->setcodigo($next_id);
		
		if ($last_id_factura = $fs->Guardar()){
			
			$tmp_fs = new FacturaShop();
			$tmp_fs->setid($last_id_factura);
			$tmp_fs->setejercicio($ejercicio_factura);
			
			if ($tmp_fs = $tmp_fs->BuscarId()){
			} else {
				throw new Exception('No existe la factura');
			}
			
			$subtotal_lineas = 0;
			$impuestos_total_lineas = 0;
			if (is_array($this->lineas) && sizeof($this->lineas)){
				foreach ($this->lineas as $lin){
					$tmp_linea_factura = new FacturaLineaShop();
					
					$product_obj = unserialize($lin->data);
					
					if (empty($product_obj->id)){
						$product_obj = new Producto();
						$product_obj->setid($lin->product_id);
						
						$product_obj = $product_obj->BuscarId();
					}
					
					$nombre_producto = __("Producto");
					$tmp_nombre_producto = SistemaIdioma::Imprimir($product_obj->nombre);
					if (!empty($tmp_nombre_producto))
						$nombre_producto = $tmp_nombre_producto;
						
					$variation_arr = Helpers::toArray(json_decode($lin->variation));
					
					if (is_array($variation_arr) && sizeof($variation_arr) > 0){
						foreach ($variation_arr as $kvar=>$var){
							$nombre_producto .= " - " . $kvar.": ".$var;
						}
					}
					
					$tmp_linea_factura->setfactura_id($tmp_fs->id);
					$tmp_linea_factura->setejercicio($ejercicio_factura);
					$tmp_linea_factura->setproducto_id($lin->product_id);
					$tmp_linea_factura->setnombre_producto(utf8_decode($nombre_producto));
					$tmp_linea_factura->setcantidad($lin->cantidad);
					$tmp_linea_factura->setdata($lin->data);
					$tmp_linea_factura->setlinea_impuesto($lin->linea_impuesto);
					$tmp_linea_factura->setlinea_subtotal($lin->linea_subtotal);
					$tmp_linea_factura->setlinea_subtotal_impuesto($lin->linea_subtotal_impuesto);
					$tmp_linea_factura->setlinea_total($lin->linea_total);
					
					if ($tmp_linea_factura->Guardar()){
					} else {
						throw new Exception('Problema al guardar la línea de la factura');
					}
				}
			}
			
			if ($envio_total > 0 && $gastosenvio == true){
				$linea_envio = new FacturaLineaShop();
				$linea_envio->setfactura_id($last_id_factura);
				$linea_envio->setejercicio($ejercicio_factura);
				$linea_envio->setproducto_id(0);
				$linea_envio->setnombre_producto(__('Gastos de envío'));
				$linea_envio->setcantidad(1);
				$linea_envio->setdata("");
				$linea_envio->setlinea_impuesto($envio_impuesto_total);
				$linea_envio->setlinea_subtotal($envio_total);
				$linea_envio->setlinea_subtotal_impuesto($envio_impuesto_total);
				$linea_envio->setlinea_total($envio_total);
				
				$linea_envio->Guardar();
			}
			
		} else {
			throw new Exception('Problema al guardar la factura');
		}
		
		return true;
	}
	
	public function getInfo(){
		$this->formatDatos();
	}
	
	function getLink($url_amigable=false,$lang=null)
    {
		if (empty($lang))
			$lang = SistemaIdioma::getIdiomaSesion();
			
		$link = '';
		if ($GLOBALS['opciones']['metadatos']['urls_amigables_metadatos'] == 0 && $url_amigable==false){
			$link .= "?extension=ext_shop&vista=pedido&id=" . $this->id;
			
			$parametros = Helpers::toArray(json_decode($this->params));
			if (!empty($parametros['estilo'])){
				$link .= '&estilo='.$parametros['estilo'];
			} else {
				$parametros['estilo'] = '';
			}
			$link .= '&lang='.$lang;
		} else {
			c_include('enlace');
			
			$enlace_bd = new Enlace();
			$enlace_bd_c = $enlace_bd->ListarCount("tipo='ext_shop' AND vista='pedido' AND id_elemento='".$this->id."'");
			
			if ($enlace_bd_c > 0){
				$enlace_bd = $enlace_bd->Listar("tipo='ext_shop' AND vista='pedido' AND id_elemento='".$this->id."'");
				$link = $enlace_bd[0]->printLink(1);
				
				return $link;
			}
			
			$params_link = array();
			$enlace_cat_sel = new Enlace();
			$enlace_cat_sel_c = $enlace_cat_sel->ListarCount("tipo='ext_shop' AND vista='lista_pedidos'");
			if ($enlace_cat_sel_c >0){
				$enlace_cat_sel = $enlace_cat_sel->Listar("tipo='ext_shop' AND vista='lista_pedidos'");
				$enlace_cat_sel = $enlace_cat_sel[0];
				
				$link = $enlace_cat_sel->printLink(1, SistemaIdioma::getIdiomaSesion()).'/'.$this->id;
				
				return $link;
			}
			$link .= Helpers::ArmaURLAmigable('ext_shop', 'producto', $this->id, $this->id, $parametros['estilo'], $lang);
		}
        return $link;
    }
	
	public function get_estadisticas($group_by='dia', $dia_inicio, $dia_fin){
		$stats = parent::get_estadisticas($group_by, $dia_inicio, $dia_fin);
		
		if (empty($dia_inicio) || empty($dia_fin)){
			$dia_inicio = strftime('%Y-%m-%d 00:00:00', time() - 2592000);
			$dia_fin = strftime('%Y-%m-%d 23:59:00', time());
		}
		
		$where = "fecha BETWEEN '".$dia_inicio."' AND '".$dia_fin."'";
		
		$pedidos_est = new PedidoShop();
		$pedidos_est_c = $pedidos_est->ListarCount($where);
		
		if ($pedidos_est_c > 0){
			$pedidos_est = $pedidos_est->Listar($where, 'fecha', 'ASC');
			
			foreach ($pedidos_est as $pe){
				foreach ($stats as $kst=>$st){
					if ($st->fecha == strftime("%Y-%m-%d", strtotime($pe->fecha))){
						$stats[$kst]->total += $pe->datos['total']['total'];
					}
				}
			}
		}
		
		return $stats;
	}
}
?>