<?php
defined('CONF_URL_APP') or die;
		
class Producto extends ItemModel
{
	protected $dbt_const = "DBT_PRODUCTOS";
	protected $dbt = "shop_productos";
	
	protected $ext_folder = "ext_shop";
	protected $ext_vista_categoria = "categoria_productos";
	protected $ext_vista_item = "producto";
	
	protected $ext_item_class = "Producto";
	protected $ext_categoria_class = "CategoriaProducto";
	protected $ext_item_campoextra_class = "ProductoCampoExtra";
	
	protected $all_vars = array("id","nombre","sku","alias","contenido","texto_corto","fecha","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","location","acceso","id_original","precio","precio_rebajado","desde_precio_rebajado","hasta_precio_rebajado","destacado","solocatalogo","stock","impuesto","peso","atributos","fabricante","cuenta_descargas");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("nombre","sku","alias","contenido","texto_corto","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","location","acceso","id_original","precio","precio_rebajado","desde_precio_rebajado","hasta_precio_rebajado","destacado","solocatalogo","stock","impuesto","peso","atributos","fabricante","cuenta_descargas");
	protected $campos_multilang = array("nombre","alias","contenido","texto_corto","lugar");
	protected $campos_array = array("params","categorias","atributos");
	
	protected $campo_titulo = 'nombre';
	protected $campo_subtitulo = 'precio_formateado';
	
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_shop/class/impuestoShop', 'ext_shop/class/impuestoTarifa', 'ext_shop/class/categoriaProducto', 'ext_shop/class/productoVariacion', 'ext_shop/class/productoAtributo', 'ext_shop/class/productoAtributoValor', 'ext_shop/class/helper');
	}
	
	function getfabricante($objeto=false){
		if ($objeto == true){
			e_include('ext_shop/class/fabricante');
			$fab = new FabricanteShop();
			$fab->setid($this->fabricante);
			if ($fab = $fab->BuscarId()){
				return $fab;
			} else {
				return false;
			}
		} else {
			return $this->fabricante;
		}
	}
    
    function getprecio($precio_actual=false,$tipo='actual',$forzar_con_impuestos=false)
    {
		if ($precio_actual == false){
       		$precio_real = $this->get_precio_real('no_rebajado');
			if ($forzar_con_impuestos == true){
				return $precio_real['precio_total'];
			} else {
				return $precio_real['precio_base'];
			}
		} else {
			$precio_real = $this->get_precio_real($tipo);
			if ($forzar_con_impuestos == true){
				return $precio_real['precio_total'];
			} else {
				return $precio_real['precio_base'];
			}
		}
    }
    function getprecio_rebajado($precio_actual=false, $forzar_con_impuestos=false)
    {
        if ($precio_actual == false){
       		return $this->precio_rebajado;
		} else {
			if ($this->precio_rebajado > 0){
				$precio_real = $this->get_precio_real('rebajado');
				if ($forzar_con_impuestos){
					return $precio_real['precio_total'];
				} else {
					return $precio_real['precio_base'];
				}
			} else {
				return 0;
			}
		}
    }
    function getimpuesto($object=false)
    {
		if ($object == true){
			$tarifa = new ImpuestoTarifa();
			$tarifa->getTarifasImpuesto();
			
			$config_shop = App::getConfigValue('ext_shop');
			
			global $paises_defecto_shop;
			
			if (is_array($paises_defecto_shop)){
				$pais_defecto = $paises_defecto_shop;
			} else {
				$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
				$pais_defecto = $paises_defecto_shop;
			}
			$pais_defecto = $pais_defecto[0];
			
			if (isset($tarifa->tarifas_parseadas[$pais_defecto][$this->impuesto][0]['tarifa'])){
				return $tarifa->tarifas_parseadas[$pais_defecto][$this->impuesto][0]['tarifa'];
			} else {
				return 0;
			}
		} else {
       		return $this->impuesto;
		}
    }
	//virtual
	function es_virtual(){
		if (empty($this->params))
			return false;
			
		$tmp_arr = Helpers::toArray(json_decode($this->params));
		if (empty($tmp_arr["virtual"]))
			return false;
		elseif ($tmp_arr["virtual"] == "1")
			return true;
		else
			return false;
	}
	//credito
	function es_credito(){
		if (empty($this->params))
			return false;
			
		$tmp_arr = Helpers::toArray(json_decode($this->params));
		if (empty($tmp_arr["virtual"]))
			return false;
		elseif ($tmp_arr["virtual"] == "1"){
			if ($tmp_arr["tipo_virtual"] == "creditos"){
				return true;
			} else {
				return false;
			}
		} else
			return false;
	}
	//get_credito
	function get_credito(){
		if (empty($this->params))
			return 0;
			
		$tmp_arr = Helpers::toArray(json_decode($this->params));
		if (empty($tmp_arr["virtual"]))
			return 0;
		elseif ($tmp_arr["virtual"] == "1"){
			if ($tmp_arr["tipo_virtual"] == "creditos"){
				if (!empty($tmp_arr["num_creditos_virtual"])){
					return $tmp_arr["num_creditos_virtual"];
				} else {
					return 0;
				}
			} else {
				return 0;
			}
		} else
			return 0;
	}
	
    function ListarCount($where = "", $orderBy, $orderS, $limit1 = 0, $limit2 = 0, $lang, $extra_append, $borradores = false, $having = '')
    {
		$extra_append .= ",IF (desde_precio_rebajado <= NOW() AND hasta_precio_rebajado >= NOW() AND precio_rebajado > 0, precio_rebajado, precio) as precio_calculado";
		
		return parent::ListarCount($where, $orderBy, $orderS, $limit1, $limit2, $lang, $extra_append, $borradores, $having);
    }
    function Listar($where = "", $orderBy, $orderS, $limit1 = 0, $limit2 = 0, $lang, $generar_info_items = true, $extra_append, $borradores = false, $having = '')
    {
        $extra_append .= ",IF (desde_precio_rebajado <= NOW() AND hasta_precio_rebajado >= NOW() AND precio_rebajado > 0, precio_rebajado, precio) as precio_calculado";
		
		return parent::Listar($where, $orderBy, $orderS, $limit1, $limit2, $lang, $generar_info_items, $extra_append, $borradores, $having);
    }
    
	function getCategoriasAlias($separador=" ")
    {
			$cats=json_decode($this->categorias);
			$c_array = array();
			foreach($cats as $c){
				$c_obj = new CategoriaProducto();
				$c_obj->setid($c);
				if ($c_obj = $c_obj->BuscarId())
					$c_array[] = SistemaIdioma::Imprimir($c_obj->alias);
			}
			
			return implode($separador, $c_array);
    }
	function getProductoVariaciones()
    {
		if (empty($this->id))
			return false;
		
		$ce = new ProductoVariacion();
		$ce_c = $ce->ListarCount("producto_id='".$this->id."'");
		
		if ($ce_c > 0){
			$ce = $ce->Listar("producto_id='".$this->id."'","id","DESC");
			return $ce;
		} else {
			return false;
		}
    }
	/**
	 * Recupera las variaciones del producto desde los atributos
	 */
	 function getVariaciones(){
		 $atributos = Helpers::toArray(json_decode($this->atributos));
		 $atr_parsed = array();
		 
		 if (is_array($atributos) && sizeof($atributos) > 0){
			 foreach ($atributos as $atr=>$sels){
				 $pa = new ProductoAtributo();
				 $pa->setid($atr);
				 
				 if ($pa = $pa->BuscarId()){
					 $pa->valor = $sels;
					 
					 if (is_array($sels) && sizeof($sels) > 0){
						 $sels_parsed = array();
						 foreach ($sels as $pav_id){
							 $pav = new ProductoAtributoValor();
							 $pav->setid($pav_id);
							 
							 if ($pav = $pav->BuscarId()){
								 $sels_parsed[] = $pav;
							 }
						 }
						 $pa->valor_parsed = $sels_parsed;
					 }
					 
					 $atr_parsed[] = $pa;
				 }
			 }
			 
			 return $atr_parsed;
		 } else {
			 return false;
		 }
	 }
	
	function necesita_envio(){
		$config_tienda = $GLOBALS['opciones']['ext_shop'];
		
		if ($config_tienda['envios']['activar_envios'] == "1" && !$this->es_virtual())
			return true;
		else
			return false;
	}
	
	/** Returns the product shipping class */
	function get_envio_class() {
		if (!$this->envio_class) :
			$this->envio_class = 'estandar';
		endif;
		return $this->envio_class;
	}
	
	public static function get_reglas_precios_sesion(){
		$_reglas = Helpers::getSesion()->get('shop.reglas');
		
		return $_reglas;
	}
	
	function get_precio_real($tipo='actual'){
		e_include("ext_shop/class/reglaPrecio");
		
		$config_shop = App::getConfigValue('ext_shop');
		$impuesto = new ImpuestoTarifa();
		
		$_product = $this;
		
		global $paises_defecto_shop;
			
		if (is_array($paises_defecto_shop)){
			$paises_defecto = $paises_defecto_shop;
		} else {
			$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
			$paises_defecto = $paises_defecto_shop;
		}
								
		$usr_sess = Helpers::getSesion()->get('shop.usuario');
		
		$pais_usr = $usr_sess['pais'];
		$prov_usr = $usr_sess['provincia'];
		
		if (empty($prov_usr))
			$prov_usr = 0;
		
		if (empty($pais_usr)){
			$localizacion_usr = $GLOBALS['opciones']['ext_shop']['shop']['localizacion_defecto'];
		} else {
			$localizacion_usr = $pais_usr.'.'.$prov_usr;
		}
		
		$tipo = trim($tipo);
			
		$base_precio = 0;
		// Base Price (inlusive of impuesto for now)
		switch ($tipo){
			case 'actual':
				if ($this->precio_rebajado > 0 && strtotime($this->desde_precio_rebajado) < time() && strtotime($this->hasta_precio_rebajado) > time()) {
					$base_precio = $_product->precio_rebajado;
				} else {
					$base_precio = $_product->precio;
				}
				break;
				
			case 'no_rebajado':
				$base_precio = $_product->precio;
				break;
				
			case 'rebajado':
				if ($this->precio_rebajado > 0 && strtotime($this->desde_precio_rebajado) < time() && strtotime($this->hasta_precio_rebajado) > time()) {
					$base_precio = $_product->precio_rebajado;
				} else {
					$base_precio = 0;
				}
				break;
				
			default:
				$base_precio = 0;
				break;
		}
		
		$reglas_disponibles = self::get_reglas_precios_sesion();
		
		foreach ( $reglas_disponibles as $kregla=>$regla ) {
			$obj_regla = new ReglaPrecio();
			$obj_regla->setid($regla['id']);
			$obj_regla = $obj_regla->BuscarId();
			
			$params_regla = Helpers::toArray(json_decode($obj_regla->params));
			
			if ($params_regla['precios_producto_global'] == '1'){
				
				if ($regla['accion']['tipo'] == 'cesta.producto' && !in_array($regla['id'], $this->reglas_ya_aplicadas)){
					
					$ids_productos_disponibles = explode(',', $regla['accion']['cantidad_descuento']);
					foreach ($ids_productos_disponibles as $kid=>$idd){
						$ids_productos_disponibles[$kid] = trim($idd);
					}
					
					$cantidad_descuento = 0;
	
					if (in_array($this->id,$ids_productos_disponibles)){
						$cantidad_descuento = (float) $base_precio;
						$this->reglas_ya_aplicadas[] = $regla['id'];
					}
					
					$base_precio = $base_precio - $cantidad_descuento;
					
				} elseif (($regla['accion']['tipo'] == 'productos.porcentaje' || $regla['accion']['tipo'] == 'productos.importe') && !in_array($regla['id'], $this->reglas_ya_aplicadas)){
					
					if (strpos($regla['accion']['cantidad_descuento'], '/')){
						$val_descuento = explode('/', $regla['accion']['cantidad_descuento']);
						$id_prod = $val_descuento[1];
						$val_descuento = $val_descuento[0];
					} else {
						$val_descuento = $regla['accion']['cantidad_descuento'];
						$id_prod = 0;
					}
	
					switch ($regla['accion']['tipo']){
						case 'productos.importe':
							if ($id_prod == 0 || ($id_prod == $this->id)){
								$base_precio = $base_precio - $val_descuento;
							}
							break;
						case 'productos.porcentaje':
							if ($id_prod == 0 || ($id_prod == $this->id)){
								$percent_discount = round( ( round($base_precio, 2) ) * ((float) $val_descuento / 100 ), 2);
								$base_precio = $base_precio - $percent_discount;
							}
							break;
					}
				}
			}
		}
		
		// Now calc the main totals, including discounts
			if ( $config_shop['impuestos']['impuestos_incluidos'] == '1' ) {
				
						/** 
						 * Prices include impuesto
						 *
						 * To prevent rounding issues we need to work with the inclusive precio where possible
						 * otherwise we'll see errors such as when working with a 9.99 inc precio, 20% VAT which would
						 * be 8.325 leading to totals being 1p off
						 *
						 * Pre impuesto cupones come off the precio the customer thinks they are paying - impuesto is calculated
						 * afterwards.
						 *
						 * e.g. $100 bike with $10 coupon = customer pays $90 and impuesto worked backwards from that
						 *
						 * Used this excellent article for reference:
						 *	http://developer.practicalecommerce.com/articles/1473-Coding-for-Tax-Calculations-Everything-You-Never-Wanted-to-Know-Part-2
						 */
						
						
						// Base Price Adjustment
						if ( $config_shop['impuestos']['activar_impuestos'] == '1' ) {
							
							// Get tarifas
							$impuesto_tarifas			 		= $impuesto->get_tarifas( $_product->impuesto );
		
							/**
							 * ADJUST TAX - Checkout calculations when customer is OUTSIDE the shop base pais and precios INCLUDE impuesto
							 * 	OR
							 * ADJUST TAX - Checkout calculations when a impuesto class is modified
							 */
							if ( !in_array($localizacion_usr, $paises_defecto) || empty($pais_usr) ) {
								
								// Get impuesto tarifa for the store base, ensuring we use the unmodified impuesto_class for the product
								$base_impuesto_tarifas 		= $impuesto->get_tarifa_base_tienda( $_product->impuesto_class );
								// Work out new precio based on region
								$row_base_precio 			= $base_precio;
								$base_impuestos				= $impuesto->calc_impuesto( $row_base_precio, $base_impuesto_tarifas, true );
								$impuestos					= $impuesto->calc_impuesto( $row_base_precio - array_sum($base_impuestos), $impuesto_tarifas, false );
								
								// Tax amount
								$impuesto_amount				= array_sum( $impuestos );
								
								// Line subtotal + impuesto
								$linea_subtotal_impuesto 		= $impuesto_amount;
								$linea_subtotal			= $row_base_precio - $impuesto->get_impuesto_total($base_impuestos);
								
								// Adjusted precio 
								$adjusted_precio 		= $row_base_precio - array_sum($base_impuestos) + array_sum($impuestos) ;
							/**
							 * Regular impuesto calculation (customer inside base and the impuesto class is unmodified
							 */
							} else {
								$impuestos_array = $impuesto->calc_impuesto( $base_precio, $impuesto_tarifas, true );
								
								// Base impuesto for line before discount - we will store this in the order data
								$impuesto_amount				= array_sum( $impuestos_array );
								// Line subtotal + impuesto
								$linea_subtotal_impuesto 		= $impuesto_amount;
								$linea_subtotal			= ( $base_precio ) - $linea_subtotal_impuesto;
								
							}
						} else {
							$linea_subtotal_impuesto		= 0;
							$linea_subtotal			= $base_precio;
						}	
			} else {
						/** 
						 * Prices exclude impuesto
						 *
						 * This calculation is simpler - work with the base, unimpuestoed precio.
						 */
						// Tax Amount (For the line, based on discounted, ex.impuesto precio)
						if ( $config_shop['impuestos']['activar_impuestos'] == '1' ) {
						
							// Get impuesto tarifas
							$impuesto_tarifas 				= $impuesto->get_tarifas( $_product->impuesto );
							
							// Base impuesto for line before discount - we will store this in the order data
							$impuesto_amount				= array_sum( $impuesto->calc_impuesto( $base_precio, $impuesto_tarifas, false ) );
							
						} else {
							$impuesto_amount 			= 0;
						}
						
						// Line precios
						$linea_subtotal_impuesto	= $impuesto_amount;
						$linea_subtotal		= $base_precio;	
			}
			
			$valores = array('precio_original'=>(float) $base_precio, 'precio_base'=>$linea_subtotal, 'impuesto'=>$linea_subtotal_impuesto, 'precio_total'=>($linea_subtotal + $linea_subtotal_impuesto));
			
			return $valores;
	}
	
	function reducir_stock( $by = 1 ) {
		$opts = $GLOBALS['opciones']['ext_shop'];
		
		if ( $opts['producto']['habilitar_stock'] == '1' ) {
			if ($this->stock - $by >= 0){
				$this->stock = $this->stock - $by;
				$tmp_obj = $this;
				if ($tmp_obj->Modificar()){
					return $this->stock;
				} else {
					return false;
				}
			} else {
				return false;
			}
		}
	}
	
	function aumentar_stock( $by = 1 ) {
		$opts = $GLOBALS['opciones']['ext_shop'];
		
		if ( $opts['producto']['habilitar_stock'] == '1' ) {
			if ($this->stock + $by >= 0){
				$this->stock = $this->stock + $by;
				$tmp_obj = $this;
				if ($tmp_obj->Modificar()){
					return $this->stock;
				} else {
					return false;
				}
			} else {
				return false;
			}
		}
	}
	
	function imprimir_entrada($return='img', $cod_pedido, $cuenta=1){
		if (empty($this->id) || empty($cuenta) || empty($cod_pedido))
			return '';
			
		$params_prod = Helpers::toArray(json_decode($this->params));
		
		$coord = explode(';', $params_prod['params']['entradas_area_codigo']);
			
		$string = $this->id;
			
		if (strlen($string) < 6){
			$lon_str = 6 - strlen($string);
			for ($i=0; $i<$lon_str; $i++){
				$string = '0'.$string;
			}
		}
		
		$string2 = $cod_pedido;
			
		if (strlen($string2) < 6){
			$lon_str2 = 6 - strlen($string2);
			for ($i2=0; $i2<$lon_str2; $i2++){
				$string2 = '0'.$string2;
			}
		}
		
		$string3 = $cuenta;
			
		if (strlen($string3) < 3){
			$lon_str3 = 3 - strlen($string3);
			for ($i3=0; $i3<$lon_str3; $i3++){
				$string3 = '0'.$string3;
			}
		}
		
		$string = $string2 . '-' . $string . '-' . $string3;
		if (!empty($params_prod['params']['entradas_area_tamano_fuente']))
			$font = (int) $params_prod['params']['entradas_area_tamano_fuente'];
		else
			$font = 20;
		
		$angle = 0;
		
		$ttf = CONF_REALPATH_APP . 'extensions/ext_shop/assets/fonts/impact.ttf';
		
		$width = imagefontwidth($font) * strlen($string) ;
		
		$height = imagefontheight($font) ;
		
		$im = imagecreatefromjpeg(CONF_REALPATH_APP.$params_prod['params']['entradas_imagen']);
		
		if (is_array($coord) && sizeof($coord) == 4){
			$x = $coord[0];
			$y = $coord[1] + ($height * 1.5);
		} else {
			$x = imagesx($im) - $width ;
			$y = imagesy($im) - $height;
		}
		
		$backgroundColor = imagecolorallocate ($im, 255, 255, 255);
		
		$textColor = imagecolorallocate ($im, 0, 0,0);
		
		imagettftext ($im, $font, $angle, $x, $y, $textColor, $ttf, $string);
		if ($params_prod['params']['entradas_detalles_imagen'] == 1){
			$coord2 = explode(';', $params_prod['params']['entradas_area_detalles']);
			
			$string_detalles = SistemaIdioma::Imprimir($this->nombre).'
';
			
			$string_detalles .= strftime('%d %B %Y', strtotime($this->entradas_fecha)).' a las '.$this->entradas_hora.'
';
			$string_detalles .= $this->entradas_local;
			
			if (!empty($params_prod['params']['entradas_detalles_tamano_fuente']))
				$font2 = (int) $params_prod['params']['entradas_detalles_tamano_fuente'];
			else
				$font2 = 20;
			
			$angle2 = 0;
			
			$ttf2 = CONF_REALPATH_APP . 'extensions/ext_shop/assets/fonts/impact.ttf';
			
			$width2 = imagefontwidth($font2) * strlen($string_detalles) ;
			
			$height2 = imagefontheight($font2) ;
			
			if (is_array($coord2) && sizeof($coord2) == 4){
				$x2 = $coord2[0];
				$y2 = $coord2[1] + ($height2 * 1.3);
				
				$max_width = $coord2[2] - $coord2[0];
			} else {
				$x2 = imagesx($im2) - $width2 ;
				$y2 = imagesy($im2) - $height2;
				
				$max_width = $width2;
			}
			
			$backgroundColor2 = imagecolorallocate ($im2, 255, 255, 255);
			
			$textColor2 = imagecolorallocate ($im2, 0, 0,0);
						
			$this->imagettftextbox ($im, $font2, $angle2, $x2, $y2, $textColor2, $ttf2, $string_detalles, $max_width);
		}
		
		// Begin capturing the byte stream
		ob_start();
		// generate the byte stream
		imagejpeg($im, NULL, 100);
		// and finally retrieve the byte stream
		$rawImageBytes = ob_get_clean();
		
		if ($return == 'img'){
			return "<img src='data:image/jpeg;base64," . base64_encode( $rawImageBytes ) . "' />";
		} else {
			return $rawImageBytes;
		}
	}
	
	private function imagettftextbox(&$image, $size, $angle, $left, $top, $color, $font, $text, $max_width)
	{
			$text_lines = explode("\n", $text); // Supports manual line breaks!
			
			$lines = array();
			$line_widths = array();
			
			$largest_line_height = 0;
			
			foreach($text_lines as $block)
			{
				$current_line = ''; // Reset current line
				
				$words = explode(' ', $block); // Split the text into an array of single words
				
				$first_word = TRUE;
				
				$last_width = 0;
				
				for($i = 0; $i < count($words); $i++)
				{
					$item = $words[$i];
					$dimensions = imagettfbbox($size, $angle, $font, $current_line . ($first_word ? '' : ' ') . $item);
					$line_width = $dimensions[2] - $dimensions[0];
					$line_height = $dimensions[1] - $dimensions[7];
					
					if($line_height > $largest_line_height) $largest_line_height = $line_height;
					
					if($line_width > $max_width && !$first_word)
					{
						$lines[] = $current_line;
						
						$line_widths[] = $last_width ? $last_width : $line_width;
						
						$current_line = $item;
					}
					else
					{
						$current_line .= ($first_word ? '' : ' ') . $item;
					}
					
					if($i == count($words) - 1)
					{
						$lines[] = $current_line;
						
						$line_widths[] = $line_width;
					}
					
					$last_width = $line_width;
						
					$first_word = FALSE;
				}
				
				if($current_line)
				{
					$current_line = $item;
				}
			}
			
			$i = 0;
			foreach($lines as $line)
			{
				if($align == 'center')
				{
					$left_offset = ($max_width - $line_widths[$i]) / 2;
				}
				elseif($align == 'right')
				{
					$left_offset = ($max_width - $line_widths[$i]);
				}
				imagettftext($image, $size, $angle, $left + $left_offset, $top + $largest_line_height + ($largest_line_height * $i), $color, $font, $line);
				$i++;
			}
			
			return $largest_line_height * count($lines);
	}
	
	public function getInfo() {
		parent::getInfo();
		
		$this->fabricante_formateado = $this->getfabricante(true);
		
		$precio_formateado = '';
		if ($this->getprecio_rebajado(true) > 0){
			$precio_formateado .= 'antes '.Helpers::Importe($this->getprecio(true, 'no_rebajado', true)) . ShopHelper::get_shop_moneda_simbolo() . ' ahora ';
		} 
		
		$precio_formateado .= Helpers::Importe($this->getprecio(true, 'actual', true)) . ShopHelper::get_shop_moneda_simbolo();
		
		$this->precio_formateado = $precio_formateado;
		
		$this->subtitulo_formateado = $this->precio_formateado;
	}
}
?>