<?php
defined('CONF_URL_APP') or die;
class ProductoAtributo extends EntidadModel
{
	protected $dbt_const = "DBT_SHOP_PRODUCTOS_ATRIBUTOS";
	protected $dbt = "shop_productos_atributos";
	
	protected $ext_folder = "ext_shop";
	
	protected $all_vars = array("id","titulo","alias","indexable","tipo","params","fecha");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("titulo","alias","indexable","tipo","params");
	
	protected $campos_multilang = array("titulo","alias");
	protected $campos_array = array("params");
	
	var $valores = array();
	
	public function __construct() {
		parent::__construct();
	}
	
	function includes() {
        e_include('ext_shop/class/productoAtributoTipo','ext_shop/class/productoAtributoValor');
    }
	
    public function getInfo(){
	}
	
	public function getValores(){
		if (is_array($this->valores) && sizeof($this->valores) > 0){
			return $this->valores;
		}
		if (!empty($this->id) && class_exists('ProductoAtributoValor')){
			$atributos_valores = new ProductoAtributoValor();
			
			$atributos_valores_c = $atributos_valores->ListarCount("atributo_id='".Helpers::mres($this->id)."'");
			
			if ($atributos_valores_c > 0){
				$atributos_valores = $atributos_valores->Listar("atributo_id='".Helpers::mres($this->id)."'", "orden", "ASC");
				$this->valores = $atributos_valores;
				return $this->valores;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	public function getTipoAtributo($valor){
		if (empty($this->tipo)){
			return false;
		}
		
		$tipo_atr = ProductoAtributoTipo::getTipoById($this->tipo, $valor);
		
		return $tipo_atr;
	}
	
	public function hasTextura(){
		if ($ta = $this->getTipoAtributo()){
			if (array_key_exists("textura", $ta->params) || array_key_exists("color", $ta->params)){
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function getalias($print=false){
		if ($print == false){
			return $this->alias;
		} else {
			return SistemaIdioma::Imprimir($this->alias);
		}
	}
	
	public function renderFrontend($valor, $txt_empty='', $input_name='atributo', $opciones=null){
		$tipo_obj = $this->getTipoAtributo();
		
		if (is_object($tipo_obj)){
			return $tipo_obj->printFormFrontend($this, $valor, $txt_empty, $input_name, $opciones);
		} else {
			return '';
		}
	}
	
	public function renderSelect($valor, $txt_empty='', $multiple=false, $input_name='atributo', $opciones=null){
		if (empty($txt_empty))
			$txt_empty = __('Cualquier combinación');
			
		if (is_null($opciones)){
		$valores_atr = $this->getValores();
		} else {
		$valores_atr = $opciones;	
		}
		$alias = $this->getalias(true);
		
		$txt_mult = $multiple == true ? '[]' : '';
		$atr_mult = $multiple == true ? ' multiple' : '';
		
		$html = '<label>'.SistemaIdioma::Imprimir($this->titulo).'</label>';
		$html .= '<select'.$atr_mult.' name="'.$input_name.'['.$this->id.']'.$txt_mult.'" class="select2">';
		if (!$multiple){
		$empty_selected = empty($valor) ? ' selected="selected"' : '';
		$html .= '<option'.$empty_selected.' value="">'.$txt_empty.'</option>';
		}
		if (is_array($valores_atr) && sizeof($valores_atr) > 0){
			foreach ($valores_atr as $va){
				if (!$multiple){
					$selected = $va->id == $valor ? ' selected="selected"' : '';
				} else {
					$selected = in_array($va->id, $valor) ? ' selected="selected"' : '';
				}
				$html .= '<option'.$selected.' value="'.$va->id.'">'.SistemaIdioma::Imprimir($va->valor).'</option>';
			}
		}
		
		$html .= '</select>';
			
		return $html;
	}
}
?>