<?php
class ProductoAtributoTipo {
	protected $nombre;
	protected $id;
	
	var $params = array();
	var $list_params = array();
	
	public function __construct($params){
		if (is_array($params) && sizeof($params) > 0){
			$this->setValoresParams($params);
		}
	}
	
	private function setValoresParams($params){
		if (is_array($params) && sizeof($params) > 0){
			foreach ($params as $kp=>$p){
				if (array_key_exists($kp, $this->params)){
					$this->params[$kp]['value'] = $p;
				}
			}
		}
	}
	
	private function getAtributosValores(){
		
	}
	
	public function printFormFrontend($obj, $valor, $txt_empty='', $input_name='atributos', $opciones=null){
		if (!is_object($obj))
			return false;
						
		if (is_null($opciones)){
			return false;
		} else {
			$valores_atr = $opciones;	
		}
		
		$html = '<label>'.SistemaIdioma::Imprimir($obj->titulo).'</label>';
		$html .= '<select name="'.$input_name.'['.$obj->id.']" class="select2">';
		if (!empty($txt_empty)){
			$empty_selected = empty($valor) ? ' selected="selected"' : '';
			$html .= '<option'.$empty_selected.' value="">'.$txt_empty.'</option>';
		}
		if (is_array($valores_atr) && sizeof($valores_atr) > 0){
			foreach ($valores_atr as $va){
				$selected = $va->id == $valor ? ' selected="selected"' : '';
				$html .= '<option'.$selected.' value="'.$va->id.'">'.SistemaIdioma::Imprimir($va->valor).'</option>';
			}
		}
		
		$html .= '</select>';
			
		return $html;
	}
	
	public function printListAdmin($columns = false){
		if ( ! $columns ) {
    		$columns = $this->list_params;
    	}
	}
	
	public function printFormAdmin($nombre_input, $id_input, $form_fields = false){
		if ( ! $form_fields ) {
    		$form_fields = $this->params;
    	}
		
		$html = '';
		
		if (is_array($form_fields) && sizeof($form_fields) > 0){
			foreach ( $form_fields as $k => $v ) {
				if ( ! isset( $v['type'] ) || ( $v['type'] == '' ) ) { $v['type'] == 'text'; } // Default to "text" field type.
				
				$v['name'] = $nombre_input . '[' . $k . ']';
				$v['id'] = $id_input.'_'.$k;
				
				$opt_v = $this->params[$k]['value'];
	
				if (is_null($opt_v) && $v["type"] == "checkbox" && isset($GLOBALS['opciones']['ext_shop_pasarelas_pago'][$this->id])){
					//$opt_v = null;
				}
				
				$html .= $this->renderCampo($v,$opt_v,'producto_atributo_tipo');
			}
		}
		
		return $html;
	}
	
	protected static function loadFieldClass($entity, $type)
	{
		$class = 'Form'.ucfirst($entity).ucfirst($type);
		if (class_exists($class)) return $class;
		// Get the field search path array.
		$paths = array();
		$paths[] = CONF_REALPATH_APP.'includes/class/forms/fields';
		// If the type is complex, add the base type to the paths.
		if ($pos = strpos($type, '_')) {
			// Add the complex type prefix to the paths.
			for ($i = 0, $n = count($paths); $i < $n; $i++) {
				// Derive the new path.
				$path = $paths[$i].'/'.strtolower(substr($type, 0, $pos));
				// If the path does not exist, add it.
				if (!in_array($path, $paths)) {
					array_unshift($paths, $path);
				}
			}
			// Break off the end of the complex type.
			$type = substr($type, $pos+1);
		}
		
		// Try to find the class file.
		$file = $paths[0].'/'.strtolower($type).'.php';
		if (is_file($file)) {
			require_once $file;
		}
		
		// Check for all if the class exists.
		return class_exists($class) ? $class : false;
	}
	function renderCampo($campo=null,$valor='',$grupo=''){
		if (empty($campo['type']))
			return false;
			
		if ($campo['type'] == 'titulo'){
			return '<h4>'.$campo['titulo'].'</h4>';
		}
		
		c_include('forms/formField');
		
		$ff = self::loadFieldClass('field', $campo['type']);
		
		if (class_exists($ff)){
			$ff_obj = new $ff;
			
			$nombre = $campo['name'];
			$id = Helpers::parseaTexto($campo['id'], true, '_');
			
			if (!empty($grupo)){
				$nombre = $grupo."[".$nombre."]";
			}
			
			$ff_obj->__set('id', $id);
			$ff_obj->__set('name', $nombre);
			$ff_obj->__set('fieldname', $nombre);
			$ff_obj->__set('label', $campo['label']);
			$ff_obj->__set('description', $campo['descripcion']);
			if ($valor != ''){
				$ff_obj->__set('value', $valor);
			}
			
			$exclude_fields = array("id","label","type","class_div");
			
			foreach ($campo as $kc=>$cc){
				if (!in_array($kc, $exclude_fields)){
					$ff_obj->__set($kc, $cc);
				}
			}
			
			if ($campo['type'] == 'hidden'){
				$ff_obj->__set('hidden', true);
			}
			
			$element = $campo['attributes'];
			
			$element["name"] = $nombre;
			$element["type"] = $campo['type'];
			$element["label"] = $campo['label'];
			$element["description"] = $campo['descripcion'];
			$element["value"] = $valor;
			
			foreach ($campo as $kc=>$cc){
				if (!in_array($kc, $exclude_fields)){
					$element[$kc] = $cc;
				}
			}
			
			if ($campo["type"] == 'checkbox'){
				$ff_obj->__set('value', $campo['default']);
			}
	
			$element_xml = new SimpleXMLElement('<root></root>');
			
			foreach (array_keys($element) as $key){
				$cxml = $element_xml->addAttribute($key, $element[$key]);
			}
			
			$ff_obj->element = $element_xml;
			
			$input = $ff_obj->getInput($valor);
			
			if (empty($formato_label)){
				$formato_label = '<label for="##ID##">##LABEL##</label>
				';
			}
			if (empty($formato_input)){
				$formato_input = '##INPUT##
				';
			}
			
			$class_div = '';
			if (!empty($campo['class_div']))
				$class_div = ' ' . $campo['class_div'];
							
			switch ($campo['type']){ 
				case 'hidden':
					$formato_label = '';
					$formato_input = "##INPUT##";
					break;
				case 'submit':
					$formato_label = '';
					break;
				case 'checkbox':
					$formato_label = '##INPUT##';
					$formato_input = ' ';
					break;
				case 'button':
					$formato_label = '';
					break;
			}
			$formato = '<div class="form-group'.$class_div.'">'.$formato_label.$formato_input.'</div>';
			$out = str_replace("##ID##", $id, $formato);
			$out = str_replace("##LABEL##", $campo['label'], $out);
			$out = str_replace("##INPUT##", $input, $out);
			
			return $out;
		}
	}
	
	public function getTipos(){
		$dir = dirname(__FILE__) . '/tipos_atributos';
		$handlers = Helpers::dir_list($dir,'','.php',false);
		$handlers = $handlers[dirname(__FILE__) . '/tipos_atributos'];
		
		$names = array();
		foreach ($handlers as $handler)
		{
			$name = substr($handler, 0, strrpos($handler, '.'));
			$class = 'ProductoAtributoTipo' . $name;
			if (!class_exists($class))
			{
				include_once dirname(__FILE__) . '/tipos_atributos/' . $name . '.php';
			}
			if (call_user_func_array(array(trim($class), 'test'), array()))
			{
				$cls_tipo = new $class();
				$info_tipo = $cls_tipo->getInfo();
				
				if (!empty($info_tipo['value']) && !empty($info_tipo['label'])){
					$names[$info_tipo['value']] = $info_tipo['label'];
				}
			}
		}
		return $names;
	}
	
	public static function getTipoById($id_tipo, $valores){
		if (empty($id_tipo))
			return false;
			
		$name = $id_tipo;
		$class = 'ProductoAtributoTipo' . $name;
		
		if (!class_exists($class))
		{
			include_once dirname(__FILE__) . '/tipos_atributos/' . $name . '.php';
		}
		
		if (call_user_func_array(array(trim($class), 'test'), array()))
		{
			$cls_tipo = new $class($valores);
			return $cls_tipo;
		}
		
		return false;
	}
	
	/**
	 * Test to see if the ProductoAtributoTipo is available.
	 *
	 * @return  boolean  True on success, false otherwise.
	 *
	 * @since   12.1
	 */
	public static function isSupported()
	{
		return true;
	}
	/**
	 * Test to see if the ProductoAtributoTipo is available.
	 *
	 * @return  boolean  True on success, false otherwise.
	 *
	 * @since   11.1
	 * @deprecated  12.3 (Platform) & 4.0 (CMS) - Use SesionStorage::isSupported() instead.
	 */
	public static function test()
	{
		return static::isSupported();
	}
	
	public function getInfo(){
		return array('label'=>$this->get('nombre'), 'value'=>$this->get('id'));
	}
	
	/**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function get($property, $default = null) {
        if (isset($this->$property)) {
            return $this->$property;
        }
        return $default;
    }
    /**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function set($property, $default = null) {
        $this->$property = $default;
        return $default;
    }
}