<?php
defined('CONF_URL_APP') or die;
e_include('ext_shop/class/producto');
		
class ProductoVariacion extends Producto
{
	protected $dbt_const = "DBT_PRODUCTOS_VARIACIONES";
	protected $dbt = "shop_productos_variaciones";
	
	protected $ext_item_class = "ProductoVariacion";
	
	protected $all_vars = array("id","producto_id","atributos","nombre","sku","alias","contenido","texto_corto","fecha","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","location","acceso","id_original","precio","precio_rebajado","desde_precio_rebajado","hasta_precio_rebajado","destacado","solocatalogo","stock","impuesto","peso");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("producto_id","atributos","nombre","sku","alias","contenido","texto_corto","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","location","acceso","id_original","precio","precio_rebajado","desde_precio_rebajado","hasta_precio_rebajado","destacado","solocatalogo","stock","impuesto","peso");
	
    var $producto_id;
    var $atributos;
	
	var $objeto_padre;
	
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_shop/class/helper', 'ext_shop/class/impuestoShop', 'ext_shop/class/impuestoTarifa', 'ext_shop/class/categoriaProducto', 'ext_shop/class/productoVariacion', 'ext_shop/class/productoAtributo', 'ext_shop/class/productoAtributoValor');
	}
	
    //producto_id
    function setproducto_id($v)
    {
        $this->producto_id = $v;
    }
    function getproducto_id()
    {
        return $this->producto_id;
    }
    //atributos
    function setatributos($v)
    {
        $this->atributos = $v;
    }
    function getatributos($print=false,$array=false,$separador='<br>')
    {
		if ($print == true){
			if (empty($this->atributos))
				return '';
				
			$tmp_arr = Helpers::toArray(json_decode($this->atributos));
			
			if (!is_array($tmp_arr) || empty($tmp_arr))
				return '';
				
			if ($array == true){
				return $tmp_arr;
			}
				
			$tmp_arr2 = array();
			
			$c_arr = 1;
			foreach ($tmp_arr as $k=>$v){
				$pa = new ProductoAtributo();
				$pa->setid($k);
				
				if ($pa = $pa->BuscarId()){
					if (!empty($v)){
						$pav = new ProductoAtributoValor();
						$pav->setid($v);
						
						if ($pav = $pav->BuscarId()){
							$vt = SistemaIdioma::Imprimir($pav->valor);
						}
					} else {
						$vt = __('Cualquiera');
					}
					
					$tmp_arr2[] = ''.SistemaIdioma::Imprimir($pa->titulo).': <b>'.$vt.'</b>';
				}
			}
			return implode($separador, $tmp_arr2);
		} else {
        	return $this->atributos;
		}
    }
	
	function getobjeto_padre(){
		if (empty($this->producto_id))
			return false;
			
		e_include('ext_shop/class/producto');
		$padre = new Producto();
		$padre->setid($this->producto_id);
		
		if ($padre = $padre->BuscarId()){
		} else {
			return false;
		}
		
		if (empty($padre->id))
			return false;
			
		$this->objeto_padre = $padre;
		
		return true;
	}
	
	public function getInfo() {
		parent::getInfo();
		
		$this->getobjeto_padre();
	}
	
	function getprecio_html($print=true){
		/*$precio_rebajado = $this->get_precio_real('rebajado');
		$precio_rebajado = $precio_rebajado['precio_total'];
		
		$precio_no_rebajado = $this->get_precio_real('no_rebajado');
		$precio_no_rebajado = $precio_no_rebajado['precio_total'];*/
		
		if (empty($this->impuesto))
			$this->impuesto = $this->objeto_padre->impuesto;
		
		if ($this->getprecio_rebajado(true) > 0){
			$precio_rebajado = $this->getprecio(true,'actual',true);
			$precio_no_rebajado = $this->getprecio(true,'no_rebajado',true);
		} else {
			$precio_rebajado = 0;
			$precio_no_rebajado = $this->getprecio(true,'actual',true);
		}
		
		$output = '<span class="precio-ajax">';
		
        if ($precio_rebajado > 0){
        $output .= '<small class="oldprice rojo"><small class="hide">'.__('Antes').'</small>'.Helpers::Importe($precio_no_rebajado).' '.ShopHelper::get_shop_moneda_simbolo().'</small>';
         }
        $output .= '<span>';
		
        if ($precio_no_rebajado > 0 || $precio_rebajado > 0){
		$output .= '&nbsp;<span class="price-value"><span class="oo_precio-ajax">';
        if ($precio_rebajado > 0){
       $output .= '<small class="hide">'.__('Precio Rebajado').'</small>'; 
	   $output .= Helpers::Importe($precio_rebajado).' '.ShopHelper::get_shop_moneda_simbolo().'</span></span>';
	   }  else {
		   $output .= Helpers::Importe($precio_no_rebajado).' '.ShopHelper::get_shop_moneda_simbolo().'</span></span>';
	   }
		
        } else { 
			
				$output .= __('Gratis!'); 
		
		}
        $output .= '</span> </span>';
		
		return $output;
	}
}
?>