<?php
defined('CONF_URL_APP') or die;

e_include('ext_shop/class/transportista');

class AntariaTransportistaShop extends TransportistaShop
{
	protected $id = "antaria";
	protected $nombre = "Antaria";
	protected $activo = 1;
	
	protected $url_api = "http://185.11.117.133:8081/dtxSW/services/Envios";
	
	protected $email = "najera@nabra.es";
	protected $password = "Antaria1";
	
	function place_shipping_order($pedido = ''){
		c_include('app');
		
		if (!$pedido instanceof PedidoShop || empty($pedido->id))
			return false;
			
		$xml = $this->getXML($pedido);
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_HEADER, FALSE);
		curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
		curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
		curl_setopt($ch, CURLOPT_URL, $this->url_api );
		curl_setopt($ch, CURLOPT_POSTFIELDS, utf8_encode($xml) );
		curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: text/xml"));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
		
		$postResult = curl_exec($ch);
		$dom = new DOMDocument;
		// load the XML string defined above
		$dom->loadXML($postResult);
		$note = $dom->getElementsByTagName("resultado");
		
		foreach($note as $usuario) {
			if ($usuario->getElementsByTagName("msgError")->item(0)->nodeValue == "" || $usuario->getElementsByTagName("msgError")->item(0)->nodeValue == 200)
			{
				$pedido->add_nota_pedido( sprintf(__( 'Enviando solicitud de recogida a transportista %s con código de albarán %s' ), $this->getNombre(), $usuario->getElementsByTagName("albaran")->item(0)->nodeValue) );
				
				//return $usuario->getElementsByTagName("albaran")->item(0)->nodeValue;
			} else {
				$pedido->add_nota_pedido("Error al grabar el envío! Cod error: " . $usuario->getElementsByTagName("codError")->item(0)->nodeValue . " Mensaje de error: " . $usuario->getElementsByTagName("msgError")->item(0)->nodeValue);
				
				//return false;
			}
		}
	}
	
	private function getXML($pedido = ''){
		if (!$pedido instanceof PedidoShop || empty($pedido->id))
			return false;
			
		$empresa_shop = $GLOBALS['opciones']['ext_shop']['empresa'];
		
		if ($pedido->envio_a_facturacion == '1'){
			$destinatario = $pedido->datos['facturacion'];
		} else {
			$destinatario = $pedido->datos['envio'];
		}
		
		if (strlen($empresa_shop['provincia']) == 1){
			$empresa_shop['provincia'] = '00' . $empresa_shop['provincia'];
		} elseif (strlen($empresa_shop['provincia']) == 2){
			$empresa_shop['provincia'] = '0' . $empresa_shop['provincia'];
		}
		
		if (strlen($destinatario['provincia']) == 1){
			$destinatario['provincia'] = '00' . $destinatario['provincia'];
		} elseif (strlen($destinatario['provincia']) == 2){
			$destinatario['provincia'] = '0' . $destinatario['provincia'];
		}
			
		$XML=
		'<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:mes="http://messagein.dtx.sw" xmlns:com="http://complexType.dtx.sw">
		   <soapenv:Header/>
		   <soapenv:Body>
			  <mes:InsertarEnviosTypeIn>
				 <mes:autenticacion>
					<com:identificador>91369</com:identificador>
					<com:empresa>91369</com:empresa>
					<com:email>'. $this->email .'</com:email>
					<com:clave>'. md5($this->password) .'</com:clave>
				 </mes:autenticacion>
				 <!--Zero or more repetitions:-->
				 <mes:envios>
					<!--Optional:-->
					<com:albaran></com:albaran>
					<!--Optional:-->
					<com:departamento></com:departamento>
					<!--Optional:-->
					<com:referencia>'.$pedido->id.'</com:referencia>
					<com:nombreRem>'.utf8_decode($empresa_shop['nombre_comercial']).'</com:nombreRem>
					<com:telefonoRem>'.utf8_decode($empresa_shop['telefono_1']).'</com:telefonoRem>
					<com:codPostalRem>'.utf8_decode($empresa_shop['codigo_postal']).'</com:codPostalRem>
					<com:poblacionRem>'.utf8_decode($empresa_shop['localidad']).'</com:poblacionRem>
					<com:provinciaRem>'.$empresa_shop['provincia'].'</com:provinciaRem>
					<!--Optional:-->
					<com:kmsRem></com:kmsRem>
					<com:direccionRem>'.$empresa_shop['direccion'].'</com:direccionRem>
					<!--Optional:-->
					<com:viaRem></com:viaRem>
					<!--Optional:-->
					<com:numeroRem></com:numeroRem>
					<!--Optional:-->
					<com:pisoRem></com:pisoRem>
					<com:paisDes>'.$destinatario['pais_iso3'].'</com:paisDes>
					<com:nombreDes>'.utf8_decode($destinatario['nombre']).' '.utf8_decode($destinatario['apellidos']).'</com:nombreDes>
					<com:telefonoDes>'.utf8_decode($destinatario['telefono']).'</com:telefonoDes>
					<com:codPostalDes>'.utf8_decode($destinatario['codigo_postal']).'</com:codPostalDes>
					<com:poblacionDes>'.utf8_decode($destinatario['nombre_localidad']).'</com:poblacionDes>
					<com:provinciaDes>'.$destinatario['provincia'].'</com:provinciaDes>
					<!--Optional:-->
					<com:kmsDes></com:kmsDes>
					<com:direccionDes>'.utf8_decode($destinatario['direccion']).'</com:direccionDes>
					<!--Optional:-->
					<com:viaDes></com:viaDes>
					<!--Optional:-->
					<com:numeroDes></com:numeroDes>
					<!--Optional:-->
					<com:pisoDes></com:pisoDes>
					<!--Optional:-->
					<com:emailDes>'.$pedido->email.'</com:emailDes>
					<!--Optional:-->
					<com:movilDes></com:movilDes>
					<!--Optional:-->
					<com:observaciones>'.utf8_decode($pedido->comentarios).'</com:observaciones>
					<com:tipoServ>0019</com:tipoServ>
					<com:largo>1</com:largo>
					<com:alto>1</com:alto>
					<com:ancho>1</com:ancho>
					<com:pesoReal>'.$pedido->datos['metodo_envio']['peso'].'</com:pesoReal>
					<!--Optional:-->
					<com:sabado></com:sabado>
					<!--Optional:-->
					<com:retorno></com:retorno>
					<!--Optional:-->
					<com:conAcuse></com:conAcuse>
					<com:docs>0</com:docs>
					<com:paqs>1</com:paqs>
					<!--Optional:-->
					<com:horaEntrega></com:horaEntrega>
					<!--Optional:-->
					<com:valor></com:valor>
					<!--Optional:-->
					<com:reembolso></com:reembolso>
					<!--Optional:-->
					<com:comReembPag></com:comReembPag>
					<com:portesPagados></com:portesPagados>
					<!--Optional:-->
					<com:gestionDestino></com:gestionDestino>
					<!--Optional:-->
					<com:gestionOrigen></com:gestionOrigen>
					<!--Optional:-->
					<com:canalizarPorPoblacion>true</com:canalizarPorPoblacion>
				 </mes:envios>
			  </mes:InsertarEnviosTypeIn>
		   </soapenv:Body>
		</soapenv:Envelope>';
		
		return $XML;
	}
}