-- --------------------------------------------------------
-- Host:                         91.121.169.218
-- Versión del servidor:         5.5.33-cll-lve - MySQL Community Server (GPL) by Atomicorp
-- SO del servidor:              Linux
-- HeidiSQL Versión:             9.3.0.4984
-- --------------------------------------------------------
/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
-- Volcando estructura para tabla db.#__shop_clientes
DROP TABLE IF EXISTS `#__shop_clientes`;
CREATE TABLE IF NOT EXISTS `#__shop_clientes` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `id_usuario` int(11) NOT NULL DEFAULT '0',
  `email` text NOT NULL,
  `datos_facturacion` text NOT NULL,
  `datos_envio` text NOT NULL,
  `direccion_envio_igual_facturacion` int(1) NOT NULL DEFAULT '1',
  `envio_calculado` int(1) NOT NULL DEFAULT '0',
  `estado` int(1) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_envios
DROP TABLE IF EXISTS `#__shop_envios`;
CREATE TABLE IF NOT EXISTS `#__shop_envios` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `estado_impuestos` varchar(250) NOT NULL DEFAULT '',
  `disponibilidad` int(1) NOT NULL DEFAULT '1',
  `paises` text NOT NULL,
  `zona` int(1) NOT NULL DEFAULT '0',
  `codigo_postal` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `tipo` varchar(250) NOT NULL DEFAULT '',
  `cuota` decimal(10,2) NOT NULL,
  `cuota_minima` decimal(10,2) NOT NULL,
  `cantidad_minima` decimal(10,2) NOT NULL,
  `tasa_manipulacion` decimal(10,2) NOT NULL,
  `activo` int(1) NOT NULL DEFAULT '1',
  `coste` decimal(10,2) NOT NULL,
  `opciones` text NOT NULL,
  `tarifas_planas` text NOT NULL,
  `metodo_envio` varchar(250) NOT NULL DEFAULT '',
  `transportista` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_fabricantes
DROP TABLE IF EXISTS `#__shop_fabricantes`;
CREATE TABLE IF NOT EXISTS `#__shop_fabricantes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `alias` text NOT NULL,
  `contenido` text NOT NULL,
  `texto_corto` text NOT NULL,
  `estado` int(1) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_publicacion` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `imagen_destacada` text NOT NULL,
  `categorias` text NOT NULL,
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `tags` text NOT NULL,
  `idioma` varchar(2) NOT NULL,
  `lugar` text NOT NULL,
  `direccion` text NOT NULL,
  `codigo_postal` text NOT NULL,
  `localidad` text NOT NULL,
  `provincia` text NOT NULL,
  `pais` text NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  `id_original` int(11) NOT NULL DEFAULT '0',
  `location` point NOT NULL,
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_facturas
DROP TABLE IF EXISTS `#__shop_facturas`;
CREATE TABLE IF NOT EXISTS `#__shop_facturas` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `codigo` int(11) NOT NULL DEFAULT '0',
  `titulo` text NOT NULL,
  `usuario_id` int(11) NOT NULL,
  `datos_facturacion` text NOT NULL,
  `creador_id` int(11) NOT NULL,
  `pedido_id` int(11) NOT NULL DEFAULT '0',
  `ejercicio` int(4) NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `vencimiento` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `estado` varchar(250) NOT NULL DEFAULT 'pendiente',
  `comentarios` text NOT NULL,
  `base_imponible` decimal(10,2) NOT NULL,
  `total_descuento` decimal(10,4) NOT NULL,
  `percent_descuento` decimal(10,2) NOT NULL,
  `total_impuesto` decimal(10,2) NOT NULL,
  `total_recargo` decimal(10,4) NOT NULL,
  `percent_recargo` decimal(10,2) NOT NULL,
  `total_retencion` decimal(10,4) NOT NULL,
  `percent_retencion` decimal(10,2) NOT NULL,
  `total` decimal(10,2) NOT NULL,
  `forma_pago` text NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`ejercicio`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_facturas_lineas
DROP TABLE IF EXISTS `#__shop_facturas_lineas`;
CREATE TABLE IF NOT EXISTS `#__shop_facturas_lineas` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `factura_id` int(11) NOT NULL,
  `ejercicio` int(4) NOT NULL DEFAULT '0',
  `producto_id` int(11) NOT NULL,
  `nombre_producto` text NOT NULL,
  `cantidad` int(11) NOT NULL,
  `data` text NOT NULL,
  `linea_total` decimal(10,2) NOT NULL,
  `linea_impuesto` decimal(10,2) NOT NULL,
  `linea_impuesto_nombre` text NOT NULL,
  `linea_subtotal` decimal(10,2) NOT NULL,
  `linea_subtotal_impuesto` decimal(10,2) NOT NULL,
  `orden` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_impuestos
DROP TABLE IF EXISTS `#__shop_impuestos`;
CREATE TABLE IF NOT EXISTS `#__shop_impuestos` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL,
  `pais` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `codigo_postal` text NOT NULL,
  `tarifa` decimal(10,2) NOT NULL DEFAULT '0.00',
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `envio` text NOT NULL,
  `tipo` varchar(250) NOT NULL DEFAULT '',
  `activo` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_pedidos
DROP TABLE IF EXISTS `#__shop_pedidos`;
CREATE TABLE IF NOT EXISTS `#__shop_pedidos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `usuario_id` int(11) NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `titulo` text NOT NULL,
  `estado` varchar(250) NOT NULL DEFAULT 'pendiente',
  `comentarios` text NOT NULL,
  `email` text NOT NULL,
  `envio_a_facturacion` int(1) NOT NULL DEFAULT '1',
  `datos_facturacion` text NOT NULL,
  `datos_envio` text NOT NULL,
  `metodo_pago` text NOT NULL,
  `metodo_envio` text NOT NULL,
  `total` text NOT NULL,
  `params` text NOT NULL,
  `reglas_aplicadas` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_pedidos_lineas
DROP TABLE IF EXISTS `#__shop_pedidos_lineas`;
CREATE TABLE IF NOT EXISTS `#__shop_pedidos_lineas` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pedido_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `variation_id` int(11) NOT NULL,
  `variation` text NOT NULL,
  `cantidad` int(11) NOT NULL,
  `data` text NOT NULL,
  `linea_total` decimal(10,2) NOT NULL,
  `linea_impuesto` decimal(10,2) NOT NULL,
  `linea_subtotal` decimal(10,2) NOT NULL,
  `linea_subtotal_impuesto` decimal(10,2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_productos
DROP TABLE IF EXISTS `#__shop_productos`;
CREATE TABLE IF NOT EXISTS `#__shop_productos` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `sku` text NOT NULL,
  `alias` text NOT NULL,
  `texto_corto` text NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_publicacion` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `estado` int(1) NOT NULL DEFAULT '1',
  `imagen_destacada` text NOT NULL,
  `categorias` text NOT NULL,
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `precio` decimal(10,2) NOT NULL,
  `precio_rebajado` decimal(10,2) NOT NULL,
  `desde_precio_rebajado` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hasta_precio_rebajado` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `destacado` int(1) NOT NULL DEFAULT '0',
  `solocatalogo` int(1) NOT NULL DEFAULT '0',
  `stock` int(11) NOT NULL,
  `cuenta_descargas` int(11) NOT NULL,
  `impuesto` varchar(250) NOT NULL DEFAULT '',
  `peso` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `tags` text NOT NULL,
  `idioma` varchar(2) NOT NULL,
  `lugar` text NOT NULL,
  `direccion` text NOT NULL,
  `codigo_postal` text NOT NULL,
  `localidad` text NOT NULL,
  `provincia` text NOT NULL,
  `pais` text NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  `id_original` int(11) NOT NULL DEFAULT '0',
  `location` point NOT NULL,
  `atributos` text NOT NULL,
  `fabricante` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_productos_atributos
DROP TABLE IF EXISTS `#__shop_productos_atributos`;
CREATE TABLE IF NOT EXISTS `#__shop_productos_atributos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `alias` text NOT NULL,
  `indexable` int(1) NOT NULL DEFAULT '0',
  `tipo` varchar(250) NOT NULL,
  `params` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_productos_atributos_valores
DROP TABLE IF EXISTS `#__shop_productos_atributos_valores`;
CREATE TABLE IF NOT EXISTS `#__shop_productos_atributos_valores` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `atributo_id` int(11) NOT NULL DEFAULT '0',
  `valor` text NOT NULL,
  `params` text NOT NULL,
  `orden` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_productos_categorias
DROP TABLE IF EXISTS `#__shop_productos_categorias`;
CREATE TABLE IF NOT EXISTS `#__shop_productos_categorias` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `padre` varchar(250) NOT NULL DEFAULT '',
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `imagen_destacada` text NOT NULL,
  `icono` text NOT NULL,
  `params` text,
  `idioma` varchar(5) NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__shop_productos_categorias` (`id`, `nombre`, `alias`, `contenido`, `fecha`, `estado`, `padre`, `creador`, `creador_alias`, `imagen_destacada`, `icono`, `params`, `idioma`, `acceso`) VALUES (1, '{"es":"Tienda"}', '{"es":"Tienda"}', '{"es":""}', '2015-10-16 02:32:21', 1, '[""]', 0, '', '', '', '{"estilo":"","hijos_heredan_estilo":"","params":{"num_productos":"0","orden":"fecha_publicacion","orden_dir":"DESC"},"bloques":{"mostrar_categorias":"1","mostrar_masvendidos":"1"}}', '', 0);
-- Volcando estructura para tabla db.#__shop_productos_variaciones
DROP TABLE IF EXISTS `#__shop_productos_variaciones`;
CREATE TABLE IF NOT EXISTS `#__shop_productos_variaciones` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `producto_id` int(11) NOT NULL,
  `atributos` text NOT NULL,
  `nombre` text NOT NULL,
  `sku` text NOT NULL,
  `alias` text NOT NULL,
  `texto_corto` text NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_publicacion` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `estado` int(1) NOT NULL DEFAULT '1',
  `imagen_destacada` text NOT NULL,
  `categorias` text NOT NULL,
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `precio` decimal(10,2) NOT NULL,
  `precio_rebajado` decimal(10,2) NOT NULL,
  `desde_precio_rebajado` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hasta_precio_rebajado` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `destacado` int(1) NOT NULL DEFAULT '0',
  `solocatalogo` int(1) NOT NULL DEFAULT '0',
  `stock` int(11) NOT NULL,
  `impuesto` varchar(250) NOT NULL DEFAULT '',
  `peso` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `tags` text NOT NULL,
  `idioma` varchar(2) NOT NULL,
  `lugar` text NOT NULL,
  `direccion` text NOT NULL,
  `codigo_postal` text NOT NULL,
  `localidad` text NOT NULL,
  `provincia` text NOT NULL,
  `pais` text NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  `id_original` int(11) NOT NULL DEFAULT '0',
  `location` point NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- La exportación de datos fue deseleccionada.
-- Volcando estructura para tabla db.#__shop_reglas_precios
DROP TABLE IF EXISTS `#__shop_reglas_precios`;
CREATE TABLE IF NOT EXISTS `#__shop_reglas_precios` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `contenido` text NOT NULL,
  `condiciones` text NOT NULL,
  `accion_regla` text NOT NULL,
  `fecha_inicio` text NOT NULL,
  `fecha_fin` text NOT NULL,
  `estado` int(1) NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `params` text NOT NULL,
  `usado` int(11) NOT NULL DEFAULT '0',
  `limite_usos` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- Volcando estructura para tabla db.#__shop_pedidos_estados
DROP TABLE IF EXISTS `#__shop_pedidos_estados`;
CREATE TABLE IF NOT EXISTS `#__shop_pedidos_estados` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `clase_css` varchar(255) NOT NULL,
  `icono` varchar(255) NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
-- Volcando datos para la tabla db.#__shop_pedidos_estados: 5 rows
/*!40000 ALTER TABLE `#__shop_pedidos_estados` DISABLE KEYS */;
INSERT INTO `#__shop_pedidos_estados` (`id`, `nombre`, `clase_css`, `icono`, `params`) VALUES
	(1, '{"es":"Procesando","en":"Processing"}', 'label-warning', '', '{"email_notificacion":"extensions\\/ext_shop\\/email\\/tabla.php"}'),
	(2, '{"es":"Completado","en":"Completed"}', 'label-success', '', '{"email_notificacion":"extensions\\/ext_shop\\/email\\/tabla.php"}'),
	(3, '{"es":"Pendiente","en":"Pending"}', 'label-default', '', '{"email_notificacion":"extensions\\/ext_shop\\/email\\/tabla.php"}'),
	(4, '{"es":"Cancelado","en":"Canceled"}', 'label-danger', '', '{"email_notificacion":""}'),
	(5, '{"es":"Enviado","en":"Shipped"}', 'label-info', '', '{"email_notificacion":"extensions\\/ext_shop\\/email\\/tabla.php"}');
/*!40000 ALTER TABLE `#__shop_pedidos_estados` ENABLE KEYS */;
-- La exportación de datos fue deseleccionada.

-- Volcando estructura para tabla db.#__shop_zonas_envios
DROP TABLE IF EXISTS `#__shop_zonas_envios`;
CREATE TABLE IF NOT EXISTS `#__shop_zonas_envios` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `paises` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- La exportación de datos fue deseleccionada.

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IF(@OLD_FOREIGN_KEY_CHECKS IS NULL, 1, @OLD_FOREIGN_KEY_CHECKS) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
