<?php
class FacturaShopListadoAdminModel extends ListadoAdminModel {
	var $columnas = array("estado_factura", "total_factura", "factura_html", "opciones_factura");
	
	public static function getValorCampo($id_columna, $obj) {
		
		$txt_cm = '';
		if (isset($GLOBALS['custom_menu'])){
			$txt_cm = '&custom_menu='.$GLOBALS['custom_menu']->id;
		}
        $valor_campo = '';
        switch ($id_columna) {
			case 'estado_factura':
				if ($obj->estado == 'pagada'){
					$extra_cls = ' label-success';
				} else {
					$extra_cls = ' label-primary';
				}
				$valor_campo = '<div class="dropdown" data-togglelist data-var="estado" data-val="'.$obj->estado.'" data-url="'.CONF_URL_APP.'api/shop/factura/updateVarFactura.json" data-token="'.Helpers::getFormToken().'" data-id="'.$obj->id.'">';
				$valor_campo .= '<a href="#" data-toggle="dropdown" class="label'.$extra_cls.'">'.$obj->estado.' <span class="caret"></span></a>';
				$valor_campo .= '<ul class="dropdown-menu"><li><a data-val="pendiente" data-class="label-primary" href="javascript:;">'.__('pendiente').'</a></li><li><a data-val="pagada" data-class="label-success" href="javascript:;">'.__('pagada').'</a></li></ul>';
				$valor_campo .= '</div>';
				break;
				
			case 'total_factura':
				$valor_campo = number_format($obj->total, 2, ',', '.').' &euro;';
				break;
				
			case 'factura_html':
				$datos_facturacion = Helpers::toArray(json_decode($obj->datos_facturacion));
				$txt_cliente = $datos_facturacion['nombre'].' '.$datos_facturacion['apellidos'];
				$params_factura = Helpers::toArray(json_decode($obj->params));
				$extra_title = '';
				if ($params_factura['periodica'] == '1'){
					$extra_title = ' <span class="label label-info" data-toggle="tooltip" title="'.sprintf(__('Factura periódica %s'), $params_factura['tipo_periodicidad']).'"><i class="fa fa-clock-o"></i></span>';
				}
												
				if (!empty($obj->pedido_id)){
					$pedido = $obj->getpedido();
				} else {
					$pedido = false;
				}
				
				$valor_campo = '<strong><a href="?extension=ext_shop&vista=editar_factura&id='.$obj->id.$txt_cm.'">'.sprintf(__("Factura #%s"), $obj->codigo."/".$obj->ejercicio).'</a></strong>'.$extra_title.'<br />
              	<small>'. __('Cliente:').' '.$txt_cliente.'</small>';
              	if ($pedido instanceof PedidoShop && !empty($pedido->id)){
				  $valor_campo .= '<br>
				  <small><b>'.__('Pedido').' <a href="?extension=ext_shop&vista=editar_pedido&id='.$pedido->id.$txt_cm.'">'.sprintf(__('#%s'), $pedido->id).'</a></b></small>';
				}
				break;
				
			case 'opciones_factura':
				$valor_campo = '<a href="?extension=ext_shop&vista=editar_factura&id='.$obj->id.'&download=html'.$txt_cm.'" target="_blank" class="btn btn-xs btn-primary" title="'.__('Ver factura en HTML').'"><i class="fa fa-search-plus"> </i></a> <a href="?extension=ext_shop&vista=editar_factura&id='.$obj->id.'&download=pdf'.$txt_cm.'" target="_blank" class="btn btn-xs btn-primary" download="Factura_'.$obj->codigo.'_'.$obj->ejercicio.'.pdf" title="'.__('Descargar factura en Pdf').'"><i class="fa fa-download"> </i></a> <a href="?extension=ext_shop&vista=editar_factura&id='.$obj->id.'&download=email'.$txt_cm.'" target="_blank" class="btn btn-xs btn-primary iframe-config"  title="'.__('Su Factura se ha enviado correctamente').'"><i class="fa fa fa-envelope"> </i></a> <a href="?extension=ext_shop&vista=editar_factura&id='.$obj->id.'&download=html'.$txt_cm.'" target="_blank" class="btn btn-xs btn-primary" title="'.__('Imprimir Factura').'"><i class="fa fa fa-print"> </i></a>';
				break;
		}
		
		if (Helpers::is_json($valor_campo)) {
            $tmp_val = (array) json_decode($valor_campo);
            if (isset($tmp_val[SistemaIdioma::getIdiomaSesion(true)]))
                $valor_campo = $tmp_val[SistemaIdioma::getIdiomaSesion(true)];
        }
        return $valor_campo;
	}
}