<?php
/**
 * Modelo del listado de artículos en el administrador
 *
 * @package		Mideas.Pagos
 * @subpackage	Model
 * @since		1.0
 */
class MetodoPagoListadoAdminModel extends ListadoAdminModel{
	var $columnas = array("icono_pasarela", "soporta_pasarela", "activo_pasarela");
	
	function get_items($categoria, $class_item) {
        //Establecemos la sentencia SQL para la búsqueda por palabra clave
        if (!empty($this->filtro_keyword)) {
            $this->parametros['params']['keyword_where'] = str_replace("##KEYWORD##", Helpers::mres($this->filtro_keyword), $this->keyword_where_exp);
        }
        if (empty($class_item))
            return false;
        //Si no hay parámetros, no seguimos
        if (empty($this->parametros['params']))
            return false;
        //Almacenamos los parámetros de la vista en una variable local	
        $params = $this->parametros['params'];
        //Parámetros de filtros personalizados
        if (isset($_GET['filtro_estado']) && trim($_GET['filtro_estado']) != '' && $_GET['filtro_estado'] != '*') {
            if (empty($params['keyword_where'])) {
                $params['keyword_where'] = 'estado=' . $_GET['filtro_estado'];
            } else {
                $params['keyword_where'] .= ' AND estado=' . $_GET['filtro_estado'];
            }
        }
        //Recuperamos el número de artículos, aplicando los filtros y orden correspondientes
        if (is_object($class_item)) {
            $this->items = $class_item;
        } else {
            $this->items = new $class_item();
        }
        if (!is_object($this->items))
            return false;
		
        $this->total_items = count($this->items->pasarelas_pago);
        $total_registros = $this->total_items;
        //Tamaño de resultados por página
        $tam_page = (int) $params['max'];
        //Calculamos el número de página en el que estamos
        if (!empty($this->pagina)) {
            $pagina = $this->pagina;
        } else {
            $pagina = 1;
            $inicio = 1;
            $final = $tam_page;
        }
        //Guardamos la página actual
        $this->pagina = $pagina;
        //calculo del limite inferior
        $this->limite_inferior = ($pagina - 1) * $tam_page;
        //calculo del numero de paginas 
        $num_pags = ceil($total_registros / $tam_page);
        $this->total_paginas = $num_pags;
        //Recuperamos y almacenamos el listado de profesionales, aplicando los filtros y orden correspondientes
        $this->items = array_slice($this->items->pasarelas_pago, $this->limite_inferior, $tam_page);
        $this->paginacion = $this->get_paginas();
    }
	
	public static function getValorCampo($id_columna, $obj) {
		$txt_cm = '';
		if (isset($GLOBALS['custom_menu'])){
			$txt_cm = '&custom_menu='.$GLOBALS['custom_menu']->id;
		}
        $valor_campo = '';
        switch ($id_columna) {
			case 'icono_pasarela':
				$valor_campo = '<img src="'.$obj->icono.'" height="24">';
				break;
				
			case 'soporta_pasarela':
				$valor_campo = implode(', ', $obj->soporta);
				break;
				
			case 'activo_pasarela':
				if ($obj->activo == 'yes'){
					$valor_campo = '<i class="fa fa-check center" alt="'.__('Activa').'" title="'.__('Activa').'"> </i>';
				} else {
					$valor_campo = '<i class="fa fa-times center" alt="'.__('Desactivada').'" title="'.__('Desactivada').'"> </i>';
				}
				break;
		}
		
		if ($valor_campo == ''){
			$valor_campo = parent::getValorCampo($id_columna, $obj);
		}
		
		if (Helpers::is_json($valor_campo)) {
            $tmp_val = (array) json_decode($valor_campo);
            if (isset($tmp_val[SistemaIdioma::getIdiomaSesion(true)]))
                $valor_campo = $tmp_val[SistemaIdioma::getIdiomaSesion(true)];
        }
        return $valor_campo;
	}
}