<?php
class PedidoShopListadoAdminModel extends ListadoAdminModel {
	var $columnas = array("estado_pedido", "pedido_html", "datos_facturacion", "datos_envio", "total_pedido");
	
	public static function getValorCampo($id_columna, $obj) {
		
		$txt_cm = '';
		if (isset($GLOBALS['custom_menu'])){
			$txt_cm = '&custom_menu='.$GLOBALS['custom_menu']->id;
		}
        $valor_campo = '';
        switch ($id_columna) {
			case 'estado_pedido':
				e_include('ext_shop/class/estadoPedidoShop');
				
				$estados = new EstadoPedidoShop();
				$estados = $estados->Listar();
				
				$estado_sel = new EstadoPedidoShop($obj->estado);
				$extra_cls = ' '.$estado_sel->clase_css;
				
				$valor_campo = '<div class="dropdown" data-togglelist data-var="estado" data-val="'.$obj->estado.'" data-url="'.CONF_URL_APP.'api/shop/pedido/updateVarPedido.json" data-token="'.Helpers::getFormToken().'" data-id="'.$obj->id.'">';
				$valor_campo .= '<a href="#" data-toggle="dropdown" class="label'.$extra_cls.'">'.SistemaIdioma::Imprimir($estado_sel->nombre).' <span class="caret"></span></a>';
				$valor_campo .= '<ul class="dropdown-menu">';
				foreach ($estados as $estado){
					$sel_txt = '';
					if ($obj->estado == $estado->id){
						$sel_txt = ' class="active"';
					}
					$valor_campo .= '<li'.$sel_txt.'><a data-val="'.$estado->id.'" data-class="'.$estado->clase_css.'" href="javascript:;">'.SistemaIdioma::Imprimir($estado->nombre).'</a></li>';
				}
				$valor_campo .= '</ul>';
				$valor_campo .= '</div>';
				break;
				
			case 'pedido_html':
				$valor_campo = '<a href="?extension=ext_shop&vista=editar_pedido&id='.$obj->id . $txt_cm.'" title="'.__('Editar').'"><strong>'.sprintf(__("Pedido #%s"), $obj->id).'</strong></a> '.sprintf(__("elaborado el %s"), strftime("%Y-%m-%d %H:%M", strtotime($obj->fecha))).'<br />
				<small>'.__('Email:').' <a href="mailto:'.$obj->email.'">'.$obj->email.'</a><br />
				'.__('Teléfono:');
				if ($obj->envio_a_facturacion == 0) $valor_campo .= $obj->datos['envio']['envio_telefono']; else $valor_campo .= $obj->datos['facturacion']['telefono'];
				$valor_campo .= '</small>';
				
				if ($obj->esta_facturado()){
                $valor_campo .= '<br />
                <a class="btn btn-xs btn-primary" href="?extension=ext_shop&vista=editar_factura&id='.$obj->esta_facturado(true) . $txt_cm .'">'.sprintf(__("Factura #%s"), $obj->esta_facturado()).'</a> <a href="?extension=ext_shop&vista=editar_factura&id='.$obj->esta_facturado(true).'&download=email'.$txt_cm.'" target="_blank" class="btn btn-xs btn-primary iframe-config"  title="'.__('Su Factura se ha enviado correctamente').'"><i class="fa fa fa-envelope"> </i></a> <a href="?extension=ext_shop&vista=editar_factura&id='.$obj->esta_facturado(true).'&download=html'.$txt_cm.'" target="_blank" class="btn btn-xs btn-primary" title="'.__('Imprimir Factura').'"><i class="fa fa fa-print"> </i></a>';
                }
				
				break;
				
			case 'datos_facturacion':
				$valor_campo = '<a href="?extension=ext_shop&vista=editar_pedido&id='.$obj->id.$txt_cm.'" title="'.__('Editar').'">'.$obj->datos['facturacion']['nombre'] . ' ' . $obj->datos['facturacion']['apellidos'].'</a> <br />
                <small>'.$obj->datos['facturacion']['direccion'] . ', ' . $obj->datos['facturacion']['codigo_postal'] . ' ' . $obj->datos['facturacion']['nombre_localidad'] . ', ' . $obj->datos['facturacion']['nombre_provincia'].'</small>';
				break;
				
			case 'datos_envio':
				if ($obj->envio_a_facturacion == 0){
					$valor_campo = '<a href="?extension=ext_shop&vista=editar_pedido&id='.$obj->id.$txt_cm.'" title="'.__('Editar').'">'.$obj->datos['envio']['envio_nombre'] . ' ' . $obj->datos['envio']['envio_apellidos'].'</a> <br />
					<small>'.$obj->datos['envio']['envio_direccion'] . ', ' . $obj->datos['envio']['envio_codigo_postal'] . ' ' . $obj->datos['envio']['nombre_localidad'] . ', ' . $obj->datos['envio']['nombre_provincia'].'</small>';
				} else {
					$valor_campo = '--';
				}
				
				break;
				
			case 'total_pedido':
				$valor_campo = number_format($obj->datos['total']['total'], 2, ',', '.').' &euro;';
				break;
		}
		
		if (Helpers::is_json($valor_campo)) {
            $tmp_val = (array) json_decode($valor_campo);
            if (isset($tmp_val[SistemaIdioma::getIdiomaSesion(true)]))
                $valor_campo = $tmp_val[SistemaIdioma::getIdiomaSesion(true)];
        }
        return $valor_campo;
	}
}