<?php
/**
 * Modelo del listado de artículos de una categoría, permite manejar los listados de artículos de una categoría de forma fácil
 *
 * @package		Mideas.Articulos
 * @subpackage	Model
 * @since		1.0
 */
class CategoriaProductoModel extends ListadoModel{
	
	protected $global_main_class = 'shop';
	
	protected $ext_folder = 'ext_shop';
	
	protected $categoria_class = 'CategoriaProducto';
	protected $item_class = 'Producto';
	
	protected $categoria_vista = 'categoria_productos';
	protected $item_vista = 'producto';
	
	protected $campo_titulo_orden = 'nombre';
	
	function __construct($id=''){
		parent::__construct($id);
	}
		
	public function includes(){
		//Clase requerida
		e_include('ext_shop/class/categoriaProducto','ext_shop/class/producto');
		$tmp_ct = new $this->categoria_class();
		$tmp_it = new $this->item_class();
	}
	
	public function get_params($custom_params=array()){
		parent::get_params($custom_params);
		
		$params = array();
		
		if (!isset($GLOBALS['params_enlace_actual'])){
			$params['tipos_resultados'] = '';
		} elseif (is_array($custom_params) && sizeof($custom_params) > 0) {
			$params['tipos_resultados'] = $custom_params['tipos_resultados'];
		} else {
			$params['tipos_resultados'] = $GLOBALS['params_enlace_actual']['params']['tipos_resultados'];
		}
		
		if (!empty($params['tipos_resultados'])){
			$this->parametros['params']['tipos_resultados'] = $params['tipos_resultados'];
			if ($params['tipos_resultados'] == 'solo_venta'){
				$this->parametros['params']['where'][] = "solocatalogo = 0";
			} elseif ($params['tipos_resultados'] == 'solo_catalogo'){
				$this->parametros['params']['where'][] = "solocatalogo = 1";
			} elseif ($params['tipos_resultados'] == 'no'){
				$this->parametros['params']['where'][] = "estado = -1";
			}
		}
		
	}
}