<?php
/**
 * Modelo del listado de artículos de una categoría, permite manejar los listados de artículos de una categoría de forma fácil
 *
 * @package		Mideas.Articulos
 * @subpackage	Model
 * @since		1.0
 */
class CestaModel {
	
	protected $ext_folder = "ext_shop_cesta";
	
	var $paises_envio=array();
	
	function __construct($id=''){
		//Incluimos los archivos necesarios
		self::includes();
		
		//Recuperamos los parámetros de la vista
		$this->get_params();
	}
	
	public function getTitulo(){
		return __('Cesta de la compra');
	}
		
	private function includes(){
		//Clase requerida
		e_include('ext_shop/class/categoriaProducto','ext_shop/class/producto');
	}
	
	private function get_params(){
		global $shop;
		
		$config_shop = $shop->config;
		
		if ($config_shop['shop']['solo_catalogo'] == '1'){
			echo App::printErrorPage('500', __('No se permite el acceso de la cesta de la compra'));
			exit;
			break;
		}
		
		global $paises_defecto_shop;
			
		if (is_array($paises_defecto_shop)){
			$localizaciones_permitidas = $paises_defecto_shop;
		} else {
			$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
			$localizaciones_permitidas = $paises_defecto_shop;
		}
		
		$paises_permitidos = array();
		if (is_array($localizaciones_permitidas) && sizeof($localizaciones_permitidas) > 0){
			c_include('loc/pais','loc/provincia');
			
			foreach ($localizaciones_permitidas as $klp=>$lp){
				$parsed_lp = explode('.',$lp);
				
				$pais_id = $parsed_lp[0];
				$prov_id = $parsed_lp[1];
				
				$pais_label = '';
				$prov_label = '';
				
				$pais_obj = Pais::BuscarPorISO2($pais_id);
				
				$pais_label = $pais_obj->getpais();
				
				if ($prov_id != '0'){
					$prov_obj = Provincia::BuscarObjPorId($prov_id);
					
					$prov_label = $prov_obj->getprovincia();
				}
				
				$arr_key = $lp;
				$arr_value = $pais_label;
				if (!empty($prov_label))
					$arr_value .= ' - '.$prov_label;
				
				$paises_permitidos[$arr_key] = $arr_value;
			}
		}
		
		$this->paises_envio = $paises_permitidos;
	//	
//		$localizaciones_permitidas = $config_shop['envios']['paises'];
//		$paises_permitidos = array();
//		
//		if (is_array($localizaciones_permitidas) && sizeof($localizaciones_permitidas) > 0){
//			foreach ($localizaciones_permitidas as $klp=>$lp){
//				$parsed_lp = explode('.',$lp);
//				
//				$pais_id = $parsed_lp[0];
//				
//				if (!in_array($pais_id, $paises_permitidos)){
//					$paises_permitidos[] = $pais_id;
//				}
//			}
//		}
//		
//		$this->paises_envio = Helpers::getPaises($paises_permitidos, 'array');
//		asort($this->paises_envio);
		
	}
	
	 /**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function get($property, $default = null) {
        if (isset($this->$property)) {
            return $this->$property;
        }
        return $default;
    }
    /**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function set($property, $default = null) {
        $this->$property = $default;
        return $default;
    }
	
}