<?php
class Cesta_finModel{
	protected $ext_folder = "ext_shop_cesta_fin";
	
	function __construct(){
		//Incluimos los archivos necesarios
		self::includes();
		
		//Recuperamos los parámetros de la vista
		$this->get_params();
		
		$this->get_opts();
	}
	
	public function getTitulo(){
		$title_link = SistemaIdioma::Imprimir($GLOBALS['enlace_actual']->titulo);
		if (!empty($title_link)){
			return $title_link;
		} else {
			return __('Finalizar pago');
		}
	}
	
	private function includes(){
		//Clase requerida
		e_include('ext_shop/class/checkout','ext_shop/class/pago','ext_shop/class/pedidoShop');
	}
	
	private function get_params(){
		global $shop;
		
		$this->carrito = $shop->carrito;
	}
	
	private function get_opts(){
		$ped_esp_pago = Helpers::getSesion()->get('shop.pedido_esperando_pago');
		
		if ((!empty($_POST) || !empty($_GET['?peticion']) || !empty($_GET['amp;?peticion'])) && !empty($_GET['payment'])){
			$met_pag_sel = $_GET['payment'];
			
			// Payment Method
			$pagos = new Pago();
			$available_gateways = $pagos->pasarelas_pago();
			
			if ( ! isset( $available_gateways[ $met_pag_sel ] ) ) {
				$this->metodo_pago = '';
				App::setMsg( __( 'Invalid payment method.' ), 'error' );
			} else {
				$this->metodo_pago = $available_gateways[ $met_pag_sel ];
				//$this->metodo_pago->validate_campos();
			}
			
			$this->metodo_pago->comprobar_respuesta_ipn();
		} elseif (!empty($_GET['pedido']) && !empty($ped_esp_pago) && $_GET['pedido'] == $ped_esp_pago) {
			if (empty($_GET['popup'])){
				$url = Helpers::currentUrl().'&popup=1';
				echo "<script>opener.location='".$url."';window.close();</script>";
				//Helpers::redirect(Helpers::currentUrl().'&popup=1');
				exit;
			}
			$this->pedido_finalizado = new PedidoShop();
			$this->pedido_finalizado->setid($_GET['pedido']);
			$this->pedido_finalizado = $this->pedido_finalizado->BuscarId();
			
			Helpers::getSesion()->clear('shop.pedido_esperando_pago');
			$this->carrito->reglas_aplicadas = array();
			$this->carrito->vaciar_carrito();
		} elseif (!empty($_GET['pedido_fallido']) && !empty($ped_esp_pago) && $_GET['pedido_fallido'] == $ped_esp_pago) {
			if (empty($_GET['popup'])){
				$url = Helpers::currentUrl().'&popup=1';
				echo "<script>opener.location='".$url."';window.close();</script>";
				//Helpers::redirect(Helpers::currentUrl().'&popup=1');
				exit;
			}
			$pedido_fallido = new PedidoShop();
			$pedido_fallido->setid($_GET['pedido_fallido']);
			$pedido_fallido = $pedido_fallido->BuscarId();
			Helpers::getSesion()->clear('shop.pedido_esperando_pago');
			//$this->carrito->reglas_aplicadas = array();
			//$this->carrito->vaciar_carrito();
			App::setMsg(__('¡Se ha producido un error al intentar pagar el pedido!'), 'error');
			$cesta_link = Helpers::resolveLink(false,'ext_shop','cesta',__('Carrito'),0);
			Helpers::redirect($cesta_link);
			exit;
		} else {
			App::setMsg(__('No se puede acceder a esta página directamente!'), 'error');
			$tienda_link = Helpers::resolveLink(false,'ext_shop','categoria_productos',__('Tienda'),$GLOBALS['opciones']['ext_shop']['shop']['categoria_defecto'][0]);
			Helpers::redirect($tienda_link);
			exit;
		}
	}
	
	/**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function get($property, $default = null) {
        if (isset($this->$property)) {
            return $this->$property;
        }
        return $default;
    }
    /**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function set($property, $default = null) {
        $this->$property = $default;
        return $default;
    }
	
}