<?php
class Cesta_pagoModel{
	protected $ext_folder = "ext_shop_cesta_pago";
	
	function __construct(){
		//Incluimos los archivos necesarios
		self::includes();
		
		//Recuperamos los parámetros de la vista
		$this->get_params();
		
		$this->get_opts();
	}
	
	public function getTitulo(){
		return __('Envío y método de pago');
	}
	
	private function includes(){
		//Clase requerida
		e_include('ext_shop/class/categoriaProducto','ext_shop/class/producto','ext_shop/class/carrito','ext_shop/models/cesta','ext_shop/class/checkout');
	}
	
	private function get_params(){
		global $shop;
		
		$this->carrito = $shop->carrito;
		$this->config = $shop->config;
	}
	
	private function get_opts(){
		if ($this->config['clientes']['permitir_invitados'] == '0' && !Usuario::isLoged()){
			App::setMsg(__('No se permite realizar pedidos como invitado. Por favor, regístrese o identifíquese para continuar con el proceso de compra.'), 'error');
			$tienda_link = Helpers::resolveLink(false,'ext_shop','categoria_productos',__('Tienda'),$GLOBALS['opciones']['ext_shop']['shop']['categoria_defecto'][0]);
			Helpers::redirect($tienda_link);
			exit;
		}
		if ( sizeof( $this->carrito->get_carrito() ) == 0 ) {
			App::setMsg(__('No se puede acceder a esta página con el carrito vacío.'), 'error');
			$tienda_link = Helpers::resolveLink(false,'ext_shop','categoria_productos',__('Tienda'),$GLOBALS['opciones']['ext_shop']['shop']['categoria_defecto'][0]);
			Helpers::redirect($tienda_link);
			exit;
		}
		
		if ($_POST['accion'] == 'cambia_pasarela_pago' && !empty($_POST['pasarela']) && $_POST['token'] == Helpers::getFormToken()){
			parse_str($_POST['posted'], $posted_vars);
			
			$usr_sess = Helpers::getSesion()->get('shop.usuario');
			
			$usr_sess["nombre"] = $posted_vars["facturacion"]["nombre"];
			$usr_sess["apellidos"] = $posted_vars["facturacion"]["apellidos"];
			$usr_sess["nif"] = $posted_vars["facturacion"]["nif"];
			$usr_sess["direccion"] = $posted_vars["facturacion"]["direccion"];
			$usr_sess["codigo_postal"] = $posted_vars["facturacion"]["codigo_postal"];
			$usr_sess["localidad"] = $posted_vars["facturacion"]["localidad"];
			$usr_sess["provincia"] = $posted_vars["facturacion"]["provincia"];
			$usr_sess["pais"] = $posted_vars["facturacion"]["pais"];
			$usr_sess["telefono"] = $posted_vars["facturacion"]["telefono"];
			$usr_sess["envio_igual_facturacion"] = isset($posted_vars["envio_igual_facturacion"]) ? 1:0;
			$usr_sess["envio_nombre"] = $posted_vars["envio"]["envio_nombre"];
			$usr_sess["envio_apellidos"] = $posted_vars["envio"]["envio_apellidos"];
			$usr_sess["envio_direccion"] = $posted_vars["envio"]["envio_direccion"];
			$usr_sess["envio_codigo_postal"] = $posted_vars["envio"]["envio_codigo_postal"];
			$usr_sess["envio_localidad"] = $posted_vars["envio"]["envio_localidad"];
			$usr_sess["envio_provincia"] = $posted_vars["envio"]["envio_provincia"];
			$usr_sess["envio_pais"] = $posted_vars["envio"]["envio_pais"];
			$usr_sess["envio_telefono"] = $posted_vars["envio"]["envio_telefono"];
			
			Helpers::getSesion()->set('shop.usuario', $usr_sess);
			
			$ped_sess = Helpers::getSesion()->get('shop.pedido');
			
			$ped_sess["notas"] = $posted_vars["pedido"]["comentarios_pedido"];
			
			Helpers::getSesion()->set('shop.pedido', $ped_sess);
			
			$usr_site_sess = Helpers::getSesion()->get('site.usuario');
			
			$usr_site_sess["email"] = $posted_vars["usuario"]["email"];
			$usr_site_sess["password"] = $posted_vars["usuario"]["password"];
			$usr_site_sess["password2"] = $posted_vars["usuario"]["password-2"];
			Helpers::getSesion()->clear('shop._metodo_envio_elegido');
			
			Helpers::getSesion()->set('shop._metodo_pago_elegido', $_POST['pasarela']);
			
			$this->carrito->calcular_totales();
			
			App::setMsg(__('Método de pago cambiado'), 'success');
			echo 'ok';
			exit;
		}
		
		$this->cesta = new CestaModel();
		
		$this->checkout = new ShopCheckout();
		
		$usuario_activo = new Usuario();
		$usuario_activo->setid(Usuario::getLogedId());
		
		if ($usuario_activo = $usuario_activo->BuscarId()){
			$this->usuario_activo = $usuario_activo;
		}
		
		$this->datos_cliente = Helpers::getSesion()->get('shop.usuario');
		
		$cliente_activo = new ClienteShop();
		$cliente_activo->setid_usuario(Usuario::getLogedId());
		
		if ($cliente_activo = $cliente_activo->BuscarIdUsuario()){
			if ($cliente_activo->id == ""){
				$cliente_activo = new ClienteShop();
				$cliente_activo->setid_usuario(Usuario::getLogedId());
			}
		} else {
			$cliente_activo = new ClienteShop();
			$cliente_activo->setid_usuario(Usuario::getLogedId());
		}
		
		$this->cliente_activo = $cliente_activo;
	}
	
	/**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function get($property, $default = null) {
        if (isset($this->$property)) {
            return $this->$property;
        }
        return $default;
    }
    /**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function set($property, $default = null) {
        $this->$property = $default;
        return $default;
    }
	
}