<?php
/**
 * Customer
 *
 * The Shop cliente class handles storage of the current cliente's data, such as localizacion.
 *
 * @class 		ClienteShopModel
 * @version		1.6.4
 * @package		Shop/Classes
 * @category	Class
 * @author 		Mideas
 */
class ClienteShopModel {	/** Stores cliente data as an array */
	protected $_data;	/** Stores bool when data is changed */
	private $_changed = false;
	
	var $_object;
	
	var $pedidos;
	var $facturas;	/**
	 * Constructor for the cliente class loads the cliente data.
	 *
	 * @access public
	 * @return void
	 */
	public function __construct($formularios=null) {
		global $shop;
		
		//var_dumpre($shop);
		if (empty($formularios))
			return false;
		
		c_include('usuario');
		$usuario_mideas = Usuario::getLogedId();
		$usuario_obj_mideas = Usuario::getLoged();
		$usuario_email_mideas = $usuario_obj_mideas->email;
		
		if (empty($usuario_mideas))
			$usuario_mideas = 0;
			
		$this->get_pedidos($usuario_mideas);
		$this->get_facturas($usuario_mideas);
		
		$cliente_mideas = new ClienteShop();
		if (!empty($usuario_mideas)){
			$cliente_mideas->setid_usuario($usuario_mideas);
			if ($cliente_mideas = $cliente_mideas->BuscarIdUsuario()){
			} else {
				$cliente_mideas = new ClienteShop();
			}
		}
		
		$this->_object = $cliente_mideas;
		
		if ( empty( $shop->cliente->_data ) ) {
			
			if (!empty($cliente_mideas->id)){
				
				$campos_facturacion = $formularios["facturacion"]->getCampos();
				$campos_envio = $formularios["envio"]->getCampos();
				
				$this->_data = array(
					'id_usuario_mideas'	=> $usuario_mideas,
					'envio_igual_facturacion'	=> $cliente_mideas->direccion_envio_igual_facturacion,
					'esta_exento_iva' 		=> false,
					'envio_calculado'	=> false
				);
				
				if (!empty($campos_facturacion)){
					foreach ($campos_facturacion as $c_f){
						$alias_var = $c_f->nombre;
						$this->_data[$c_f->nombre] = $cliente_mideas->facturacion->$alias_var;
					}
				}
				
				if (!empty($campos_envio)){
					foreach ($campos_envio as $c_e){
						$alias_var = $c_e->nombre;
						$this->_data[$c_e->nombre] = $cliente_mideas->envio->$alias_var;
					}
				}
				
				
			} else {
				
				global $paises_defecto_shop;
			
				if (is_array($paises_defecto_shop)){
					$paises_permitidos = $paises_defecto_shop;
				} else {
					$paises_defecto_shop = Helpers::getPaisesWithArgs($config_shop['envios']['paises'], $config_shop['envios']['disponibilidad']);
					$paises_permitidos = $paises_defecto_shop;
				}
							
				$default = $paises_permitidos;
	
				if ( strstr( $default, '.' ) ) {
					list( $pais, $provincia ) = explode( '.', $default );
				} else {
					$pais = $default;
					$provincia   = '';
				}
				
				$this->_data = array(
					'id_usuario_mideas'	=> $usuario_mideas,
					'envio_igual_facturacion'	=> 1,
					'esta_exento_iva' 		=> false,
					'envio_calculado'	=> false
				);
				
				if (!empty($campos_facturacion)){
					foreach ($campos_facturacion as $c_f){
						$alias_var = $c_f->nombre;
						if ($alias_var == 'pais'){
							$this->_data[$c_f->nombre] = $pais;
						} else {
							$this->_data[$c_f->nombre] = '';
						}
					}
				}
				
				if (!empty($campos_envio)){
					foreach ($campos_envio as $c_e){
						$alias_var = $c_e->nombre;
						if ($alias_var == 'envio_pais'){
							$this->_data[$c_e->nombre] = $pais;
						} else {
							$this->_data[$c_e->nombre] = '';
						}
					}
				}
			
			}		} else {			$this->_data = $shop->cliente->_data;		}
		
		// When leaving or ending page load, store data
		$this->save_data();
    	//add_action( 'shutdown', array( $this, 'save_data' ), 10 );
	}
	
	private function get_pedidos($usuario_id){
		if (empty($usuario_id))
			return false;
			
		e_include('ext_shop/class/pedidoShop');
		if (!class_exists('PedidoShop'))
			return false;
			
		$pedidos = new PedidoShop();
		$pedido_c = $pedidos->ListarCount('usuario_id="'.$usuario_id.'"', 'id', 'DESC');
		
		if ($pedido_c > 0){
			$pedidos = $pedidos->Listar('usuario_id="'.$usuario_id.'"', 'id', 'DESC');
		} else {
			$pedidos = array();
		}
		
		$this->pedidos = $pedidos;
		
		return true;
	}
	
	private function get_facturas($usuario_id){
		if (empty($usuario_id))
			return false;
			
		e_include('ext_shop/class/facturaShop');
		if (!class_exists('FacturaShop'))
			return false;
		
		$cliente_usr = new ClienteShop();
		$cliente_usr->setid_usuario($usuario_id);
		$cliente_usr = $cliente_usr->BuscarIdUsuario();
		
		if (!empty($cliente_usr->id)){
			$id_cliente = $cliente_usr->id;
		} else {
			$id_cliente = '-1';
		}
			
		$facturas = new FacturaShop();
		$factura_c = $facturas->ListarCount('creador_id="'.$usuario_id.'" OR (datos_facturacion LIKE "%\"cliente_id\":\"'.$id_cliente.'\"%")', 'id', 'DESC');
		
		if ($factura_c > 0){
			$facturas = $facturas->Listar('creador_id="'.$usuario_id.'" OR (datos_facturacion LIKE "%\"cliente_id\":\"'.$id_cliente.'\"%")', 'id', 'DESC');
		} else {
			$facturas = array();
		}
		
		$this->facturas = $facturas;
		
		return true;
	}
		/**
	 * save_data function.
	 *
	 * @access public
	 * @return void
	 */
	public function save_data() {
		if ( $this->_changed )
			$GLOBALS['shop']->cliente = $this->_data;
			
		$usr_sess = Helpers::getSesion()->get('shop.usuario');
			
		if ( sizeof( $this->_data ) > 0 ) { 
			foreach ($this->_data as $k=>$v){
				if (!isset($usr_sess[$k])){
					$usr_sess[$k] = $v;
				}
			}
		}
		
		Helpers::getSesion()->set('shop.usuario', $usr_sess);
	}    /**
     * __set function.
     *
     * @access public
     * @param mixed $property
     * @param mixed $value
     * @return void
     */
    public function __isset( $property ) {
        return isset( $this->_data[ $property ] );
    }    /**
     * __get function.
     *
     * @access public
     * @param mixed $property
     * @return mixed
     */
    public function __get( $property ) {
        return isset( $this->_data[ $property ] ) ? $this->_data[ $property ] : null;
    }    /**
     * __set function.
     *
     * @access public
     * @param mixed $property
     * @param mixed $value
     * @return void
     */
    public function __set( $property, $value ) {
        $this->_data[ $property ] = $value;
        $this->_changed = true;
    }	/**
	 * tiene_envio_calculado function.
	 *
	 * @access public
	 * @return bool
	 */
	public function tiene_envio_calculado() {
		return ( ! empty( $this->envio_calculado ) ) ? true : false;
	}
	/**
	 * Set cliente direccion to match shop base direccion.
	 *
	 * @access public
	 * @return void
	 */
	public function set_to_base() {
		global $shop;
		$default = apply_filters( 'shop_cliente_default_localizacion', get_option('shop_default_pais') );
    	if ( strstr( $default, ':' ) ) {
    		list( $pais, $provincia ) = explode( ':', $default );
    	} else {
    		$pais = $default;
    		$provincia = '';
    	}
    	$this->pais  = $pais;
    	$this->provincia    = $provincia;
    	$this->codigo_postal = '';
    	$this->poblacion     = '';
	}
	/**
	 * Set cliente envio direccion to base direccion.
	 *
	 * @access public
	 * @return void
	 */
	public function set_envio_to_base() {
		global $shop;
		$default = get_option('shop_default_pais');
    	if ( strstr( $default, ':' ) ) {
    		list( $pais, $provincia ) = explode( ':', $default );
    	} else {
    		$pais = $default;
    		$provincia = '';
    	}
    	$this->envio_pais  = $pais;
    	$this->envio_provincia    = $provincia;
    	$this->envio_codigo_postal = '';
    	$this->envio_poblacion     = '';
	}
	/**
	 * Is cliente outside base pais (for tax purposes)?
	 *
	 * @access public
	 * @return bool
	 */
	public function is_cliente_outside_base() {
		list( $pais, $provincia, $codigo_postal, $poblacion ) = $this->get_direccion_gravable();		if ( $pais ) {			$default = get_option('shop_default_pais');        	if ( strstr( $default, ':' ) ) {
	    		list( $default_pais, $default_provincia ) = explode( ':', $default );
	    	} else {
	    		$default_pais = $default;
	    		$default_provincia = '';
	    	}			if ( $default_pais !== $pais ) return true;
			if ( $default_provincia && $default_provincia !== $provincia ) return true;		}
		return false;
	}
	/**
	 * Is cliente VAT exempt?
	 *
	 * @access public
	 * @return bool
	 */
	public function esta_exento_iva() {
		return ( ! empty( $this->esta_exento_iva ) ) ? true : false;
	}
	/**
	 * Gets the provincia from the current session.
	 *
	 * @access public
	 * @return string
	 */
	public function get_provincia() {
		if ( isset( $this->provincia ) ) return $this->provincia;
	}
	/**
	 * Gets the pais from the current session
	 *
	 * @access public
	 * @return string
	 */
	public function get_pais() {
		if ( isset( $this->pais ) ) return $this->pais;
	}
	/**
	 * Gets the codigo_postal from the current session.
	 *
	 * @access public
	 * @return string
	 */
	public function get_codigo_postal() {
		global $shop;
		$validation = $shop->validation();
		if ( isset( $this->codigo_postal ) && $this->codigo_postal !== false )
			return $validation->format_codigo_postal( $this->codigo_postal, $this->get_pais() );
	}
	/**
	 * Get the poblacion from the current session.
	 *
	 * @access public
	 * @return void
	 */
	public function get_poblacion() {
		if ( isset( $this->poblacion ) ) return $this->poblacion;
	}	/**
	 * Gets the direccion from the current session.
	 *
	 * @access public
	 * @return void
	 */
	public function get_direccion() {
		if ( isset( $this->direccion ) ) return $this->direccion;
	}	/**
	 * Gets the direccion_2 from the current session.
	 *
	 * @access public
	 * @return void
	 */
	public function get_direccion_2() {
		if ( isset( $this->direccion_2 ) ) return $this->direccion_2;
	}	/**
	 * Gets the provincia from the current session.
	 *
	 * @access public
	 * @return string
	 */
	public function get_envio_provincia() {
		if ( isset( $this->envio_provincia ) ) return $this->envio_provincia;
	}
	/**
	 * Gets the pais from the current session.
	 *
	 * @access public
	 * @return string
	 */
	public function get_envio_pais() {
		if ( isset( $this->envio_pais ) ) return $this->envio_pais;
	}
	/**
	 * Gets the codigo_postal from the current session.
	 *
	 * @access public
	 * @return string
	 */
	public function get_envio_codigo_postal() {
		global $shop;
		$validation = $shop->validation();
		if ( isset( $this->envio_codigo_postal ) )
			return $validation->format_codigo_postal( $this->envio_codigo_postal, $this->get_envio_pais() );
	}
	/**
	 * Gets the poblacion from the current session.
	 *
	 * @access public
	 * @return void
	 */
	public function get_envio_poblacion() {
		if ( isset( $this->envio_poblacion ) ) return $this->envio_poblacion;
	}	/**
	 * Gets the direccion from the current session.
	 *
	 * @access public
	 * @return void
	 */
	public function get_envio_direccion() {
		if ( isset( $this->envio_direccion ) ) return $this->envio_direccion;
	}	/**
	 * Gets the direccion_2 from the current session.
	 *
	 * @access public
	 * @return void
	 */
	public function get_envio_direccion_2() {
		if ( isset( $this->envio_direccion_2 ) ) return $this->envio_direccion_2;
	}	/**
	 * get_direccion_gravable function.
	 *
	 * @access public
	 * @return void
	 */
	public function get_direccion_gravable() {
		$tax_based_on = get_option( 'shop_tax_based_on' );		if ( $tax_based_on == 'base' ) {			$default = get_option( 'shop_default_pais' );
	    	if ( strstr( $default, ':' ) ) {
	    		list( $pais, $provincia ) = explode( ':', $default );
	    	} else {
	    		$pais = $default;
	    		$provincia = '';
	    	}			$codigo_postal   = '';
			$poblacion   	= '';		} elseif ( $tax_based_on == 'billing' ) {			$pais 	= $this->get_pais();
			$provincia 		= $this->get_provincia();
			$codigo_postal   = $this->get_codigo_postal();
			$poblacion   	= $this->get_poblacion();		} else {			$pais 	= $this->get_envio_pais();
			$provincia 		= $this->get_envio_provincia();
			$codigo_postal   = $this->get_envio_codigo_postal();
			$poblacion   	= $this->get_envio_poblacion();		}		return apply_filters( 'shop_cliente_taxable_direccion', array( $pais, $provincia, $codigo_postal, $poblacion ) );
	}
	/**
	 * Sets session data for the localizacion.
	 *
	 * @access public
	 * @param mixed $pais
	 * @param mixed $provincia
	 * @param string $codigo_postal (default: '')
	 * @param string $poblacion (default: '')
	 * @return void
	 */
	public function set_localizacion( $pais, $provincia, $codigo_postal = '', $poblacion = '' ) {
		$this->pais = $pais;
		$this->provincia = $provincia;
		$this->codigo_postal = $codigo_postal;
		$this->poblacion = $poblacion;
	}
	/**
	 * Sets session data for the pais.
	 *
	 * @access public
	 * @param mixed $pais
	 * @return void
	 */
	public function set_pais( $pais ) {
		$this->pais = $pais;
	}
	/**
	 * Sets session data for the provincia.
	 *
	 * @access public
	 * @param mixed $provincia
	 * @return void
	 */
	public function set_provincia( $provincia ) {
		$this->provincia = $provincia;
	}
	/**
	 * Sets session data for the codigo_postal.
	 *
	 * @access public
	 * @param mixed $codigo_postal
	 * @return void
	 */
	public function set_codigo_postal( $codigo_postal ) {
		$this->codigo_postal = $codigo_postal;
	}
	/**
	 * Sets session data for the poblacion.
	 *
	 * @access public
	 * @param mixed $codigo_postal
	 * @return void
	 */
	public function set_poblacion( $poblacion ) {
		$this->poblacion = $poblacion;
	}	/**
	 * Sets session data for the direccion.
	 *
	 * @access public
	 * @param mixed $direccion
	 * @return void
	 */
	public function set_direccion( $direccion ) {
		$this->direccion = $direccion;
	}	/**
	 * Sets session data for the direccion_2.
	 *
	 * @access public
	 * @param mixed $direccion_2
	 * @return void
	 */
	public function set_direccion_2( $direccion_2 ) {
		$this->direccion_2 = $direccion_2;
	}	/**
	 * Sets session data for the localizacion.
	 *
	 * @access public
	 * @param mixed $pais
	 * @param string $provincia (default: '')
	 * @param string $codigo_postal (default: '')
	 * @param string $poblacion (default: '')
	 * @return void
	 */
	public function set_envio_localizacion( $pais, $provincia = '', $codigo_postal = '', $poblacion = '' ) {
		$this->envio_pais = $pais;
		$this->envio_provincia = $provincia;
		$this->envio_codigo_postal = $codigo_postal;
		$this->envio_poblacion = $poblacion;
	}
	/**
	 * Sets session data for the pais.
	 *
	 * @access public
	 * @param mixed $pais
	 * @return void
	 */
	public function set_envio_pais( $pais ) {
		$this->envio_pais = $pais;
	}
	/**
	 * Sets session data for the provincia.
	 *
	 * @access public
	 * @param mixed $provincia
	 * @return void
	 */
	public function set_envio_provincia( $provincia ) {
		$this->envio_provincia = $provincia;
	}
	/**
	 * Sets session data for the codigo_postal.
	 *
	 * @access public
	 * @param mixed $codigo_postal
	 * @return void
	 */
	public function set_envio_codigo_postal( $codigo_postal ) {
		$this->envio_codigo_postal = $codigo_postal;
	}
	/**
	 * Sets session data for the poblacion.
	 *
	 * @access public
	 * @param mixed $codigo_postal
	 * @return void
	 */
	public function set_envio_poblacion( $poblacion ) {
		$this->envio_poblacion = $poblacion;
	}	/**
	 * Sets session data for the direccion.
	 *
	 * @access public
	 * @param mixed $direccion
	 * @return void
	 */
	public function set_envio_direccion( $direccion ) {
		$this->envio_direccion = $direccion;
	}	/**
	 * Sets session data for the direccion_2.
	 *
	 * @access public
	 * @param mixed $direccion_2
	 * @return void
	 */
	public function set_envio_direccion_2( $direccion_2 ) {
		$this->envio_direccion_2 = $direccion_2;
	}
	/**
	 * Sets session data for the tax exemption.
	 *
	 * @access public
	 * @param mixed $esta_exento_iva
	 * @return void
	 */
	public function set_esta_exento_iva( $esta_exento_iva ) {
		$this->esta_exento_iva = $esta_exento_iva;
	}
	/**
	 * envio_calculado function.
	 *
	 * @access public
	 * @param mixed $calculated
	 * @return void
	 */
	public function envio_calculado( $calculated = true ) {
		$this->envio_calculado = $calculated;
	}
	/**
	 * Gets a user's downloadable products if they are logged in.
	 *
	 * @access public
	 * @return array Array of downloadable products
	 */
	public function get_downloadable_products() {
		global $wpdb, $shop;		$downloads = array();		if ( is_user_logged_in() ) :			$user_info = get_userdata( get_current_user_id() );			$results = $wpdb->get_results( $wpdb->prepare("SELECT * FROM ".$wpdb->prefix."shop_downloadable_product_permissions WHERE user_id = '%s' ORDER BY order_id, product_id, download_id", get_current_user_id()) );			$_product = null;
			$order = null;
			$file_number = 0;
			if ($results) foreach ($results as $result) :				if ($result->order_id>0) :					if ( ! $order || $order->id != $result->order_id ) {
						// new order
						$order = new WC_Order( $result->order_id );
						$_product = null;
					}					// order exists and downloads permitted?
					if ( ! $order->id || ! $order->is_download_permitted() || $order->post_status != 'publish' ) continue;					if ( ! $_product || $_product->id != $result->product_id ) :
						// new product
						$file_number = 0;
						$_product = get_product( $result->product_id );
					endif;					if ( ! $_product || ! $_product->exists() ) continue;					if ( ! $_product->tiene_file( $result->download_id ) ) continue;					// Download name will be 'Product Name' for products with a single downloadable file, and 'Product Name - File X' for products with multiple files
					$download_name = apply_filters(
						'shop_downloadable_product_name',
						$_product->get_title() . ( $file_number > 0 ? ' &mdash; ' . sprintf( __( 'File %d', 'shop' ), $file_number + 1 ) : '' ),
						$_product,
						$result->download_id,
						$file_number
					);					// Rename previous download with file number if there are multiple files only
					if ( $file_number == 1 ) {
						$downloads[ count( $downloads ) - 1 ]['download_name'] = apply_filters(
							'shop_downloadable_product_name',
							$downloads[ count( $downloads ) - 1 ]['download_name'] . ' &mdash; ' . sprintf( __( 'File %d', 'shop' ), $file_number ),
							$_product,
							$result->download_id,
							0
						);
					}					$downloads[] = array(
						'download_url' => add_query_arg( array( 'download_file' => $result->product_id, 'order' => $result->order_key, 'email' => $result->user_email, 'key' => $result->download_id ), trailingslashit( home_url() ) ),
						'download_id' => $result->download_id,
						'product_id' => $result->product_id,
						'download_name' => $download_name,
						'order_id' => $order->id,
						'order_key' => $order->order_key,
						'downloads_remaining' => $result->downloads_remaining
					);					$file_number++;				endif;			endforeach;		endif;		return apply_filters('shop_cliente_get_downloadable_products', $downloads);
	}
}