<?php
class Editar_clienteModel{
	protected $ext_folder = "ext_shop_editar_cliente";
	
	function __construct(){
		//Incluimos los archivos necesarios
		self::includes();
		
		//Recuperamos los parámetros de la vista
		$this->get_params();
		
		$this->get_opts();
		
		if (!empty($_POST)){
			$this->post_process();
		}
	}
	
	public function getTitulo(){
		return __('Direcciones de la tienda');
	}
	
	private function includes(){
		//Clase requerida
		c_include('usuario');
		e_include('ext_shop/models/cliente');
	}
	
	private function get_params(){
		global $shop;
		
		$this->formularios = $shop->formularios;
	}
	
	private function get_opts(){
		if (!Usuario::isLoged()){
			App::setMsg(__('Identifícate para acceder a la página de modificación de cuenta'), 'error');
			$link_login = CONF_URL_APP . SistemaIdioma::getIdiomaSesion();
			Helpers::redirect($link_login);
			exit;
		}
		
		if (empty($this->formularios)){
			App::setMsg(__('No hay formularios de la tienda configurados'), 'error');
			$link_tienda = Helpers::resolveLink(false, 'ext_shop', 'categoria_productos', __('Tienda'), $GLOBALS['opciones']['ext_shop']['shop']['categoria_defecto'][0]);
			Helpers::redirect($link_tienda);
			exit;
		}
		
		$this->usuario_activo = new Usuario();
		$this->usuario_activo->setid(Usuario::getLogedId());
		
		if ($this->usuario_activo = $this->usuario_activo->BuscarId()){
		} else {
			App::setMsg(__('No se encuentra el usuario en la base de datos.'), 'error');
		}
		
		$this->cliente_activo = new ClienteShopModel($this->formularios);
	}
	
	private function post_process(){
		if (!empty($_POST['accion']) && $_POST['accion'] == 'guardar'){
			
			if ($_POST['token'] != Helpers::getFormToken()){
				App::setMsg(__('Token incorrecto.'), 'error');
				return false;
			}
			
			if (empty($this->formularios['facturacion']) || empty($this->formularios['envio']))
				return false;
				
			$campos_facturacion = $this->formularios['facturacion']->getCampos();
			$campos_envio = $this->formularios['envio']->getCampos();
			
			if ($_POST['envio_igual_facturacion'] == '1'){
				$pais_envio = $_POST['pais'];
				$provincia_envio = $_POST['provincia'];
				$localidad_envio = $_POST['localidad'];
				$codigo_postal_envio = $_POST['codigo_postal'];
			} else {
				$pais_envio = $_POST['envio_pais'];
				$provincia_envio = $_POST['envio_provincia'];
				$localidad_envio = $_POST['envio_localidad'];
				$codigo_postal_envio = $_POST['envio_codigo_postal'];
			}
			
			$usr_email = Usuario::getLoged()->email;
			
			$cliente_edit = new ClienteShop();
			$cliente_edit->setid_usuario($_POST['id_usuario']);
			
			if ($cliente_edit = $cliente_edit->BuscarIdUsuario()){
				if ($cliente_edit->id_usuario == ""){
					$cliente_edit = new ClienteShop();
					$cliente_edit->setid_usuario(Usuario::getLogedId());
					$cliente_edit->setemail($usr_email);
				}
			} else {
				$cliente_edit = new ClienteShop();
				$cliente_edit->setid_usuario(Usuario::getLogedId());
				$cliente_edit->setemail($usr_email);
			}
			
			$cliente_edit->setemail($usr_email);
			
			if (!empty($campos_facturacion) && is_array($campos_facturacion)){
				$campos_facturacion_parsed = array();
				foreach ($campos_facturacion as $c_f){
					$campos_facturacion_parsed[$c_f->nombre] = $_POST[$c_f->nombre];
				}
				$cliente_edit->setdatos_facturacion(json_encode($campos_facturacion_parsed));
			}
			
			$cliente_edit->setdireccion_envio_igual_facturacion($_POST['envio_igual_facturacion']);
			
			if (!empty($campos_envio) && is_array($campos_envio)){
				$campos_envio_parsed = array();
				foreach ($campos_envio as $c_e){
					if ($_POST['envio_igual_facturacion'] == "1"){
						$campos_envio_parsed[$c_e->nombre] = '';
					} else {
						$campos_envio_parsed[$c_e->nombre] = $_POST[$c_e->nombre];
					}
				}
				$cliente_edit->setdatos_envio(json_encode($campos_envio_parsed));
			}
			
			if (empty($cliente_edit->id)){
					if ($cliente_edit->Guardar()){
						Helpers::getSesion()->set('shop.usuario', $campos_facturacion_parsed);
						App::setMsg(__('Las direcciones se han modificado correctamente.'), 'info');
					} else {
						App::setMsg(__('Se ha producido un error al intentar modificar las direcciones de la tienda.'), 'error');
					}
					
			} else {
				if ($cliente_edit->Modificar()){
					Helpers::getSesion()->set('shop.usuario', $campos_facturacion_parsed);
					App::setMsg(__('Las direcciones se han modificado correctamente.'), 'info');
				} else {
					App::setMsg(__('Se ha producido un error al intentar modificar las direcciones de la tienda.'), 'error');
				}
			}
		}
	}
	
	/**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function get($property, $default = null) {
        if (isset($this->$property)) {
            return $this->$property;
        }
        return $default;
    }
    /**
     * Returns a property of the object or the default value if the property is not set.
     *
     * @param   string  $property  The name of the property.
     * @param   mixed   $default   The default value.
     *
     * @return  mixed    The value of the property.
     *
     * @since   11.1
     *
     * @see     getProperties()
     */
    public function set($property, $default = null) {
        $this->$property = $default;
        return $default;
    }
	
}