<?php
/**
 * Modelo del fabricante, permite manejar los fabricantes de forma fácil
 *
 * @package		Mideas.Muzzim
 * @subpackage	Model
 * @since		1.0
 */
class FabricanteModel extends DetalleModel {
	
	protected $global_main_class = 'shop';
	
	protected $ext_folder = 'ext_shop';
	
	protected $categoria_class = 'CategoriaProducto';
	protected $item_class = 'FabricanteShop';
	
	protected $categoria_vista = 'categoria_fabricantes';
	protected $item_vista = 'fabricante';
	
	var $items;
	
	function __construct($id=''){
		parent::__construct($id);
		
		if (is_object($this->objeto)){	
			$this->getProductosFabricante();
		}
	}
	
	public function includes(){
		c_include('enlace');
		e_include('ext_shop/class/fabricante','ext_shop/class/categoriaProducto','ext_shop/class/producto');
	}
	
	function getTitulo(){
		if (is_object($this->objeto))
			return $this->objeto->getTitulo();
		else
			return false;
	}
	
	private function getProductosFabricante(){
		$fab_id = $this->id;
		$orden = 'fecha';
		$orden_dir = 'DESC';
		$limit1 = 0;
		$limit2 = 20;
		
		$where_pr = "estado=1 AND fecha_publicacion < '".strftime(SistemaIdioma::formatoFecha('sistema'))."' AND fabricante='".$fab_id."'";
		
		$pr = new Producto();
		$pr_c = $pr->ListarCount($where_pr);
		
		if ($pr_c > 0){
			$this->items = $pr->Listar($where_pr, $orden, $orden_dir, $limit1, $limit2);
			return true;
		} else {
			return false;
		}
	}
}