<?php
/**
 * Modelo del listado de artículos de una categoría, permite manejar los listados de artículos de una categoría de forma fácil
 *
 * @package		Mideas.Productos
 * @subpackage	Model
 * @since		1.0
 */
class HomeShopModel {
	/**
     * Artículos del slide
     *
     * @var	array
     * @access  public
     */
	var $slide_items;
	/**
     * Artículos 2 columnas
     *
     * @var	array
     * @access  public
     */
	var $dos_columnas_items;
	/**
     * Artículos 3 columnas
     *
     * @var	array
     * @access  public
     */
	var $tres_columnas_items;
	/**
     * Últimos artículos
     *
     * @var	array
     * @access  public
     */
	var $ultimos_items;
	/**
     * Parámetros de la home
     *
     * @var	array
     * @access  public
     */
	var $parametros;
	
	function __construct($id=''){
		//Incluimos los archivos necesarios
		self::includes();
		
		//Recuperamos los parámetros de la vista
		$this->get_params();
		
		//Recuperamos los listados de artículos ordenados
		//$this->get_items();
		
	}
		
	private function includes(){
		//Clase requerida
		e_include('ext_shop/class/categoriaProducto','ext_shop/class/producto');
	}
	
	private function get_params(){
		global $shop;
		
		//Variable local para almacenar los parámetros
		$params = array();
		
		//Almacenamos los parámetros establecidos por el enlace actual
		$params = $GLOBALS['params_enlace_actual'];
		
		//Parseamos las variables recogidas mediante URL amigable
		if (!empty($shop->params_url_vars)){
			if (!empty($shop->params_url_vars['page'])){
				$_GET['page'] = $shop->params_url_vars['page'];
			}
		}
		//Si se ha establecido una palabra clave de búsqueda, la almacenamos
		//if (!empty($productos->get_vars["keyword"])){
			//$this->filtro_keyword = utf8_decode($productos->get_vars["keyword"]);
		//}
		
		//Establecemos el orden de los resultados
		//if (!empty($productos->get_vars["orden"])){
//			switch($productos->get_vars["orden"]){
//				case 'nuevo':
//					$params['orden'] = 'fecha';
//					$params['orden_dir'] = 'DESC';
//					break;
//				case 'antiguo':
//					$params['orden'] = 'fecha';
//					$params['orden_dir'] = 'ASC';
//					break;
//				case 'a-z':
//					$params['orden'] = 'titulo';
//					$params['orden_dir'] = 'ASC';
//					break;
//				case 'z-a':
//					$params['orden'] = 'titulo';
//					$params['orden_dir'] = 'DESC';
//					break;
//			}
//		}
			
		//Generamos las consultas SQL de los filtros que se vayan a aplicar a los resultados
		//$params['keyword_where'] = '';
		//Establecemos la sentencia SQL para la búsqueda por palabra clave
		//if (!empty($this->filtro_keyword)){
			//$params['keyword_where'] = " AND (titulo LIKE '%".mysql_escape_string($this->filtro_keyword)."%' OR contenido LIKE '%".mysql_escape_string($this->filtro_keyword)."%' OR texto_corto LIKE '%".mysql_escape_string($this->filtro_keyword)."%' OR creador_alias LIKE '%".mysql_escape_string($this->filtro_keyword)."%')";
		//}
		
		//Si no se ha definido un estilo para la vista, chequeamos si el enlace actual tiene un estilo personalizado
		if (empty($_GET['estilo']) && trim($GLOBALS['params_enlace_actual']['estilo']) != '')
			$_GET['estilo'] = $GLOBALS['params_enlace_actual']['estilo'];
		
		//Guardamos el número de página si se ha definido mediante una variable GET	
		if (isset($_GET['page']) && !empty($_GET['page']))
			$this->pagina = (int) $_GET['page'];
		
		//Guardamos los parámetros de los artículos	
		$this->parametros['params'] = $params;
		
	}
	
	private function get_slide_items(){
		//Si no hay parámetros, no seguimos
		if (empty($this->parametros['params']['slide']))
			return false;
		
		$parametros_slide = $this->parametros['params']['slide'];
		
		if ($parametros_slide['mostrar_slide'] == '0')
			return false;
		
		//Recuperamos el número de artículos del slide, aplicando los filtros y orden correspondientes
		$this->slide_items = new Producto();
		
		$total_registros_slide = $this->slide_items->Listar("estado=1 AND fecha_publicacion < '".strftime('%Y-%m-%d %H:%M:%S', time())."'",$parametros_slide['orden_slide'],$parametros_slide['orden_dir_slide']);
		
		$registros_tmp = array();
		if ($total_registros_slide == false){
			$total_registros_slide = 0;
		} else {
			$ids_tmp = array();
			foreach ($total_registros_slide as $art){
				$cats_art = json_decode($art->categorias);
				foreach ($parametros_slide['categorias_slide'] as $cat){
					if (in_array($cat, $cats_art) && !in_array($art->id, $ids_tmp)){
						$ids_tmp[] = $art->id;
						$registros_tmp[] = $art;
					}
				}
			}
			$registros_tmp = array_slice($registros_tmp, 0, $parametros_slide['num_productos_slide']);
			$total_registros_slide = count($registros_tmp);
		}
		
		return $registros_tmp;
	}
	
	private function get_dos_columnas_items(){
		//Si no hay parámetros, no seguimos
		if (empty($this->parametros['params']['2columnas']))
			return false;
		
		$parametros_destacados = $this->parametros['params']['2columnas'];
		
		if ($parametros_destacados['mostrar_2columnas'] == '0')
			return false;
		
		//Recuperamos el número de artículos del bloque de destacados, aplicando los filtros y orden correspondientes
		$this->dos_columnas_items = new Producto();
		
		$total_registros_destacados = $this->dos_columnas_items->Listar("estado=1 AND fecha_publicacion < '".strftime('%Y-%m-%d %H:%M:%S', time())."'",$parametros_destacados['orden'],$parametros_destacados['orden_dir_2columnas']);
		
		$registros_tmp = array();
		if ($total_registros_destacados == false){
			$total_registros_destacados = 0;
		} else {
			$ids_tmp = array();
			foreach ($total_registros_destacados as $art){
				$cats_art = json_decode($art->categorias);
				foreach ($parametros_destacados['categorias_2columnas'] as $cat){
					if (in_array($cat, $cats_art) && !in_array($art->id, $ids_tmp)){
						$ids_tmp[] = $art->id;
						$registros_tmp[] = $art;
					}
				}
			}
			$registros_tmp = array_slice($registros_tmp, 0, $parametros_destacados['num_productos_2columnas']);
			$total_registros_destacados = count($registros_tmp);
		}
		
		return $registros_tmp;
	}
	
	private function get_tres_columnas_items(){
		//Si no hay parámetros, no seguimos
		if (empty($this->parametros['params']['3columnas']))
			return false;
		
		$parametros_destacados = $this->parametros['params']['3columnas'];
		
		if ($parametros_destacados['mostrar_3columnas'] == '0')
			return false;
		
		//Recuperamos el número de artículos del bloque de destacados, aplicando los filtros y orden correspondientes
		$this->tres_columnas_items = new Producto();
		
		$total_registros_destacados = $this->tres_columnas_items->Listar("estado=1 AND fecha_publicacion < '".strftime('%Y-%m-%d %H:%M:%S', time())."'",$parametros_destacados['orden'],$parametros_destacados['orden_dir_3columnas']);
		
		$registros_tmp = array();
		if ($total_registros_destacados == false){
			$total_registros_destacados = 0;
		} else {
			$ids_tmp = array();
			foreach ($total_registros_destacados as $art){
				$cats_art = json_decode($art->categorias);
				foreach ($parametros_destacados['categorias_3columnas'] as $cat){
					if (in_array($cat, $cats_art) && !in_array($art->id, $ids_tmp)){
						$ids_tmp[] = $art->id;
						$registros_tmp[] = $art;
					}
				}
			}
			$registros_tmp = array_slice($registros_tmp, 0, $parametros_destacados['num_productos_3columnas']);
			$total_registros_destacados = count($registros_tmp);
		}
		
		return $registros_tmp;
	}
	
	private function get_ultimos_items(){
		//Si no hay parámetros, no seguimos
		if (empty($this->parametros['params']['ultimos']))
			return false;
		
		$parametros_ultimos = $this->parametros['params']['ultimos'];
		
		if ($parametros_ultimos['mostrar_ultimos'] == '0')
			return false;
		
		//Recuperamos el número de artículos del bloque de ultimos, aplicando los filtros y orden correspondientes
		$this->ultimos_items = new Producto();
		
		$total_registros_ultimos = $this->ultimos_items->Listar("estado=1 AND fecha_publicacion < '".strftime('%Y-%m-%d %H:%M:%S', time())."'",$parametros_ultimos['orden'],$parametros_ultimos['orden_dir_ultimos']);
		
		$registros_tmp = array();
		if ($total_registros_ultimos == false){
			$total_registros_ultimos = 0;
		} else {
			$ids_tmp = array();
			foreach ($total_registros_ultimos as $art){
				$cats_art = json_decode($art->categorias);
				foreach ($parametros_ultimos['categorias_ultimos'] as $cat){
					if (in_array($cat, $cats_art) && !in_array($art->id, $ids_tmp)){
						$ids_tmp[] = $art->id;
						$registros_tmp[] = $art;
					}
				}
			}
			$registros_tmp = array_slice($registros_tmp, 0, $parametros_ultimos['num_productos_ultimos']);
			$total_registros_ultimos = count($registros_tmp);
		}
		
		return $registros_tmp;
	}
	
	public function get_items(){
		//Si no hay parámetros, no seguimos
		if (empty($this->parametros['params']))
			return false;
		
		//Almacenamos los parámetros de la vista en una variable local	
		$params = $this->parametros['params'];
		
		//Recuperamos los items del slide
		$this->slide_items = $this->get_slide_items();
		
		//Recuperamos los items del bloque 2 columnas
		$this->dos_columnas_items = $this->get_dos_columnas_items();
		
		//Recuperamos los items del bloque 3 columnas
		$this->tres_columnas_items = $this->get_tres_columnas_items();
		
		//Recuperamos los items del bloque últimos artículos
		$this->ultimos_items = $this->get_ultimos_items();
		
		/*
		//Tamaño de resultados por página
		$tam_page = (int) $params['max'];
		
		//Calculamos el número de página en el que estamos
		if (!empty($this->pagina)){
			$pagina = $this->pagina;
		} else {
			$pagina = 1;
			$inicio = 1;
			$final = $tam_page;
		}
		
		//Guardamos la página actual
		$this->pagina = $pagina;
		
		//calculo del limite inferior
		$this->limite_inferior=($pagina-1)*$tam_page;
		
		//calculo del numero de paginas 
		$num_pags=ceil($total_registros/$tam_page);	
		$this->total_paginas = $num_pags;
				
		//Recuperamos y almacenamos el listado de profesionales, aplicando los filtros y orden correspondientes
		$this->items = array_slice($registros_tmp, $this->limite_inferior, $tam_page);
		//$this->items = $this->items->Listar("estado=1 AND fecha_publicacion < '".strftime('%Y-%m-%d %H:%M:%S', time())."'".$params['keyword_where'],$params['orden'],$params['orden_dir'],$this->limite_inferior,$tam_page);
		*/
		$this->calcula_comentarios_items('slide');
		$this->calcula_comentarios_items('dos_columnas');
		$this->calcula_comentarios_items('tres_columnas');
		$this->calcula_comentarios_items('ultimos');
		
	}
	
	private function calcula_comentarios_items($tipo='slide'){
		$nombre_metodo = $tipo.'_items';
		if (empty($this->$nombre_metodo))
			return false;
		
		e_include('ext_comentarios/class/comentario');
		
		if (!class_exists('Comentario'))
			return false;
			
		foreach ($this->$nombre_metodo as $kitem=>$item){
			$coms = Comentario::getComentarios('ext_shop', 'producto', $item->id);
			if ($coms == false)
				$coms = array();
				
			$this->comentarios[$tipo][$item->id] = $coms;
			
		}
		
	}
	
	function get_paginas(){
		//Si no hay parámetros, salimos
		if (empty($this->total_paginas) || empty($this->pagina) || empty($this->parametros['params']))
			return false;
		
		//Variables locales
		$params = $this->parametros['params'];
		$tam_page = (int) $params['max'];
		$num_pags = $this->total_paginas;
		
		//Calculamos el inicio y final de la sección actual de páginas
		if(!isset($this->pagina)) 
		{ 
			 $this->pagina=1; 
			 $inicio=1; 
			 $final=$tam_page; 
		}else{ 
			 $seccionActual=intval(($this->pagina-1)/$tam_page); 
			 $inicio=($seccionActual*$tam_page)+1; 
	
			 if($this->pagina<$num_pags) 
			 { 
				 $final=$inicio+$tam_page-1; 
			 }else{ 
				 $final=$num_pags; 
			 } 
	
		   if ($final>$num_pags){ 
			  $final=$num_pags; 
			 } 
		}
		
		//Devolvemos los cálculos en una matriz
		return array("total" => $num_pags, "actual" => $this->pagina, "seccion_inicio" => $inicio, "seccion_final" => $final);
	}
	
}