<?php
class Shop extends Controller
{	
	protected $ext_folder = 'ext_shop';
	protected $ext_home_vista = 'home';
	protected $ext_categoria_vista = 'categoria_productos';
	protected $ext_item_vista = 'producto';
	protected $ext_form_item_vista = 'nuevo_producto';
	
	protected $ext_item_modelo = 'ProductoModel';
	protected $ext_categoria_modelo = 'CategoriaProductoModel';
	protected $ext_home_modelo = 'HomeShopModel';
	
	protected $ext_categoria_clase = 'CategoriaProducto';
	protected $ext_item_clase = 'Producto';
	
	var $extra_vistas_categoria=array("categoria_fabricantes"=>"CategoriaProducto");
	var $extra_vistas_items=array("fabricante"=>"FabricanteShop");
	var $extra_vistas_form_item=array("producto"=>"nueva_factura");
	
	var $extra_models=array('fabricante'=>'FabricanteModel','categoria_fabricantes'=>'Categoria_fabricantesModel');	var $producto;
	
	function __construct($pasivo=false){
		parent::__construct($pasivo);
		$this->checkEstadoTienda();
		$fs = new FacturaShop();
		$ids_pedidos = $fs->getIDPedidosFacturados();
		$this->get_config();
		$this->get_reglas_precios();
		$this->get_carrito();
		$this->get_metodo_pago();
		$this->get_formularios();
		$this->get_cliente();
		if (!empty($_POST)){
			$PATH_EXTENSION = CONF_REALPATH_EXTENSIONS.$_GET['extension'];
			include($PATH_EXTENSION.'/tools/redirect_post.php');
		}
		$this->get_envio();
	}
	
	private function checkEstadoTienda(){
		if ($this->config['shop']['tienda_desactivada'] == '1'){
			$txt_desactivada = $this->config['shop']['mensaje_tienda_desactivada'][SistemaIdioma::getIdiomaSesion()];
			if (empty($txt_desactivada))
				$txt_desactivada = __('Tienda desactivada');
					echo $txt_desactivada;
			exit;
		} else {
			return false;
		}
	}
	
	function checkDownload(){
		if ($this->get_vars['descargar'] == '1'){
				$pr_mod = $this->producto;
				$params_pro = Helpers::toArray(json_decode($this->producto->objeto->params));
			$lang = SistemaIdioma::getIdiomaSesion();
				if ($pr_mod->getdownload_link('false') != 'false'){
				if (!empty($params_pro["url_descargable_virtual"][$lang])){
								if ((substr($params_pro["url_descargable_virtual"][$lang], 0, 7) != 'http://' && substr($params_pro["url_descargable_virtual"][$lang], 0, 8) != 'https://') || (strpos($params_pro["url_descargable_virtual"][$lang], CONF_URL_APP))){
										$filename_url = str_replace(CONF_URL_APP, '', $params_pro["url_descargable_virtual"][$lang]);
										$f_arr = explode('/', $filename_url);
						$filename = end($f_arr);
										$pr_mod->objeto->incrementar_descargas(1);						header("Pragma: public");
						header("Expires: 0"); 
						header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
						header("Cache-Control: private",false);
						header("Content-Type: application/download"); 
						header("Content-Disposition: filename=".$filename);
									readfile(CONF_REALPATH_APP.$filename_url);
						exit;
					} else {
						$pr_mod->objeto->incrementar_descargas(1);
						Helpers::redirect($params_pro["url_descargable_virtual"][$lang]);
						exit;
					}
				}
			}
		}
	}
	
	public function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_shop/class/helper','ext_shop/class/producto','ext_shop/class/productoVariacion','ext_shop/class/categoriaProducto','ext_comentarios/class/comentario','ext_shop/class/envio','ext_shop/class/metodoEnvio','ext_shop/class/envio/tarifaPlana','ext_shop/class/envioShop','ext_shop/class/carrito','ext_shop/class/impuestoShop','ext_shop/class/impuestoTarifa','ext_shop/class/checkout','ext_shop/class/cliente','ext_forms/class/formulario','ext_shop/class/pago','ext_shop/class/metodoPago','ext_shop/class/pedidoShop','ext_shop/class/pedidoLineaShop','ext_shop/class/reglaPrecio','ext_shop/class/facturaShop','ext_shop/class/facturaLineaShop','ext_shop/class/fabricante');
		e_include('ext_shop/models/producto','ext_shop/models/categoria','ext_shop/models/home','ext_shop/models/cesta','ext_shop/models/cliente','ext_shop/models/pedido','ext_shop/models/factura','ext_shop/models/reglas','ext_shop/models/fabricante','ext_shop/models/categoria_fabricantes');
		if (!class_exists('Producto') || !class_exists('CategoriaProducto')) {
			App::setMsg(__("Error 500: No se ha encontrado la clase de la extensión."), 'error');
			return false;
		}
	}
	
	public function add_assets(){
		global $AssetBundles;
		if ($AssetBundles instanceof AssetsHelper){
			$AssetBundles->require_bundle('bootbox');
				$shop_bundle = new AssetBundle(array('id'=>'shop', 'nombre'=>'Shop'));
				$shop_bundle->register_css('mideas-shop', CONF_URL_APP.'extensions/ext_shop/assets/mideas_shop/css/mideas_shop.min.css');
			$shop_bundle->register_css('shop', CONF_URL_APP.'extensions/ext_shop/assets/css/shop.css');
				$shop_bundle->register_js('shop-carrito', CONF_URL_APP.'extensions/ext_shop/assets/mideas_shop/js/frontend/add_carrito_var.js');
			$shop_bundle->register_js('shop', CONF_URL_APP.'extensions/ext_shop/assets/js/shop.js');
				$AssetBundles->register_bundle($shop_bundle);
			$AssetBundles->require_bundle('shop');
		}
	}
	
	function get_envio(){
		$this->envio = new Envio();
		$this->envio->init();
	}
	
	function get_metodo_pago(){
		$this->pago = new Pago();
		$this->pago->init();
	}
	
	function get_reglas_precios(){
		$this->reglas_precios = new ReglasPreciosModel();
		$this->reglas_precios->init();
	}
	
	function get_carrito(){
		global $shop;
		global $carrito_shop;
		if (is_object($shop->carrito)){
			$this->carrito = $shop->carrito;
		} elseif (is_object($carrito_shop)){
			$this->carrito = $carrito_shop;
		} else {
			$this->carrito = new Carrito();
			$carrito_shop = $this->carrito;
		}
		$this->carrito->calcular_totales();
	}
	
	function get_cliente(){
		$this->cliente = new ClienteShopModel($this->formularios);
	}
	
	function get_formularios(){
		$this->get_formularios_direcciones();
	}
	
	function get_formularios_direcciones(){
		if (empty($this->config['clientes']['formulario_facturacion']) || empty($this->config['clientes']['formulario_facturacion']))
			return false;
			$formulario_facturacion = new Formulario();
		$formulario_facturacion->setid($this->config['clientes']['formulario_facturacion']);
		if ($formulario_facturacion = $formulario_facturacion->BuscarId()){
		} else {
			return false;
		}
		$formulario_envio = new Formulario();
		$formulario_envio->setid($this->config['clientes']['formulario_envio']);
		if ($formulario_envio = $formulario_envio->BuscarId()){
		} else {
			return false;
		}
		$this->formularios['facturacion'] = $formulario_facturacion;
		$this->formularios['envio'] = $formulario_envio;
		return true;
	}
	
	public function get_params_url_vars($num_url_vars){
		$params = array();
		$params_ext = $GLOBALS["opciones"][$this->ext_folder];
		if ($params_ext['general']['geolocalizacion_en_url'] == '1'){
			switch($num_url_vars){
				case 1:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$_GET['vista'] = 'categoria_fabricantes';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
						}
					} elseif ($_GET['vista'] == 'lista_facturas'){
						$factura = $this->encuentra_factura_por_id($this->url_vars[0]);
						if (!empty($factura)){
							$params['factura'] = $factura;
							$_GET['vista'] = 'factura';
							$_GET['id'] = $factura;
							$_GET['estilo'] = '';
							return $params;
						}
					} elseif ($_GET['vista'] == 'lista_pedidos'){
						$pedido = $this->encuentra_pedido_por_id($this->url_vars[0]);
						if (!empty($pedido)){
							$params['pedido'] = $pedido;
							$_GET['vista'] = 'pedido';
							$_GET['id'] = $pedido;
							$_GET['estilo'] = '';
							return $params;
						}
					}
					break;	
						case 2:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$_GET['vista'] = 'categoria_fabricantes';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								$this->pais_obj = $pais_obj;
							} else {
								break;
							}
						} else {
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
											if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
														$this->pais_obj = $pais_obj;
														$prov_obj = Provincia::BuscarAlias($this->url_vars[1],$this->url_vars[0]);
														if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
																$this->provincia_obj = $prov_obj;
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
					case 3:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
												$_GET['vista'] = 'categoria_fabricantes';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
									$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
												if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
														$this->pais_obj = $pais_obj;
														$prov_obj = Provincia::BuscarAlias($this->url_vars[2],$this->url_vars[1]);
														if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
																$this->provincia_obj = $prov_obj;
								} else {
									break;
								}
							} else {
								break;
							}
						} else {
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
											if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
														$this->pais_obj = $pais_obj;
														$prov_obj = Provincia::BuscarAlias($this->url_vars[1],$this->url_vars[0]);
														if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
																$this->provincia_obj = $prov_obj;
																$loc_obj = Localidad::BuscarAlias($this->url_vars[2], $prov_obj->id);
																if (is_object($loc_obj)){
										$this->get_vars['localidad'] = $loc_obj->getalias();
																		$this->localidad_obj = $loc_obj;
									}
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
					case 4:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$item = $this->encuentra_fabricante_por_nombre($this->url_vars[3],$this->url_vars[2],$this->url_vars[1],$this->url_vars[0]);
						if (!empty($item)){
							$params['album'] = $item;
												$_GET['vista'] = 'album';
							$_GET['id'] = $item;
							$_GET['estilo'] = '';
						}
										$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
												$_GET['vista'] = 'albums';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
												if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
														$this->pais_obj = $pais_obj;
														$prov_obj = Provincia::BuscarAlias($this->url_vars[2],$this->url_vars[1]);
														if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
																$this->provincia_obj = $prov_obj;
																$loc_obj = Localidad::BuscarAlias($this->url_vars[3], $prov_obj->id);
																if (is_object($loc_obj)){
										$this->get_vars['localidad'] = $loc_obj->getalias();
																		$this->localidad_obj = $loc_obj;
									} else {
										break;
									}
								} else {
									break;
								}
							}
						} else {
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
												if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
														$this->pais_obj = $pais_obj;
														$prov_obj = Provincia::BuscarAlias($this->url_vars[1],$this->url_vars[0]);
														if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
																$this->provincia_obj = $prov_obj;
																$loc_obj = Localidad::BuscarAlias($this->url_vars[2], $prov_obj->id);
																if (is_object($loc_obj)){
										$this->get_vars['localidad'] = $loc_obj->getalias();
																		$this->localidad_obj = $loc_obj;
									} else {
										break;
									}
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
				case 5:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if ($subcategoria){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$item = $this->encuentra_fabricante_por_nombre($this->url_vars[4],$this->url_vars[3],$this->url_vars[2],$this->url_vars[1],$subcategoria);
							if (!empty($item)){
								$params['album'] = $item;
														$_GET['vista'] = 'categoria_fabricantes';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						} else {
							break;
						}
								$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
										if (is_object($pais_obj)){
							$this->get_vars['pais'] = $pais_obj->iso2;
												$this->pais_obj = $pais_obj;
												$prov_obj = Provincia::BuscarAlias($this->url_vars[2],$this->url_vars[1]);
												if (is_object($prov_obj)){
								$this->get_vars['provincia'] = $prov_obj->getalias();
														$this->provincia_obj = $prov_obj;
														$loc_obj = Localidad::BuscarAlias($this->url_vars[3], $prov_obj->id);
														if (is_object($loc_obj)){
									$this->get_vars['localidad'] = $loc_obj->getalias();
																$this->localidad_obj = $loc_obj;
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
			}
		} else {
			switch($num_url_vars){
				case 1:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$params['categoria'] = $subcategoria;
							$_GET['vista'] = 'categoria_fabricantes';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
						}
					} elseif ($_GET['vista'] == 'lista_pedidos'){
						$pedido = $this->encuentra_pedido_por_id($this->url_vars[0]);
						if (!empty($pedido)){
							$params['pedido'] = $pedido;
							$_GET['vista'] = 'pedido';
							$_GET['id'] = $pedido;
							$_GET['estilo'] = '';
							return $params;
						}
					}
					elseif ($_GET['vista'] == 'lista_facturas'){
						$factura = $this->encuentra_factura_por_id($this->url_vars[0]);
						if (!empty($factura)){
							$params['factura'] = $factura;
							$_GET['vista'] = 'factura';
							$_GET['id'] = $factura;
							$_GET['estilo'] = '';
							return $params;
						}
					}
					break;
					case 2:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$params['categoria'] = $subcategoria;							$_GET['vista'] = 'categoria_fabricantes';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
						} else {
							$item = $this->encuentra_fabricante_por_nombre_sinloc($this->url_vars[1],$this->url_vars[0]);
							if (!empty($item)){
								$params['fabricante'] = $item;
														$_GET['vista'] = 'fabricante';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						}
					}
					break;
				case 3:
					if ($_GET['vista'] == 'categoria_fabricantes'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
										if ($subcategoria){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$item = $this->encuentra_fabricante_por_nombre_sinloc($this->url_vars[2],$this->url_vars[1], $subcategoria);
							if (!empty($item)){
								$params['fabricante'] = $item;
														$_GET['vista'] = 'fabricante';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						} else {
							echo App::printErrorPage('404', __('La página no existe'));
							exit;
						}
					}
					break;
			}
			}
		if (!is_array($params) || sizeof($params) == 0){
			$params = parent::get_params_url_vars($num_url_vars);
		}
		return $params;
	}
	
	function encuentra_fabricante_por_nombre_sinloc($item='',$id='', $id_cat){
		if (empty($item) || empty($id) || ($_GET['vista'] != 'categoria_fabricantes' || empty($GLOBALS['enlace_actual'])))
			return false;
			if (empty($id_cat))
			$id_cat = $_GET['id'];
			$item_obj = new FabricanteShop();
		$item_obj->setid($id);
		if ($item_obj = $item_obj->BuscarId()){
			$alias = SistemaIdioma::Imprimir($item_obj->alias);
			$cats = (array) json_decode($item_obj->categorias);
				if (!in_array($id_cat, $cats) || $alias != $item){
				return false;
			} else {
				return $item_obj->id;
			}
		} else {
			return false;
		}
	}
	
	function encuentra_fabricante_por_nombre($item='',$localidad='', $provincia='', $pais='', $id_cat){
		if (empty($item) || empty($localidad) || empty($provincia) || empty($pais) || ($_GET['vista'] != 'albums' || empty($GLOBALS['enlace_actual'])))
			return false;
			$categoria = new CategoriaProducto();
		if (empty($id_cat))
			$id_cat = $_GET['id'];
			$categoria->setid($id_cat);
		if ($categoria = $categoria->BuscarId()) {
			$params_cat = $GLOBALS['params_enlace_actual'];
			$items = $categoria->getFabricantes(true,"alias LIKE '%\"".SistemaIdioma::getIdiomaSesion()."\":\"".$item."\"%'",$params_cat['params']['orden'],$params_cat['params']['orden_dir'], 0, 0, SistemaIdioma::getIdiomaSesion(), false, false);
		} else {
			return false;
		}
		$pais_obj = Pais::BuscarPorISO2($pais);
		if (is_object($pais_obj)){
			$prov_obj = Provincia::BuscarAlias($provincia,$pais);
				if (is_object($prov_obj)){
				$loc_obj = Localidad::BuscarAlias($localidad, $prov_obj->id);
			}
		}
		if ($items == false)
			return false;
			foreach ($items as $ite){
			if ($item == SistemaIdioma::Imprimir($ite->alias) && (($ite->localidad == $loc_obj->id && $ite->provincia == $prov_obj->id && $ite->pais == $pais) || (!is_object($loc_obj)))) {
				return $ite->id;
			}
		}
	}
	
	function encuentra_factura_por_id($id_factura){
		if (empty($id_factura) || ($_GET['vista'] != 'lista_facturas'))
			return false;
			$factura = new FacturaShop();
		$factura->setid($id_factura);
		$factura = $factura->BuscarId();
		
		if (!empty($factura->id))
			return $factura->id;
		else
			return false;	}
	
	function encuentra_pedido_por_id($id_pedido){
		if (empty($id_pedido) || ($_GET['vista'] != 'lista_pedidos'))
			return false;
			$pedido = new PedidoShop();
		$pedido->setid($id_pedido);
		$pedido = $pedido->BuscarId();
		if (!empty($pedido->id))
			return $pedido->id;
		else
			return false;	}
	
	function encuentra_producto_por_nombre($producto='',$dia=''){
		if (empty($producto) || ($_GET['vista'] != 'categoria_productos' || empty($GLOBALS['enlace_actual'])))
			return false;
			$categoria = new CategoriaProducto();
		$categoria->setid($_GET['id']);
		if ($categoria = $categoria->BuscarId()) {
			$params_cat = $GLOBALS['params_enlace_actual'];
			$productos = $categoria->getProductos(true,'',$params_cat['params']['orden'],$params_cat['params']['orden_dir']);
		} else {
			return false;
		}
		if ($productos == false)
			return false;
			foreach ($productos as $art){
			if ($producto == SistemaIdioma::Imprimir($art->alias) && (empty($dia) || $dia == strftime('%Y_%m_%d',strtotime($art->fecha)))) {
				return $art->id;
			}
		}
	}
	
	function set_breadcrumbs(){
		$base_link = $this->current_url;
		Helpers::getBreadcrumbs();
		$params_ext = $this->config;
		switch ($_GET['vista']){
			case 'fabricante':
				if ($params_ext["general"]["geolocalizacion_en_url"] == '1' && $params_ext["general"]["geolocalizacion"] == '1'){
								if (is_object($this->pais_obj)){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
										if (is_object($this->provincia_obj)){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
												if (is_object($this->localidad_obj)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
											}
					}
				} elseif ($params_ext["general"]["geolocalizacion"] == '1') {
					if ($this->pais_obj = Pais::BuscarPorISO2($this->get_vars['pais'])){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
										if (is_object($this->provincia_obj)){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
												if (is_object($this->localidad_obj)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
											}
					}
				}
				if (!empty($this->params_url_vars['fabricante'])){
					$item = new FabricanteShop();
					$item->setid($_GET['id']);
					$item = $item->BuscarId();
					$url_item = $item->getLink();
					$this->breadcrumbs[$url_item] = SistemaIdioma::Imprimir($item->titulo);
				}
						break;
					case 'categoria_fabricantes':
				if (!empty($this->params_url_vars['categoria'])){
					$categoria = new CategoriaProducto();
					$categoria->setid($_GET['id']);
					$categoria = $categoria->BuscarId();
					//$url_categoria = $categoria->getLink();
					$url_categoria = $categoria->parent_category_link($_GET['id'], true, 'categoria_fabricantes');
					$this->breadcrumbs[$url_categoria] = SistemaIdioma::Imprimir($categoria->nombre);
				}
				if ($params_ext["general"]["geolocalizacion_en_url"] == '1' && $params_ext["general"]["geolocalizacion"] == '1'){
					if (is_object($this->pais_obj)){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
										if (is_object($this->provincia_obj)){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
												if (is_object($this->localidad_obj)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
											}
					}
				} elseif ($params_ext["general"]["geolocalizacion"] == '1') {
					if ($this->pais_obj = Pais::BuscarPorISO2($this->get_vars['pais'])){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
										if ($this->provincia_obj = Provincia::BuscarAlias($this->get_vars['provincia'], $this->get_vars['pais'])){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
												if ($this->localidad_obj = Localidad::BuscarAlias($this->get_vars['localidad'], $this->provincia_obj->id)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
											}
					}
				}
				break;
					case 'pedido':
				if (!empty($this->params_url_vars['pedido'])){
					$item = new PedidoShop();
					$item->setid($_GET['id']);
					$item = $item->BuscarId();
					$url_item = $item->getLink();
					$this->breadcrumbs[$url_item] = sprintf(__('Pedido #%s'), $item->id);
				}
						break;
						case 'factura':
				if (!empty($this->params_url_vars['factura'])){
					$item = new FacturaShop();
					$item->setid($_GET['id']);
					$item = $item->BuscarId();
					$url_item = $item->getLink();
					$this->breadcrumbs[$url_item] = sprintf(__('Factura #%s'), $item->id);
				}
						break;	
						
		}
		if (!empty($this->breadcrumbs)){
			$GLOBALS['AppDoc']->breadcrumbs = array_merge($GLOBALS['AppDoc']->breadcrumbs, $this->breadcrumbs);
		} else {
			parent::set_breadcrumbs();
		}
	}
}